#include "stdafx.h"
#include "index.h"
#include "AbyssLib.h"

namespace nsAbyssLib{
namespace nsCore{

//RXgN^
NovelEditor::NovelEditor(BaseTextStream* Text){
	Outer = this;
	m_TextStream = Text;
	GETCOMMAND()->SetParent(this);
}
//fXgN^
NovelEditor::~NovelEditor(){
	delete(m_TextStream);
}

//x擾(1)
ISingleHeap* NovelEditor::GetLabel(){
	return(&m_Label);
}
//x擾(2)
const ISingleHeap* NovelEditor::GetLabel() const{
	return(&m_Label);
}
//ϐ擾(1)
ISingleHeap* NovelEditor::GetLocal(){
	return(&m_Local);
}
//ϐ擾(2)
const ISingleHeap* NovelEditor::GetLocal() const{
	return(&m_Local);
}
//Oϐ擾(1)
ISingleHeap* NovelEditor::GetGlobal(){
	return(&m_Global);
}
//Oϐ擾(2)
const ISingleHeap* NovelEditor::GetGlobal() const{
	return(&m_Global);
}
//V{擾(1)
ISingleHeap* NovelEditor::GetSymbolName(){
	return(&m_SymbolName);
}
//V{擾(2)
const ISingleHeap* NovelEditor::GetSymbolName() const{
	return(&m_SymbolName);
}
//߃Xg擾(1)
ICommandHeap* NovelEditor::GetCommand(){
	return(&m_Command);
}
//߃Xg擾(2)
const ICommandHeap* NovelEditor::GetCommand() const{
	return(&m_Command);
}

//eLXgo̓Xg[擾(1)
ITextStream* NovelEditor::GetPrint(){
	if(m_TextStream){
		return(m_TextStream);
	}
	else{
		WARNING
	}
}
//eLXgo̓Xg[擾(2)
const ITextStream* NovelEditor::GetPrint() const{
	if(m_TextStream){
		return(m_TextStream);
	}
	else{
		WARNING
	}
}

//XNvgt@Cۑ
bool NovelEditor::SaveScript(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "wb")){
		return(false);
	}
	char Header[4] = {0};
	Header[0] = '.'; Header[1] = 's'; Header[2] = 'c'; Header[3] = 'r';
	IOStream->SavePrimitive(Header, sizeof(Header));
	GETLABEL()->Save(IOStream);
	GETCOMMAND()->Save(IOStream);
	GETSYMBOLNAME()->Save(IOStream);
	return(IOStream->Close());
}
//XNvgt@Cǂݍ
bool NovelEditor::LoadScript(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='s' && Header[2]=='c' && Header[3]=='r'){
		GETLABEL()->Load(IOStream);
		GETCOMMAND()->Load(IOStream);
		GETSYMBOLNAME()->Load(IOStream);
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
//IuWFNgt@Cۑ
bool NovelEditor::SaveObject(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "wb")){
		return(false);
	}
	char Header[4] = {0};
	Header[0] = '.'; Header[1] = 'o'; Header[2] = 'b'; Header[3] = 'j';
	IOStream->SavePrimitive(Header, sizeof(Header));
	GETLABEL()->Save(IOStream);
	GETCOMMAND()->Save(IOStream);
	GETSYMBOLNAME()->Save(IOStream);
	return(IOStream->Close());
}
//IuWFNgt@Cǂݍ
bool NovelEditor::LoadObject(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='o' && Header[2]=='b' && Header[3]=='j'){
		GETLABEL()->Load(IOStream);
		GETCOMMAND()->Load(IOStream);
		GETSYMBOLNAME()->Load(IOStream);
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}	
}



//RXgN^
NovelPlayer::NovelPlayer(BaseTextStream* Text, BaseInputManager* Input, BaseSoundManager* Sound, BaseDrawManager* Graphic, unsigned int InitFlag){
	Outer = this;
	m_TextStream = Text;
	m_InputManager = Input;
	m_SoundManager = Sound;
	m_DrawManager = Graphic;
	m_Normal = NULL;
	m_BackLog = NULL;
	m_Save = NULL;
	m_Load = NULL;
	m_Config = NULL;
	m_Menu = NULL;

	GETCOMMAND()->SetParent(this);
	GETTASK()->SetParent(this);
	GETDRAW()->SetParent(this);

	m_IOStreamUseInScript = new BaseIOStream;

	SetNormalScene(new DefaultNormalScene);
	SetBackLogScene(new DefaultBackLogScene);
	SetSaveScene(new DefaultSaveScene);
	SetLoadScene(new DefaultLoadScene);
	SetConfigScene(new DefaultConfigScene);
	SetMenuScene(new DefaultMenuScene);

	InitState();
	SetMenu(true);
	m_SystemState = false;
}

//fXgN^
NovelPlayer::~NovelPlayer(){
	delete(m_TextStream);
	delete(m_InputManager);
	GetSound()->StopBGM();
	GETSOUND()->UnloadBGM();
	GetSound()->StopAllSE();
	GetSound()->UnloadAllSE();
	GetSound()->StopAllVoice();
	GetSound()->UnloadAllVoice();
	delete(m_SoundManager);
	GetDraw()->UnloadAllImage();
	delete(m_DrawManager);
}

//
void NovelPlayer::Initialize(){
	GETLOCAL()->Clear();
	for(map<string, int>::iterator it=GETSYMBOLNAME()->GetObj()->begin();it!=GETSYMBOLNAME()->GetObj()->end();){
		if(it->second!=SY_GLOBAL){
			GETSYMBOLNAME()->GetObj()->erase(it);
			it = GETSYMBOLNAME()->GetObj()->begin();
		}
		else{
			it++;
		}
	}
	GETCOMMAND()->Initialize();
	GETTASK()->Initialize();
	GETTEXT()->Initialize();
	GETSOUND()->Initialize();
	GETDRAW()->Initialize();

	InitState();
	SetMenu(true);
	m_SystemState = false;

	m_Normal->Initialize();
	m_BackLog->Initialize();
	m_Save->Initialize();
	m_Load->Initialize();
	m_Config->Initialize();
	m_Menu->Initialize();
}

//x擾(1)
ISingleHeap* NovelPlayer::GetLabel(){
	return(&m_Label);
}
//x擾(2)
const ISingleHeap* NovelPlayer::GetLabel() const{
	return(&m_Label);
}
//ϐ擾(1)
ISingleHeap* NovelPlayer::GetLocal(){
	return(&m_Local);
}
//ϐ擾(2)
const ISingleHeap* NovelPlayer::GetLocal() const{
	return(&m_Local);
}
//Oϐ擾(1)
ISingleHeap* NovelPlayer::GetGlobal(){
	return(&m_Global);
}
//Oϐ擾(2)
const ISingleHeap* NovelPlayer::GetGlobal() const{
	return(&m_Global);
}
//V{擾(1)
ISingleHeap* NovelPlayer::GetSymbolName(){
	return(&m_SymbolName);
}
//V{擾(2)
const ISingleHeap* NovelPlayer::GetSymbolName() const{
	return(&m_SymbolName);
}
//߃Xg擾(1)
ICommandHeap* NovelPlayer::GetCommand(){
	return(&m_Command);
}
//߃Xg擾(2)
const ICommandHeap* NovelPlayer::GetCommand() const{
	return(&m_Command);
}

//`^XN̊Ǘ擾(1)
ITaskManager* NovelPlayer::GetTask(){
	return(&m_DrawTask);
}
//`^XN̊Ǘ擾(2)
const ITaskManager* NovelPlayer::GetTask() const{
	return(&m_DrawTask);
}
//Ǘ̊Ǘ擾(1)
ITextManager* NovelPlayer::GetText(){
	return(&m_ReadRecord);
}
//Ǘ̊Ǘ擾(2)
const ITextManager* NovelPlayer::GetText() const{
	return(&m_ReadRecord);
}

//eLXgo̓Xg[擾(1)
ITextStream* NovelPlayer::GetPrint(){
	if(m_TextStream){
		return(m_TextStream);
	}
	else{
		WARNING
	}
}
//eLXgo̓Xg[擾(2)
const ITextStream* NovelPlayer::GetPrint() const{
	if(m_TextStream){
		return(m_TextStream);
	}
	else{
		WARNING
	}
}
//[U[͗pfoCX擾(1)
IInputManager* NovelPlayer::GetInput(){
	if(m_InputManager){
		return(m_InputManager);
	}
	else{
		WARNING
	}
}
//[U[͗pfoCX擾(2)
const IInputManager* NovelPlayer::GetInput() const{
	if(m_InputManager){
		return(m_InputManager);
	}
	else{
		WARNING
	}
}
//TEhpfoCX擾(1)
ISoundManager* NovelPlayer::GetSound(){
	if(m_SoundManager){
		return(m_SoundManager);
	}
	else{
		WARNING
	}
}
//TEhpfoCX擾(2)
const ISoundManager* NovelPlayer::GetSound() const{
	if(m_SoundManager){
		return(m_SoundManager);
	}
	else{
		WARNING
	}
}
//OtBbNpfoCX擾(1)
IDrawManager* NovelPlayer::GetDraw(){
	if(m_DrawManager){
		return(m_DrawManager);
	}
	else{
		WARNING
	}
}
//OtBbNpfoCX擾(2)
const IDrawManager* NovelPlayer::GetDraw() const{
	if(m_DrawManager){
		return(m_DrawManager);
	}
	else{
		WARNING
	}
}

//sixwȂj
void NovelPlayer::Run(){
	//XNvgǂݍłȂ^CG[
	if(m_ScriptFileName==""){
		RuntimeError(GetMyAppHWND(), "sXNvgt@Cw肳Ă܂I");
	}
	//XNvgɊJnx݂遨Ce[^Zbg
	//XNvgɊJnx݂Ȃ^CG[
	if(GetCommand()->GetIterator()==-1){
		if(GetLabel()->Find("@start")){
			GetCommand()->SetIterator(GetLabel()->Get("@start"));
		}
		else{
			RuntimeError(GetMyAppHWND(), "%sɂ͊Jnx݂܂I", m_ScriptFileName.c_str());
		}
	}
	//s
	//ԑJ
	switch(GetState()){
		case(ST_NORMAL):
			m_Normal->OnBegin();
			m_Normal->OnMove();
			m_Normal->OnDraw();
			m_Normal->OnEnd();
			break;
		case(ST_BACKLOG):
			m_BackLog->OnBegin();
			m_BackLog->OnMove();
			m_BackLog->OnDraw();
			m_BackLog->OnEnd();
			break;
		case(ST_SAVE):
			m_Save->OnBegin();
			m_Save->OnMove();
			m_Save->OnDraw();
			m_Save->OnEnd();
			break;
		case(ST_LOAD):
			m_Load->OnBegin();
			m_Load->OnMove();
			m_Load->OnDraw();
			m_Load->OnEnd();
			break;
		case(ST_CONFIG):
			m_Config->OnBegin();
			m_Config->OnMove();
			m_Config->OnDraw();
			m_Config->OnEnd();
			break;
		case(ST_MENU):
			m_Menu->OnBegin();
			m_Menu->OnMove();
			m_Menu->OnDraw();
			m_Menu->OnEnd();
			break;
		case(ST_SUSPEND):
			_Suspend();
			break;
		case(ST_ENDAPP):
			_EndApp();
			break;
		default:
			WARNING
	}
}
//sixw肠j
void NovelPlayer::Run(const string& LabelName){
	if(GetLabel()->Find(LabelName.c_str())){
		GetCommand()->SetIterator(GetLabel()->Get(LabelName.c_str()));
	}
	else{
		RuntimeError(GetMyAppHWND(), "%s݂͑ȂxłI", LabelName.c_str());
	}
	Run();
}

//ĊJixwȂj
void NovelPlayer::Resume(){
	SetState(ST_NORMAL);
	GETDRAW()->SetText(TextTokenSection());
	GETDRAW()->SetTalker(TextTokenSection());
}
//ĊJixw肠j
void NovelPlayer::Resume(const string& LabelName){
	if(GetLabel()->Find(LabelName.c_str())){
		GetCommand()->SetIterator(GetLabel()->Get(LabelName.c_str()));
	}
	else{
		RuntimeError(GetMyAppHWND(), "%s݂͑ȂxłI", LabelName.c_str());
	}
	Resume();
}

//Ԃ擾
unsigned int NovelPlayer::GetState() const{
	if(m_State.empty()){
		WARNING
	}
	return(m_State.back());
}
//Ԃݒ
void NovelPlayer::SetState(unsigned int State){
	if(m_State.empty()){
		WARNING
	}
	m_State.back() = State;
}
//Ԃ|bv
void NovelPlayer::PopState(){
	if(m_State.empty()){
		WARNING
	}
	m_State.pop_back();
}
//ԂvbV
void NovelPlayer::PushState(unsigned int State){
	m_State.push_back(State);
}
//Ԃ
void NovelPlayer::InitState(){
	m_State.clear();
	PushState(ST_NORMAL);
}

//͎tL
void NovelPlayer::EnableSystem(){
	if(m_SystemState){
		RuntimeError(GetMyAppHWND(), "ɓ͎t͗LĂ܂I");
	}
	m_SystemState = true;
	GETTASK()->LeaveBRCS();
}
//͎t𖳌
void NovelPlayer::DisableSystem(){
	if(!m_SystemState){
		RuntimeError(GetMyAppHWND(), "ɓ͎t͖Ă܂I");
	}
	m_SystemState = false;
	GETTASK()->EnterBRCS();
}
//͎t̗L擾
bool NovelPlayer::GetSystemState() const{
	return(m_SystemState);
}

//j[̗L擾
bool NovelPlayer::GetMenu() const{
	return(m_IsMenu);
}
//j[̗Lݒ
void NovelPlayer::SetMenu(bool IsMenu){
	m_IsMenu = IsMenu;
}

//SEgpĂ邩H
bool NovelPlayer::IsUsedSE(const char* FileName) const{
	return(GetTask()->IsUsedSE(FileName) || GetSound()->IsUsedSE(FileName) || GetDraw()->IsUsedSE(FileName));
}
//BGMgpĂ邩H
bool NovelPlayer::IsUsedBGM(const char* FileName) const{
	return(GetSound()->IsUsedBGM(FileName));
}
//gpĂ邩H
bool NovelPlayer::IsUsedVoice(const char* FileName) const{
	return(GetSound()->IsUsedVoice(FileName));
}
//摜gpĂ邩H
bool NovelPlayer::IsUsedImage(const char* FileName) const{
	return(GetTask()->IsUsedImage(FileName) || GetDraw()->IsUsedImage(FileName));
}

//XNvgt@Cǂݍ
bool NovelPlayer::LoadScript(const string& FileName, IIOStream* IOStream){
	if(m_ScriptFileName!=""){
		RuntimeError(GetMyAppHWND(), "ɃXNvgt@Cǂݍ܂Ă܂I");
	}
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='s' && Header[2]=='c' && Header[3]=='r'){
		GETLABEL()->Load(IOStream);
		GETCOMMAND()->Load(IOStream);
		m_SymbolInfo.Load(IOStream);
		m_ScriptFileName = FileName;
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
//[Jf[^ۑ
bool NovelPlayer::SaveLocalData(const char* FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName, "wb")){
		return(false);
	}
	char Header[4] = {0};
	Header[0] = '.'; Header[1] = 'l'; Header[2] = 's'; Header[3] = 'v';
	IOStream->SavePrimitive(Header, sizeof(Header));
	GETLOCAL()->Save(IOStream);
	GETCOMMAND()->SaveIterator(IOStream);
	GETTASK()->SaveL(IOStream);
	GETTEXT()->SaveL(IOStream);
	GETSOUND()->SaveL(IOStream);
	GETDRAW()->SaveL(IOStream);
	SaveTemplate(IOStream, m_IsMenu);
	for(map<string, SaveLocalDataFunc>::iterator it=PSaveLocalDataFunc.begin();it!=PSaveLocalDataFunc.end();it++){
		SaveStringS(IOStream, it->first);
		it->second(Outer, IOStream);
	}
	return(IOStream->Close());
}
//[Jf[^ǂݍ
bool NovelPlayer::LoadLocalData(const char* FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName, "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='l' && Header[2]=='s' && Header[3]=='v'){
		GETSYMBOLNAME()->Clear();
		GETCOMMAND()->Initialize();
		GETLOCAL()->Load(IOStream);
		GETCOMMAND()->LoadIterator(IOStream);
		GETTASK()->LoadL(IOStream);
		GETTEXT()->LoadL(IOStream);
		GETSOUND()->LoadL(IOStream);
		GETDRAW()->LoadL(IOStream);
		LoadTemplate(IOStream, &m_IsMenu);
		size_t PNum = PLoadLocalDataFunc.size();
		while(PNum>0){
			string PName;
			LoadStringS(IOStream, &PName);
			for(map<string, LoadLocalDataFunc>::iterator it=PLoadLocalDataFunc.begin();it!=PLoadLocalDataFunc.end();it++){
				if(PName==it->first){
					it->second(Outer, IOStream);
				}
			}
			PNum -= 1;
		}
		//ϐ̃V{ǉ
		for(map<string, int>::iterator it=GETLOCAL()->GetObj()->begin();it!=GETLOCAL()->GetObj()->end();it++){
			GetSymbolName()->Set(it->first.c_str(), SY_LOCAL);
		}
		//Oϐ̃V{ǉ
		for(map<string, int>::iterator it=GETGLOBAL()->GetObj()->begin();it!=GETGLOBAL()->GetObj()->end();it++){
			GetSymbolName()->Set(it->first.c_str(), SY_GLOBAL);
		}
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
//O[of[^ۑ
bool NovelPlayer::SaveGlobalData(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "wb")){
		return(false);
	}
	char Header[4] = {0};
	Header[0] = '.'; Header[1] = 'g'; Header[2] = 's'; Header[3] = 'v';
	IOStream->SavePrimitive(Header, sizeof(Header));
	GETGLOBAL()->Save(IOStream);
	return(IOStream->Close());
}
//O[of[^ǂݍ
bool NovelPlayer::LoadGlobalData(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='g' && Header[2]=='s' && Header[3]=='v'){
		GETGLOBAL()->Load(IOStream);
		//Oϐ̃V{ǉ
		for(map<string, int>::iterator it=GETGLOBAL()->GetObj()->begin();it!=GETGLOBAL()->GetObj()->end();it++){
			GetSymbolName()->Set(it->first.c_str(), SY_GLOBAL);
		}
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
//ݒۑ
bool NovelPlayer::SaveEnvironmentData(const string& FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "wb")){
		return(false);
	}
	char Header[4] = {0};
	Header[0] = '.'; Header[1] = 'e'; Header[2] = 'n'; Header[3] = 'v';
	IOStream->SavePrimitive(Header, sizeof(Header));
	SaveTemplate(IOStream, GetDraw()->GetFullScreen());
	GETTEXT()->SaveE(IOStream);
	GETSOUND()->SaveE(IOStream);
	GETDRAW()->SaveE(IOStream);
	for(map<string, SaveEnvironmentDataFunc>::iterator it=PSaveEnvironmentDataFunc.begin();it!=PSaveEnvironmentDataFunc.end();it++){
		SaveStringS(IOStream, it->first);
		it->second(Outer, IOStream);
	}
	return(IOStream->Close());
}
//ݒǂݍ
bool NovelPlayer::LoadEnvironmentData(const string& FileName, bool AllowChangeDisplayMode, IIOStream* IOStream){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='e' && Header[2]=='n' && Header[3]=='v'){
		bool bData;
		LoadTemplate(IOStream, &bData);
		GETTEXT()->LoadE(IOStream);
		GETSOUND()->LoadE(IOStream);
		GETDRAW()->LoadE(IOStream, AllowChangeDisplayMode);
		size_t PNum = PLoadEnvironmentDataFunc.size();
		while(PNum>0){
			string PName;
			LoadStringS(IOStream, &PName);
			for(map<string, LoadEnvironmentDataFunc>::iterator it=PLoadEnvironmentDataFunc.begin();it!=PLoadEnvironmentDataFunc.end();it++){
				if(PName==it->first){
					it->second(Outer, IOStream);
				}
			}
			PNum -= 1;
		}
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
//IuWFNgt@Cǉœǂݍ
bool NovelPlayer::AddLoadObject(const char* FileName, IIOStream* IOStream){
	if(!IOStream->Open(FileName, "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='o' && Header[2]=='b' && Header[3]=='j'){
		SingleHeap LabelChecker;
		CommandHeap CommandChecker;
		SingleHeap SymbolNameChecker;
		CommandChecker.SetParent(this);
		//ǂݍ
		LabelChecker.Load(IOStream);
		CommandChecker.Load(IOStream);
		SymbolNameChecker.Load(IOStream);
		//`FbN
		for(map<string, int>::iterator it=LabelChecker.GetObj()->begin();it!=LabelChecker.GetObj()->end();it++){
			if(GetLabel()->Find(it->first.c_str())){
				if(it->second>=0){
					IOStream->Close();
					return(false);
				}
			}
			else{
				if(it->second<0){
					IOStream->Close();
					return(false);
				}
			}
		}
		for(map<string, int>::iterator it=SymbolNameChecker.GetObj()->begin();it!=SymbolNameChecker.GetObj()->end();it++){
			if(m_SymbolInfo.Find(it->first.c_str())){
				if(abs(m_SymbolInfo.Get(it->first.c_str()))!=abs(it->second)){
					if(m_SymbolInfo.Get(it->first.c_str())!=SY_GLOBAL || it->second!=-SY_LOCAL){
						IOStream->Close();
						return(false);
					}
				}
			}
			else{
				if(it->second<0){
					IOStream->Close();
					return(false);
				}
			}
		}
		//ǉ
		int LabelBaseAddress = static_cast<int>(GETCOMMAND()->GetObj()->size());
		for(map<string, int>::iterator it=LabelChecker.GetObj()->begin();it!=LabelChecker.GetObj()->end();it++){
			if(it->second>=0){
				GetLabel()->Set(it->first.c_str(), it->second+LabelBaseAddress);
			}
		}
		for(vector<ICmd_Base*>::iterator it=CommandChecker.GetObj()->begin();it!=CommandChecker.GetObj()->end();it++){
			GETCOMMAND()->GetObj()->push_back(*it);
		}
		CommandChecker.GetObj()->clear();
		for(map<string, int>::iterator it=SymbolNameChecker.GetObj()->begin();it!=SymbolNameChecker.GetObj()->end();it++){
			if(it->second>=0){
				m_SymbolInfo.Set(it->first.c_str(), it->second);
			}
		}
		if(m_ScriptFileName==""){
			m_ScriptFileName = FileName;
		}
		else{
			m_ScriptFileName += ", ";
			m_ScriptFileName += FileName;
		}
		//㏈
		IOStream->Close();
		return(true);
	}
	else{
		IOStream->Close();
		return(false);
	}
}

//XNvgŎgpf[^o̓NXݒ
void NovelPlayer::SetIOStreamUseInScript(IIOStream* IOStream){
	delete(m_IOStreamUseInScript);
	m_IOStreamUseInScript = IOStream;
}
//XNvgŎgpf[^o̓NX擾
IIOStream* NovelPlayer::GetIOStreamUseInScript() const{
	return(m_IOStreamUseInScript);
}

//V[NXiʏjݒ
void NovelPlayer::SetNormalScene(IScene_Base* Scene){
	delete(m_Normal);
	m_Normal = Scene;
	m_Normal->SetParent(this);
}
//V[NXiǗjݒ
void NovelPlayer::SetBackLogScene(IScene_Base* Scene){
	delete(m_BackLog);
	m_BackLog = Scene;
	m_BackLog->SetParent(this);
}
//V[NXiZ[ujݒ
void NovelPlayer::SetSaveScene(IScene_Base* Scene){
	delete(m_Save);
	m_Save = Scene;
	m_Save->SetParent(this);
}
//V[NXi[hjݒ
void NovelPlayer::SetLoadScene(IScene_Base* Scene){
	delete(m_Load);
	m_Load = Scene;
	m_Load->SetParent(this);
}
//V[NXiݒjݒ
void NovelPlayer::SetConfigScene(IScene_Base* Scene){
	delete(m_Config);
	m_Config = Scene;
	m_Config->SetParent(this);
}
//V[NXij[jݒ
void NovelPlayer::SetMenuScene(IScene_Base* Scene){
	delete(m_Menu);
	m_Menu = Scene;
	m_Menu->SetParent(this);
}



//eݒ̈ꊇۑ/ǂݍ
void SaveSettingsToFile(NovelPlayer* Outer, IIOStream* IOStream, 
						const char* GlobalDataFileName, 
						const char* KidokuDataFileName, 
						const char* EnvironmentDataFileName){
	Outer->SaveGlobalData(GlobalDataFileName, IOStream);
	GETTEXT()->SaveK(KidokuDataFileName, IOStream);
	Outer->SaveEnvironmentData(EnvironmentDataFileName, IOStream);
}
void LoadSettingsFromFile(NovelPlayer* Outer, IIOStream* IOStream, 
						  unsigned int InitFlag, 
						  const char* GlobalDataFileName, 
						  const char* KidokuDataFileName, 
						  const char* EnvironmentDataFileName){
	Outer->LoadGlobalData(GlobalDataFileName, IOStream);
	GETTEXT()->LoadK(KidokuDataFileName, IOStream);
	if(!Outer->LoadEnvironmentData(EnvironmentDataFileName, ((InitFlag & IT_ALLOW_CHANGEDISPLAYMODE)!=0), IOStream)){
		if(InitFlag & IT_ALLOW_CHANGEDISPLAYMODE){
			Outer->GetDraw()->SetFullScreen(DEFAULT_SCREENMODE);
		}
	}
}

}
}