#include "stdafx.h"
#include "index.h"
#include "CMisc.h"

namespace nsAbyssLib{
namespace nsCMisc{

//ftHgRXgN^
mystr::mystr(){
	m_Data = NULL;
	m_Capacity = 0;
	assign("");
}
//Rs[RXgN^(1)
mystr::mystr(const char* Src){
	m_Data = NULL;
	m_Capacity = 0;
	if(Src){
		assign(Src);
	}
	else{
		RuntimeError(NULL, "mystr::mystr(const char* Src)");
	}
}
//Rs[RXgN^(2)
mystr::mystr(const mystr& Src){
	m_Data = NULL;
	m_Capacity = 0;
	assign(Src);
}
//fXgN^
mystr::~mystr(){
	delete[](m_Data);
}

//蓖(1)
void mystr::assign(const char* Src){
	if(Src){
		if(strlen(Src)+1>m_Capacity){
			delete[](m_Data);
			m_Data = new char[strlen(Src)+1];
			m_Capacity = static_cast<unsigned int>(strlen(Src)+1);
		}
		strcpy(m_Data, Src);
	}
	else{
		RuntimeError(NULL, "mystr::assign(const char* Src)");
	}
}
//蓖(2)
void mystr::assign(const mystr& Src){
	assign(Src.c_str());
}

//ANZX
const char* mystr::c_str() const{
	return(m_Data);
}

//TCY擾
unsigned int mystr::size() const{
	return(static_cast<unsigned int>(strlen(m_Data)));
}

//Zq(1)
mystr& mystr::operator =(const char* RHS){
	if(RHS){
		assign(RHS);
		return(*this);
	}
	else{
		RuntimeError(NULL, "mystr::operator =(const char* RHS)");
	}
}
//Zq(2)
mystr& mystr::operator =(const mystr& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		assign(RHS);
		return(*this);
	}
}
//rZq(1)
bool mystr::operator ==(const char* RHS) const{
	if(RHS){
		return(strcmp(m_Data, RHS)==0);
	}
	else{
		RuntimeError(NULL, "mystr::operator ==(const char* RHS)");
	}
}
//rZq(2)
bool mystr::operator ==(const mystr& RHS) const{
	return((*this)==RHS.c_str());
}
//rZq(3)
bool mystr::operator !=(const char* RHS) const{
	if(RHS){
		return(strcmp(m_Data, RHS)!=0);
	}
	else{
		RuntimeError(NULL, "mystr::operator !=(const char* RHS)");
	}
}
//rZq(4)
bool mystr::operator !=(const mystr& RHS) const{
	return((*this)!=RHS.c_str());
}

	
	
//ftHgRXgN^
vector_mystr::vector_mystr(){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
}
//Rs[RXgN^
vector_mystr::vector_mystr(const vector_mystr& Src){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
	for(unsigned int i=0;i<Src.size();i++){
		push_back(Src.at(i));
	}
}
//fXgN^
vector_mystr::~vector_mystr(){
	for(unsigned int i=0;i<m_Capacity;i++){
		delete(m_P[i]);
	}
	delete[](m_P);
}

//
void vector_mystr::clear(){
	for(unsigned int i=0;i<m_Size;i++){
		(*m_P[i]) = "";
	}
	m_Size = 0;
}

//ǉ
void vector_mystr::push_back(const mystr& Src){
	if(m_Capacity==0){
		m_Size = 1;
		m_Capacity = 1;
		m_P = new mystr*[1];
		m_P[0] = new mystr;
		(*m_P[0]) = Src;
	}
	else{
		if(m_Size==m_Capacity){
			mystr** NewP;
			m_Capacity *= 2;
			NewP = new mystr*[m_Capacity];
			for(unsigned int i=0;i<m_Size;i++){
				NewP[i] = m_P[i];
			}
			for(unsigned int i=m_Size;i<m_Capacity;i++){
				NewP[i] = new mystr;
			}
			delete[](m_P);
			m_P = NewP;
		}
		(*m_P[m_Size++]) = Src;
	}
}
//폜
void vector_mystr::pop_back(){
	if(empty()){
		RuntimeError(NULL, "vector_mystr::pop_back()");
	}
	else{
		(*m_P[--m_Size]) = "";
	}
}

//Q(1-1)
mystr& vector_mystr::at(unsigned int Num){
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "vector_mystr::at(unsigned int Num)");
	}
}
//Q(1-2)
const mystr& vector_mystr::at(unsigned int Num) const{
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "vector_mystr::at(unsigned int Num)");
	}
}
//Q(2-1)
mystr& vector_mystr::back(){
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "vector_mystr::back()");
	}
}
//Q(2-2)
const mystr& vector_mystr::back() const{
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "vector_mystr::back()");
	}
}

//󂩁H
bool vector_mystr::empty() const{
	return(m_Size==0);
}
//TCY擾
unsigned int vector_mystr::size() const{
	return(m_Size);
}

//Zq
vector_mystr& vector_mystr::operator =(const vector_mystr& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		clear();
		for(unsigned int i=0;i<RHS.size();i++){
			push_back(RHS.at(i));
		}
		return(*this);
	}
}



//ftHgRXgN^
Expression::Expression(){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
}
//Rs[RXgN^
Expression::Expression(const Expression& Src){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
	for(unsigned int i=0;i<Src.size();i++){
		push_back(Src.at(i));
	}
}
//fXgN^
Expression::~Expression(){
	for(unsigned int i=0;i<m_Capacity;i++){
		delete(m_P[i]);
	}
	delete[](m_P);
}

//
void Expression::clear(){
	for(unsigned int i=0;i<m_Size;i++){
		m_P[i]->Clear();
	}
	m_Size = 0;
}

//ǉ
void Expression::push_back(const Token& Src){
	if(m_Capacity==0){
		m_Size = 1;
		m_Capacity = 1;
		m_P = new Token*[1];
		m_P[0] = new Token;
		(*m_P[0]) = Src;
	}
	else{
		if(m_Size==m_Capacity){
			Token** NewP;
			m_Capacity *= 2;
			NewP = new Token*[m_Capacity];
			for(unsigned int i=0;i<m_Size;i++){
				NewP[i] = m_P[i];
			}
			for(unsigned int i=m_Size;i<m_Capacity;i++){
				NewP[i] = new Token;
			}
			delete[](m_P);
			m_P = NewP;
		}
		(*m_P[m_Size++]) = Src;
	}
}
//폜
void Expression::pop_back(){
	if(empty()){
		RuntimeError(NULL, "Expression::pop_back()");
	}
	else{
		m_P[--m_Size]->Clear();
	}
}

//Q(1-1)
Token& Expression::at(unsigned int Num){
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "Expression::at(unsigned int Num)");
	}
}
//Q(1-2)
const Token& Expression::at(unsigned int Num) const{
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "Expression::at(unsigned int Num)");
	}
}
//Q(2-1)
Token& Expression::back(){
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "Expression::back()");
	}
}
//Q(2-2)
const Token& Expression::back() const{
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "Expression::back()");
	}
}

//󂩁H
bool Expression::empty() const{
	return(m_Size==0);
}
//TCY擾
unsigned int Expression::size() const{
	return(m_Size);
}

//Zq
Expression& Expression::operator =(const Expression& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		clear();
		for(unsigned int i=0;i<RHS.size();i++){
			push_back(RHS.at(i));
		}
		return(*this);
	}
}



//ftHgRXgN^
RubyTextTokenLine::RubyTextTokenLine(){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
}
//Rs[RXgN^
RubyTextTokenLine::RubyTextTokenLine(const RubyTextTokenLine& Src){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
	for(unsigned int i=0;i<Src.size();i++){
		push_back(Src.at(i));
	}
}
//fXgN^
RubyTextTokenLine::~RubyTextTokenLine(){
	for(unsigned int i=0;i<m_Capacity;i++){
		delete(m_P[i]);
	}
	delete[](m_P);
}

//
void RubyTextTokenLine::clear(){
	for(unsigned int i=0;i<m_Size;i++){
		m_P[i]->Clear();
	}
	m_Size = 0;
}

//ǉ
bool RubyTextTokenLine::push_back(const RubyTextToken& Src){
	if(m_Capacity==0){
		m_Size = 1;
		m_Capacity = 1;
		m_P = new RubyTextToken*[1];
		m_P[0] = new RubyTextToken;
		(*m_P[0]) = Src;
		return(true);
	}
	else{
		if(m_Size==m_Capacity){
			RubyTextToken** NewP;
			m_Capacity *= 2;
			NewP = new RubyTextToken*[m_Capacity];
			for(unsigned int i=0;i<m_Size;i++){
				NewP[i] = m_P[i];
			}
			for(unsigned int i=m_Size;i<m_Capacity;i++){
				NewP[i] = new RubyTextToken;
			}
			delete[](m_P);
			m_P = NewP;
		}
		(*m_P[m_Size++]) = Src;
		return(true);
	}
}
//폜
void RubyTextTokenLine::pop_back(){
	if(empty()){
		RuntimeError(NULL, "RubyTextTokenLine::pop_back()");
	}
	else{
		m_P[--m_Size]->Clear();
	}
}

//Q(1-1)
RubyTextToken& RubyTextTokenLine::at(unsigned int Num){
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "RubyTextTokenLine::at(unsigned int Num)");
	}
}
//Q(1-2)
const RubyTextToken& RubyTextTokenLine::at(unsigned int Num) const{
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "RubyTextTokenLine::at(unsigned int Num)");
	}
}
//Q(2-1)
RubyTextToken& RubyTextTokenLine::back(){
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "RubyTextTokenLine::back()");
	}
}
//Q(2-2)
const RubyTextToken& RubyTextTokenLine::back() const{
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "RubyTextTokenLine::back()");
	}
}

//擾
unsigned int RubyTextTokenLine::GetWidth() const{
	unsigned int Width = 0;
	for(unsigned int i=0;i<m_Size;i++){
		Width += m_P[i]->Width;
	}
	return(Width);
}
//c擾
unsigned int RubyTextTokenLine::GetHeight() const{
	unsigned int Height = 0;
	for(unsigned int i=0;i<m_Size;i++){
		if(Height<m_P[i]->Height){
			Height = m_P[i]->Height;
		}
	}
	return(Height);
}

//󂩁H
bool RubyTextTokenLine::empty() const{
	return(m_Size==0);
}
//TCY擾
unsigned int RubyTextTokenLine::size() const{
	return(m_Size);
}

//Zq
RubyTextTokenLine& RubyTextTokenLine::operator =(const RubyTextTokenLine& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		clear();
		for(unsigned int i=0;i<RHS.size();i++){
			push_back(RHS.at(i));
		}
		return(*this);
	}
}
//rZq(1)
bool RubyTextTokenLine::operator ==(const RubyTextTokenLine& RHS) const{
	if(size()!=RHS.size()){
		return(false);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(false);
		}
	}
	return(true);
}
//rZq(2)
bool RubyTextTokenLine::operator !=(const RubyTextTokenLine& RHS) const{
	if(size()!=RHS.size()){
		return(true);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(true);
		}
	}
	return(false);
}



//ftHgRXgN^
TextTokenLine::TextTokenLine(){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
}
//Rs[RXgN^
TextTokenLine::TextTokenLine(const TextTokenLine& Src){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
	for(unsigned int i=0;i<Src.size();i++){
		push_back(Src.at(i), UINT_MAX);
	}
}
//fXgN^
TextTokenLine::~TextTokenLine(){
	for(unsigned int i=0;i<m_Capacity;i++){
		delete(m_P[i]);
	}
	delete[](m_P);
}

//
void TextTokenLine::clear(){
	for(unsigned int i=0;i<m_Size;i++){
		m_P[i]->Clear();
	}
	m_Size = 0;
}

//ǉ
bool TextTokenLine::push_back(const TextToken& Src, unsigned int MaxWidth){
	if(GetWidth()+(Src.Width>Src.Ruby.GetWidth() ? Src.Width : Src.Ruby.GetWidth())>MaxWidth){
		return(false);
	}
	if(m_Capacity==0){
		m_Size = 1;
		m_Capacity = 1;
		m_P = new TextToken*[1];
		m_P[0] = new TextToken;
		(*m_P[0]) = Src;
		return(true);
	}
	else{
		if(m_Size==m_Capacity){
			TextToken** NewP;
			m_Capacity *= 2;
			NewP = new TextToken*[m_Capacity];
			for(unsigned int i=0;i<m_Size;i++){
				NewP[i] = m_P[i];
			}
			for(unsigned int i=m_Size;i<m_Capacity;i++){
				NewP[i] = new TextToken;
			}
			delete[](m_P);
			m_P = NewP;
		}
		(*m_P[m_Size++]) = Src;
		return(true);
	}
}
//폜
void TextTokenLine::pop_back(){
	if(empty()){
		RuntimeError(NULL, "TextTokenLine::pop_back()");
	}
	else{
		m_P[--m_Size]->Clear();
	}
}

//Q(1-1)
TextToken& TextTokenLine::at(unsigned int Num){
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "TextTokenLine::at(unsigned int Num)");
	}
}
//Q(1-2)
const TextToken& TextTokenLine::at(unsigned int Num) const{
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "TextTokenLine::at(unsigned int Num)");
	}
}
//Q(2-1)
TextToken& TextTokenLine::back(){
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "TextTokenLine::back()");
	}
}
//Q(2-2)
const TextToken& TextTokenLine::back() const{
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "TextTokenLine::back()");
	}
}

//擾
unsigned int TextTokenLine::GetWidth() const{
	unsigned int Width = 0;
	for(unsigned int i=0;i<m_Size;i++){
		Width += (m_P[i]->Width>m_P[i]->Ruby.GetWidth() ? m_P[i]->Width : m_P[i]->Ruby.GetWidth());
	}
	return(Width);
}
//c擾
unsigned int TextTokenLine::GetHeight() const{
	unsigned int Height = 0;
	for(unsigned int i=0;i<m_Size;i++){
		if(Height<m_P[i]->Height+m_P[i]->Ruby.GetHeight()){
			Height = m_P[i]->Height + m_P[i]->Ruby.GetHeight();
		}
	}
	return(Height);
}

//󂩁H
bool TextTokenLine::empty() const{
	return(m_Size==0);
}
//TCY擾
unsigned int TextTokenLine::size() const{
	return(m_Size);
}

//Zq
TextTokenLine& TextTokenLine::operator =(const TextTokenLine& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		clear();
		for(unsigned int i=0;i<RHS.size();i++){
			push_back(RHS.at(i), UINT_MAX);
		}
		return(*this);
	}
}
//rZq(1)
bool TextTokenLine::operator ==(const TextTokenLine& RHS) const{
	if(size()!=RHS.size()){
		return(false);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(false);
		}
	}
	return(true);
}
//rZq(2)
bool TextTokenLine::operator !=(const TextTokenLine& RHS) const{
	if(size()!=RHS.size()){
		return(true);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(true);
		}
	}
	return(false);
}



//ftHgRXgN^
TextTokenSection::TextTokenSection(){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
}
//Rs[RXgN^
TextTokenSection::TextTokenSection(const TextTokenSection& Src){
	m_P = NULL;
	m_Size = 0;
	m_Capacity = 0;
	for(unsigned int i=0;i<Src.size();i++){
		push_back(Src.at(i), UINT_MAX, UINT_MAX);
	}
}
//fXgN^
TextTokenSection::~TextTokenSection(){
	for(unsigned int i=0;i<m_Capacity;i++){
		delete(m_P[i]);
	}
	delete[](m_P);
}

//
void TextTokenSection::clear(){
	for(unsigned int i=0;i<m_Size;i++){
		m_P[i]->clear();
	}
	m_Size = 0;
}

//ǉ(s)
bool TextTokenSection::push_back(const TextTokenLine& Src, unsigned int MaxWidth, unsigned int MaxHeight){
	if(Src.GetWidth()>MaxWidth || GetHeight()+Src.GetHeight()>MaxHeight){
		return(false);
	}
	if(m_Capacity==0){
		m_Size = 1;
		m_Capacity = 1;
		m_P = new TextTokenLine*[1];
		m_P[0] = new TextTokenLine;
		(*m_P[0]) = Src;
		return(true);
	}
	else{
		if(m_Size==m_Capacity){
			TextTokenLine** NewP;
			m_Capacity *= 2;
			NewP = new TextTokenLine*[m_Capacity];
			for(unsigned int i=0;i<m_Size;i++){
				NewP[i] = m_P[i];
			}
			for(unsigned int i=m_Size;i<m_Capacity;i++){
				NewP[i] = new TextTokenLine;
			}
			delete[](m_P);
			m_P = NewP;
		}
		(*m_P[m_Size++]) = Src;
		return(true);
	}
}
//폜(s)
void TextTokenSection::pop_back(){
	if(empty()){
		RuntimeError(NULL, "TextTokenSection::pop_back()");
	}
	else{
		m_P[--m_Size]->clear();
	}
}

//Q(1-1)
TextTokenLine& TextTokenSection::at(unsigned int Num){
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "TextTokenSection::at(unsigned int Num)");
	}
}
//Q(1-2)
const TextTokenLine& TextTokenSection::at(unsigned int Num) const{
	if(Num<m_Size){
		return(*m_P[Num]);
	}
	else{
		RuntimeError(NULL, "TextTokenSection::at(unsigned int Num)");
	}
}
//Q(2-1)
TextTokenLine& TextTokenSection::back(){
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "TextTokenSection::back()");
	}
}
//Q(2-2)
const TextTokenLine& TextTokenSection::back() const{
	if(m_Size>0){
		return(*m_P[m_Size-1]);
	}
	else{
		RuntimeError(NULL, "TextTokenSection::back()");
	}
}

//擾
unsigned int TextTokenSection::GetWidth() const{
	unsigned int Width = 0;
	for(unsigned int i=0;i<m_Size;i++){
		if(Width<m_P[i]->GetWidth()){
			Width = m_P[i]->GetWidth();
		}
	}
	return(Width);
}
//c擾
unsigned int TextTokenSection::GetHeight() const{
	unsigned int Height = 0;
	for(unsigned int i=0;i<m_Size;i++){
		Height += m_P[i]->GetHeight();
	}
	return(Height);
}

//󂩁H
bool TextTokenSection::empty() const{
	return(m_Size==0);
}
//TCY擾
unsigned int TextTokenSection::size() const{
	return(m_Size);
}

//Zq
TextTokenSection& TextTokenSection::operator =(const TextTokenSection& RHS){
	if(this==&RHS){
		return(*this);
	}
	else{
		clear();
		for(unsigned int i=0;i<RHS.size();i++){
			push_back(RHS.at(i), UINT_MAX, UINT_MAX);
		}
		return(*this);
	}
}
//rZq(1)
bool TextTokenSection::operator ==(const TextTokenSection& RHS) const{
	if(size()!=RHS.size()){
		return(false);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(false);
		}
	}
	return(true);
}
//rZq(2)
bool TextTokenSection::operator !=(const TextTokenSection& RHS) const{
	if(size()!=RHS.size()){
		return(true);
	}
	for(unsigned int i=0;i<size();i++){
		if(at(i)!=RHS.at(i)){
			return(true);
		}
	}
	return(false);
}

}
}