#include "stdafx.h"
#include "index.h"
#include "Component.h"

namespace nsAbyssLib{
namespace nsComponent{

//ftHgRXgN^
UICBarDraw::UICBarDraw(){
	SetParent(NULL);
	SetDisable(false);
	SetRate(5000);
	SetBorder(1);
	SetPosition(CreateRect(0, 0, 0, 0), CreateRect(0, 0, 0, 0), 0);
	SetSound("", "");
	SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IsCursored = false;
	m_IsPushed = false;
}
//RXgN^
UICBarDraw::UICBarDraw(NovelPlayer* Parent){
	SetParent(Parent);
	SetDisable(false);
	SetRate(5000);
	SetBorder(1);
	SetPosition(CreateRect(0, 0, 0, 0), CreateRect(0, 0, 0, 0), 0);
	SetSound("", "");
	SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IsCursored = false;
	m_IsPushed = false;
}

//eGWݒ
void UICBarDraw::SetParent(NovelPlayer* Parent){
	Outer = Parent;
}

//擾
bool UICBarDraw::GetDisable() const{
	return(m_IsDisable);
}
//ݒ
void UICBarDraw::SetDisable(bool IsDisable){
	m_IsDisable = IsDisable;
}

//擾(0-10000)
unsigned int UICBarDraw::GetRate() const{
	return(m_Rate);
}
//ݒ(0-10000)
void UICBarDraw::SetRate(unsigned int Rate){
	if(Rate>=0 && Rate<=10000){
		m_Rate = Rate;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "UICBarDraw::SetRate(unsigned int Rate)");
	}
}

//gݒ
void UICBarDraw::SetBorder(unsigned int Border){
	m_Border = Border;
}
//Wݒ
void UICBarDraw::SetPosition(RECT Rect, RECT Knob, BYTE a){
	m_Rect = Rect;
	m_Knob = Knob;
	m_a = a;
}
//SEݒ
void UICBarDraw::SetSound(const string& OnCursor, const string& OnClick){
	m_CursorSE = OnCursor;
	m_ClickSE = OnClick;
}
//Fݒ
void UICBarDraw::SetBarColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable){
	m_NColor = Normal;
	m_CColor = OnCursor;
	m_HColor = OnHold;
	m_DColor = Disable;
}
//g̐Fݒ
void UICBarDraw::SetBorderColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable){
	m_BorderNColor = Normal;
	m_BorderCColor = OnCursor;
	m_BorderHColor = OnHold;
	m_BorderDColor = Disable;
}

//`
void UICBarDraw::OnDraw(){
	int X, Y;
	Outer->GetInput()->GetXY(X, Y);
	int KnobX = (m_Rect.right - m_Rect.left) * GetRate() / 10000 + m_Rect.left;
	int KnobY = (m_Rect.bottom - m_Rect.top) / 2 + m_Rect.top;
	if(m_IsDisable){
		//
		GETDRAW()->DrawBorderRect(m_Rect, m_DColor, m_a, m_Border, m_BorderDColor);
		GETDRAW()->DrawBorderRect(CreateRect(KnobX+m_Knob.left, KnobY+m_Knob.top, m_Knob.right-m_Knob.left, m_Knob.bottom-m_Knob.top), m_DColor, m_a, m_Border, m_BorderDColor);
	}
	else{
		if( (X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border)) ||
			(X>=KnobX+m_Knob.left-static_cast<int>(m_Border) && X<=KnobX+m_Knob.right+static_cast<int>(m_Border) && Y>=KnobY+m_Knob.top-static_cast<int>(m_Border) && Y<=KnobY+m_Knob.bottom+static_cast<int>(m_Border))){
			if(Outer->GetInput()->OnHoldUIButton()){
				//z[h
				GETDRAW()->DrawBorderRect(m_Rect, m_HColor, m_a, m_Border, m_BorderHColor);
				GETDRAW()->DrawBorderRect(CreateRect(KnobX+m_Knob.left, KnobY+m_Knob.top, m_Knob.right-m_Knob.left, m_Knob.bottom-m_Knob.top), m_HColor, m_a, m_Border, m_BorderHColor);
			}
			else{
				//J[\
				GETDRAW()->DrawBorderRect(m_Rect, m_CColor, m_a, m_Border, m_BorderCColor);
				GETDRAW()->DrawBorderRect(CreateRect(KnobX+m_Knob.left, KnobY+m_Knob.top, m_Knob.right-m_Knob.left, m_Knob.bottom-m_Knob.top), m_CColor, m_a, m_Border, m_BorderCColor);
			}
		}
		else{
			//ʏ펞
			GETDRAW()->DrawBorderRect(m_Rect, m_NColor, m_a, m_Border, m_BorderNColor);
			GETDRAW()->DrawBorderRect(CreateRect(KnobX+m_Knob.left, KnobY+m_Knob.top, m_Knob.right-m_Knob.left, m_Knob.bottom-m_Knob.top), m_NColor, m_a, m_Border, m_BorderNColor);
		}
	}
}
//m
bool UICBarDraw::OnMove(){
	if(m_IsDisable){
		return(false);
	}
	int X, Y;
	Outer->GetInput()->GetXY(X, Y);
	int KnobX = (m_Rect.right - m_Rect.left) * GetRate() / 10000 + m_Rect.left;
	int KnobY = (m_Rect.bottom - m_Rect.top) / 2 + m_Rect.top;
	if(m_IsCursored){
		m_IsCursored =	(X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border)) ||
						(X>=KnobX+m_Knob.left-static_cast<int>(m_Border) && X<=KnobX+m_Knob.right+static_cast<int>(m_Border) && Y>=KnobY+m_Knob.top-static_cast<int>(m_Border) && Y<=KnobY+m_Knob.bottom+static_cast<int>(m_Border));
	}
	else{
		if(	(X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border)) ||
			(X>=KnobX+m_Knob.left-static_cast<int>(m_Border) && X<=KnobX+m_Knob.right+static_cast<int>(m_Border) && Y>=KnobY+m_Knob.top-static_cast<int>(m_Border) && Y<=KnobY+m_Knob.bottom+static_cast<int>(m_Border))){
			Outer->GetSound()->PlaySE(m_CursorSE.c_str());
			m_IsCursored = true;
		}
	}
	if(m_IsPushed){
		m_IsPushed = (m_IsCursored && Outer->GetInput()->OnHoldUIButton());
		if(m_IsPushed){
			if(X<m_Rect.left){
				SetRate(0);
			}
			else if(X>m_Rect.right){
				SetRate(10000);
			}
			else{
				SetRate((X-m_Rect.left)*10000/(m_Rect.right-m_Rect.left));
			}
		}
		return(m_IsPushed);
	}
	else{
		if(m_IsCursored && Outer->GetInput()->OnPushUIButton()){
			if(X<m_Rect.left){
				SetRate(0);
			}
			else if(X>m_Rect.right){
				SetRate(10000);
			}
			else{
				SetRate((X-m_Rect.left)*10000/(m_Rect.right-m_Rect.left));
			}
			Outer->GetSound()->PlaySE(m_ClickSE.c_str());
			m_IsPushed = true;
		}
		return(m_IsPushed);
	}
}
//ނ擾
int UICBarDraw::GetID() const{
	return(UICOMPONENT_BAR_DRAW);
}

	
	
//ftHgRXgN^
UICButtonDraw::UICButtonDraw(){
	SetParent(NULL);
	SetDisable(false);
	SetBorder(1);
	SetPosition(CreateRect(0, 0, 0, 0), 0);
	SetSound("", "");
	SetText("", "lr SVbN", 20);
	SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IsCursored = false;
	m_IsPushed = false;
}
//RXgN^
UICButtonDraw::UICButtonDraw(NovelPlayer* Parent){
	SetParent(Parent);
	SetDisable(false);
	SetBorder(1);
	SetPosition(CreateRect(0, 0, 0, 0), 0);
	SetSound("", "");
	SetText("", "lr SVbN", 20);
	SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IsCursored = false;
	m_IsPushed = false;
}

//eGWݒ
void UICButtonDraw::SetParent(NovelPlayer* Parent){
	Outer = Parent;
}

//擾
bool UICButtonDraw::GetDisable() const{
	return(m_IsDisable);
}
//ݒ
void UICButtonDraw::SetDisable(bool IsDisable){
	m_IsDisable = IsDisable;
}

//gݒ
void UICButtonDraw::SetBorder(unsigned int Border){
	m_Border = Border;
}
//Wݒ
void UICButtonDraw::SetPosition(RECT Rect, BYTE a){
	m_Rect = Rect;
	m_a = a;
}
//SEݒ
void UICButtonDraw::SetSound(const string& OnCursor, const string& OnClick){
	m_CursorSE = OnCursor;
	m_ClickSE = OnClick;
}
//eLXgݒ
void UICButtonDraw::SetText(const string& Text, const string& Font, unsigned int Size){
	m_Text = Text;
	m_Font = Font;
	m_Size = Size;
}
//eLXg̐Fݒ
void UICButtonDraw::SetTextColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable){
	m_TextNColor = Normal;
	m_TextCColor = OnCursor;
	m_TextHColor = OnHold;
	m_TextDColor = Disable;
}
//Fݒ
void UICButtonDraw::SetButtonColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable){
	m_NColor = Normal;
	m_CColor = OnCursor;
	m_HColor = OnHold;
	m_DColor = Disable;
}
//g̐Fݒ
void UICButtonDraw::SetBorderColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable){
	m_BorderNColor = Normal;
	m_BorderCColor = OnCursor;
	m_BorderHColor = OnHold;
	m_BorderDColor = Disable;
}

//`
void UICButtonDraw::OnDraw(){
	int X, Y;
	Outer->GetInput()->GetXY(X, Y);
	if(m_IsDisable){
		//
		GETDRAW()->DrawBorderRect(m_Rect, m_DColor, m_a, m_Border, m_BorderDColor);
		GETDRAW()->DrawFreeText(m_Text, m_Rect.left+(m_Rect.right-m_Rect.left-m_Size*m_Text.size()/2)/2,
								m_Rect.top+(m_Rect.bottom-m_Rect.top-m_Size)/2, m_a, m_Font, m_Size, m_TextDColor, false, false);
	}
	else{
		if(X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border)){
			if(Outer->GetInput()->OnHoldUIButton()){
				//z[h
				GETDRAW()->DrawBorderRect(m_Rect, m_HColor, m_a, m_Border, m_BorderHColor);
				GETDRAW()->DrawFreeText(m_Text, m_Rect.left+(m_Rect.right-m_Rect.left-m_Size*m_Text.size()/2)/2,
										m_Rect.top+(m_Rect.bottom-m_Rect.top-m_Size)/2, m_a, m_Font, m_Size, m_TextHColor, false, false);
			}
			else{
				//J[\
				GETDRAW()->DrawBorderRect(m_Rect, m_CColor, m_a, m_Border, m_BorderCColor);
				GETDRAW()->DrawFreeText(m_Text, m_Rect.left+(m_Rect.right-m_Rect.left-m_Size*m_Text.size()/2)/2,
										m_Rect.top+(m_Rect.bottom-m_Rect.top-m_Size)/2, m_a, m_Font, m_Size, m_TextCColor, false, false);
			}
		}
		else{
			//ʏ펞
			GETDRAW()->DrawBorderRect(m_Rect, m_NColor, m_a, m_Border, m_BorderNColor);
			GETDRAW()->DrawFreeText(m_Text, m_Rect.left+(m_Rect.right-m_Rect.left-m_Size*m_Text.size()/2)/2,
									m_Rect.top+(m_Rect.bottom-m_Rect.top-m_Size)/2, m_a, m_Font, m_Size, m_TextNColor, false, false);
		}
	}
}
//m
bool UICButtonDraw::OnMove(){
	if(m_IsDisable){
		return(false);
	}
	int X, Y;
	Outer->GetInput()->GetXY(X, Y);
	if(m_IsCursored){
		m_IsCursored = (X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border));
	}
	else{
		if(X>=m_Rect.left-static_cast<int>(m_Border) && X<=m_Rect.right+static_cast<int>(m_Border) && Y>=m_Rect.top-static_cast<int>(m_Border) && Y<=m_Rect.bottom+static_cast<int>(m_Border)){
			Outer->GetSound()->PlaySE(m_CursorSE.c_str());
			m_IsCursored = true;
		}
	}
	if(m_IsPushed){
		m_IsPushed = (m_IsCursored && Outer->GetInput()->OnHoldUIButton());
		return(m_IsCursored && Outer->GetInput()->OnClickUIButton());
	}
	else{
		if(m_IsCursored && Outer->GetInput()->OnPushUIButton()){
			Outer->GetSound()->PlaySE(m_ClickSE.c_str());
			m_IsPushed = true;
		}
		return(false);
	}
}
//ނ擾
int UICButtonDraw::GetID() const{
	return(UICOMPONENT_BUTTON_DRAW);
}

}
}