#include "stdafx.h"
#include "index.h"
#include "DrawManager.h"

namespace nsAbyssLib{
namespace nsDrawManager{

//``FbN
static bool IsValidRect(RECT Rect){
	return(Rect.top<=Rect.bottom && Rect.left<=Rect.right);
}
//``FbNiRŁj
static bool IsValidNNRect(RECT Rect){
	return(Rect.top<=Rect.bottom && Rect.left<=Rect.right && Rect.top>=0 && Rect.left>=0);
}



//ftHgRXgN^
BaseDrawManager::BaseDrawManager(){
	SetTextSpeed(-1);
	SetDefaultTextSpeed(DEFAULT_TEXT_SPEED);
	SetTextWindowShow(true);
	SetTextWindowForceShow(false);
	SetTextWindow(DEFAULT_TEXTWINDOW_POSITION, DEFAULT_TEXTWINDOW_COLOR, DEFAULT_TEXTWINDOW_A, DEFAULT_TEXTWINDOW_BORDER, DEFAULT_TEXTWINDOW_BORDERCOLOR);
	SetRubyFont(DEFAULT_RUBY_FONT);
	SetRubySize(DEFAULT_RUBY_SIZE);
	SetTextPos(DEFAULT_TEXT_X, DEFAULT_TEXT_Y);
	SetTextMaxWidth(DEFAULT_TEXT_MAXWIDTH);
	SetTextMaxHeight(DEFAULT_TEXT_MAXHEIGHT);
	SetTextColor(DEFAULT_TEXT_COLOR);
	SetTextFont(DEFAULT_TEXT_FONT);
	SetTextSize(DEFAULT_TEXT_SIZE);
	SetTalkerPos(DEFAULT_TALKER_X, DEFAULT_TALKER_Y);
	SetTalkerMaxWidth(DEFAULT_TALKER_MAXWIDTH);
	SetTalkerMaxHeight(DEFAULT_TALKER_MAXHEIGHT);
	SetTalkerColor(DEFAULT_TALKER_COLOR);
	SetTalkerFont(DEFAULT_TALKER_FONT);
	SetTalkerSize(DEFAULT_TALKER_SIZE);
	SetTextCursorMode(TEXTCURSOR_NONE);
	SetTextCursorShow(DEFAULT_DRAW_TEXTCURSOR_NONE, DEFAULT_DRAW_TEXTCURSOR_CLICK, DEFAULT_DRAW_TEXTCURSOR_GONEXT, DEFAULT_DRAW_TEXTCURSOR_BACKLOG);
	SetTextCursorNone(DEFAULT_TEXTCURSOR_NONE_FILENAME, DEFAULT_TEXTCURSOR_NONE_X, DEFAULT_TEXTCURSOR_NONE_Y, DEFAULT_TEXTCURSOR_NONE_A, DEFAULT_TEXTCURSOR_NONE_RECT, DEFAULT_TEXTCURSOR_NONE_ABS);
	SetTextCursorClick(DEFAULT_TEXTCURSOR_CLICK_FILENAME, DEFAULT_TEXTCURSOR_CLICK_X, DEFAULT_TEXTCURSOR_CLICK_Y, DEFAULT_TEXTCURSOR_CLICK_A, DEFAULT_TEXTCURSOR_CLICK_RECT, DEFAULT_TEXTCURSOR_CLICK_ABS);
	SetTextCursorGoNext(DEFAULT_TEXTCURSOR_GONEXT_FILENAME, DEFAULT_TEXTCURSOR_GONEXT_X, DEFAULT_TEXTCURSOR_GONEXT_Y, DEFAULT_TEXTCURSOR_GONEXT_A, DEFAULT_TEXTCURSOR_GONEXT_RECT, DEFAULT_TEXTCURSOR_GONEXT_ABS);
	SetTextCursorBackLog(DEFAULT_TEXTCURSOR_BACKLOG_FILENAME, DEFAULT_TEXTCURSOR_BACKLOG_X, DEFAULT_TEXTCURSOR_BACKLOG_Y, DEFAULT_TEXTCURSOR_BACKLOG_A, DEFAULT_TEXTCURSOR_BACKLOG_RECT, DEFAULT_TEXTCURSOR_BACKLOG_ABS);
	SetSelectTextSize(DEFAULT_SELECT_TEXT_SIZE);
	SetSelectTextFont(DEFAULT_SELECT_TEXT_FONT);
	SetSelectTextMaxWidth(DEFAULT_SELECT_TEXT_MAXWIDTH);
	SetSelectTextMaxHeight(DEFAULT_SELECT_TEXT_MAXHEIGHT);
	SetSelectTextNColor(DEFAULT_SELECT_TEXT_NCOLOR);
	SetSelectTextCColor(DEFAULT_SELECT_TEXT_CCOLOR);
	SetSelectTextHColor(DEFAULT_SELECT_TEXT_HCOLOR);
	SetSelectWindowUnderSpace(DEFAULT_SELECTWINDOW_UNDERSPACE);
	SetSelectClickSE(DEFAULT_SELECT_CLICKSE);
	SetSelectCursorSE(DEFAULT_SELECT_CURSORSE);
	SetSelectWindow(DEFAULT_SELECTWINDOW_AROUNDSPACE, DEFAULT_SELECTWINDOW_NCOLOR, DEFAULT_SELECTWINDOW_CCOLOR, DEFAULT_SELECTWINDOW_HCOLOR, DEFAULT_SELECTWINDOW_A, DEFAULT_SELECTWINDOW_BORDER, DEFAULT_SELECTWINDOW_BORDER_NCOLOR, DEFAULT_SELECTWINDOW_BORDER_CCOLOR, DEFAULT_SELECTWINDOW_BORDER_HCOLOR);
	ClearSelect();
	SetClearColor(DEFAULT_BGCOLOR);
	SetPresentClearColor(DEFAULT_BGCOLOR);
}

//
void BaseDrawManager::Initialize(){
	UnloadAllImage();
	SetTextSpeed(-1);
	SetTextWindowShow(true);
	SetTextWindowForceShow(false);
	SetTextWindow(DEFAULT_TEXTWINDOW_POSITION, DEFAULT_TEXTWINDOW_COLOR, DEFAULT_TEXTWINDOW_A, DEFAULT_TEXTWINDOW_BORDER, DEFAULT_TEXTWINDOW_BORDERCOLOR);
	SetRubyFont(DEFAULT_RUBY_FONT);
	SetRubySize(DEFAULT_RUBY_SIZE);
	SetTextPos(DEFAULT_TEXT_X, DEFAULT_TEXT_Y);
	SetTextMaxWidth(DEFAULT_TEXT_MAXWIDTH);
	SetTextMaxHeight(DEFAULT_TEXT_MAXHEIGHT);
	SetTextColor(DEFAULT_TEXT_COLOR);
	SetTextFont(DEFAULT_TEXT_FONT);
	SetTextSize(DEFAULT_TEXT_SIZE);
	SetTalkerPos(DEFAULT_TALKER_X, DEFAULT_TALKER_Y);
	SetTalkerMaxWidth(DEFAULT_TALKER_MAXWIDTH);
	SetTalkerMaxHeight(DEFAULT_TALKER_MAXHEIGHT);
	SetTalkerColor(DEFAULT_TALKER_COLOR);
	SetTalkerFont(DEFAULT_TALKER_FONT);
	SetTalkerSize(DEFAULT_TALKER_SIZE);
	SetText(TextTokenSection());
	SetTalker(TextTokenSection());
	SetTextCursorMode(TEXTCURSOR_NONE);
	SetTextCursorShow(DEFAULT_DRAW_TEXTCURSOR_NONE, DEFAULT_DRAW_TEXTCURSOR_CLICK, DEFAULT_DRAW_TEXTCURSOR_GONEXT, DEFAULT_DRAW_TEXTCURSOR_BACKLOG);
	SetTextCursorNone(DEFAULT_TEXTCURSOR_NONE_FILENAME, DEFAULT_TEXTCURSOR_NONE_X, DEFAULT_TEXTCURSOR_NONE_Y, DEFAULT_TEXTCURSOR_NONE_A, DEFAULT_TEXTCURSOR_NONE_RECT, DEFAULT_TEXTCURSOR_NONE_ABS);
	SetTextCursorClick(DEFAULT_TEXTCURSOR_CLICK_FILENAME, DEFAULT_TEXTCURSOR_CLICK_X, DEFAULT_TEXTCURSOR_CLICK_Y, DEFAULT_TEXTCURSOR_CLICK_A, DEFAULT_TEXTCURSOR_CLICK_RECT, DEFAULT_TEXTCURSOR_CLICK_ABS);
	SetTextCursorGoNext(DEFAULT_TEXTCURSOR_GONEXT_FILENAME, DEFAULT_TEXTCURSOR_GONEXT_X, DEFAULT_TEXTCURSOR_GONEXT_Y, DEFAULT_TEXTCURSOR_GONEXT_A, DEFAULT_TEXTCURSOR_GONEXT_RECT, DEFAULT_TEXTCURSOR_GONEXT_ABS);
	SetTextCursorBackLog(DEFAULT_TEXTCURSOR_BACKLOG_FILENAME, DEFAULT_TEXTCURSOR_BACKLOG_X, DEFAULT_TEXTCURSOR_BACKLOG_Y, DEFAULT_TEXTCURSOR_BACKLOG_A, DEFAULT_TEXTCURSOR_BACKLOG_RECT, DEFAULT_TEXTCURSOR_BACKLOG_ABS);
	SetSelectTextSize(DEFAULT_SELECT_TEXT_SIZE);
	SetSelectTextFont(DEFAULT_SELECT_TEXT_FONT);
	SetSelectTextMaxWidth(DEFAULT_SELECT_TEXT_MAXWIDTH);
	SetSelectTextMaxHeight(DEFAULT_SELECT_TEXT_MAXHEIGHT);
	SetSelectTextNColor(DEFAULT_SELECT_TEXT_NCOLOR);
	SetSelectTextCColor(DEFAULT_SELECT_TEXT_CCOLOR);
	SetSelectTextHColor(DEFAULT_SELECT_TEXT_HCOLOR);
	SetSelectWindowUnderSpace(DEFAULT_SELECTWINDOW_UNDERSPACE);
	SetSelectClickSE(DEFAULT_SELECT_CLICKSE);
	SetSelectCursorSE(DEFAULT_SELECT_CURSORSE);
	SetSelectWindow(DEFAULT_SELECTWINDOW_AROUNDSPACE, DEFAULT_SELECTWINDOW_NCOLOR, DEFAULT_SELECTWINDOW_CCOLOR, DEFAULT_SELECTWINDOW_HCOLOR, DEFAULT_SELECTWINDOW_A, DEFAULT_SELECTWINDOW_BORDER, DEFAULT_SELECTWINDOW_BORDER_NCOLOR, DEFAULT_SELECTWINDOW_BORDER_CCOLOR, DEFAULT_SELECTWINDOW_BORDER_HCOLOR);
	ClearSelect();
	SetClearColor(DEFAULT_BGCOLOR);
	SetPresentClearColor(DEFAULT_BGCOLOR);
}

//eGWݒ
void BaseDrawManager::SetParent(INovelEngine* Parent){
	Outer = Parent;
}

//S摜
bool BaseDrawManager::UnloadAllImage(){
	bool Result = true, Result2;
	vector<string>::iterator it = m_ImageName.begin();
	while(it!=m_ImageName.end()){
		if((Result2=UnloadImage(it->c_str()))!=0){
			it = m_ImageName.begin();
		}
		else{
			it++;
		}
		Result &= Result2;
	}
	return(Result);
}
//摜ɓǂݍ
bool BaseDrawManager::LoadImage(const char* FileName){
	if(!strcmp(FileName, "") || find(m_ImageName.begin(), m_ImageName.end(), FileName)!=m_ImageName.end()){
		return(true);
	}
	if(find(m_ImageName.begin(), m_ImageName.end(), FileName)==m_ImageName.end()){
		m_ImageName.push_back(FileName);
		if(_LoadImage(FileName)){
			return(true);
		}
		m_ImageName.pop_back();
	}
	return(false);
}
//摜
bool BaseDrawManager::UnloadImage(const char* FileName){
	if(!strcmp(FileName, "") || find(m_ImageName.begin(), m_ImageName.end(), FileName)==m_ImageName.end()){
		return(true);
	}
	if(find(m_ImageName.begin(), m_ImageName.end(), FileName)!=m_ImageName.end()){
		if(!_UnloadImage(FileName)){
			return(false);
		}
		m_ImageName.erase(find(m_ImageName.begin(), m_ImageName.end(), FileName));
		return(true);
	}
	return(false);
}

//eLXg̕\x擾
int BaseDrawManager::GetTextSpeed() const{
	if(m_TextSpeed<0){
		return(-1*m_DefaultTextSpeed);
	}
	else{
		return(m_TextSpeed);
	}
}
//eLXg̕\xݒ
void BaseDrawManager::SetTextSpeed(int TextSpeed){
	m_TextSpeed = TextSpeed;
}
//eLXg̕\x擾iftHgj
unsigned int BaseDrawManager::GetDefaultTextSpeed() const{
	return(m_DefaultTextSpeed);
}
//eLXg̕\xݒiftHgj
void BaseDrawManager::SetDefaultTextSpeed(unsigned int DefaultTextSpeed){
	m_DefaultTextSpeed = DefaultTextSpeed;
}

//eLXgEChE̕\Ԃ擾
bool BaseDrawManager::GetTextWindowShow() const{
	return(m_TextWindowIsShow);
}
//eLXgEChE̕\Ԃݒ
void BaseDrawManager::SetTextWindowShow(bool IsShow){
	m_TextWindowIsShow = IsShow;
}
//eLXgEChE̕\ԁi\j擾
bool BaseDrawManager::GetTextWindowForceShow() const{
	return(m_TextWindowIsForceShow);
}
//eLXgEChE̕\ԁi\jݒ
void BaseDrawManager::SetTextWindowForceShow(bool IsForceShow){
	m_TextWindowIsForceShow = IsForceShow;
}
//eLXgEChEݒi摜j
void BaseDrawManager::SetTextWindow(const char* FileName, int x, int y, BYTE a, RECT Image){
	if(IsValidNNRect(Image)){
		m_TextWindowIsUsedImage = true;
		m_TextWindowImageName = FileName;
		m_TextWindowX = x;
		m_TextWindowY = y;
		m_TextWindowA = a;
		m_TextWindowImageSrcRect = Image;
		LoadImage(FileName);
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetTextWindow.SrcRect = {%d, %d, %d, %d}j",
			Image.left, Image.top, Image.right, Image.bottom
		);
	}
}
//eLXgEChEݒi`j
void BaseDrawManager::SetTextWindow(RECT Position, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor){
	if(IsValidRect(Position)){
		m_TextWindowIsUsedImage = false;
		m_TextWindowPosition = Position;
		m_TextWindowColor = Color;
		m_TextWindowA = a;
		m_TextWindowBorder = Border;
		m_TextWindowBorderColor = BorderColor;
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"`̎w肪ԈĂ܂I\niSetTextWindow.Position = {%d, %d, %d, %d}j",
			Position.left, Position.top, Position.right, Position.bottom
		);
	}
}

//r̃tHg擾
const char* BaseDrawManager::GetRubyFont() const{
	return(m_RubyFont.c_str());
}
//r̃tHgݒ
void BaseDrawManager::SetRubyFont(const char* Font){
	m_RubyFont = Font;
}
//r̃TCY擾
unsigned int BaseDrawManager::GetRubySize() const{
	return(m_RubySize);
}
//r̃TCYݒ
void BaseDrawManager::SetRubySize(unsigned int Size){
	m_RubySize = Size;
}
//eLXg̍W擾
void BaseDrawManager::GetTextPos(int& x, int& y) const{
	x = m_TextX;
	y = m_TextY;
}
//eLXg̍Wݒ
void BaseDrawManager::SetTextPos(int x, int y){
	m_TextX = x;
	m_TextY = y;
}
//eLXg̍ő剡擾
unsigned int BaseDrawManager::GetTextMaxWidth() const{
	return(m_TextMaxWidth);
}
//eLXg̍ő剡ݒ
void BaseDrawManager::SetTextMaxWidth(unsigned int Width){
	m_TextMaxWidth = Width;
}
//eLXg̍őc擾
unsigned int BaseDrawManager::GetTextMaxHeight() const{
	return(m_TextMaxHeight);
}
//eLXg̍őcݒ
void BaseDrawManager::SetTextMaxHeight(unsigned int Height){
	m_TextMaxHeight = Height;
}
//eLXg̃J[擾
COLORREF BaseDrawManager::GetTextColor() const{
	return(m_TextColor);
}
//eLXg̃J[ݒ
void BaseDrawManager::SetTextColor(COLORREF Color){
	m_TextColor = Color;
}
//eLXg̃tHg擾
const char* BaseDrawManager::GetTextFont() const{
	return(m_TextFont.c_str());
}
//eLXg̃tHgݒ
void BaseDrawManager::SetTextFont(const char* Font){
	m_TextFont = Font;
}
//eLXg̃TCY擾iptj
unsigned int BaseDrawManager::GetTextSize() const{
	return(m_TextSize);
}
//eLXg̃TCYݒiptj
void BaseDrawManager::SetTextSize(unsigned int Size){
	m_TextSize = Size;
}
//Җ̍W擾
void BaseDrawManager::GetTalkerPos(int& x, int& y) const{
	x = m_TalkerX;
	y = m_TalkerY;
}
//Җ̍Wݒ
void BaseDrawManager::SetTalkerPos(int x, int y){
	m_TalkerX = x;
	m_TalkerY = y;
}
//Җ̍ő剡擾
unsigned int BaseDrawManager::GetTalkerMaxWidth() const{
	return(m_TalkerMaxWidth);
}
//Җ̍ő剡ݒ
void BaseDrawManager::SetTalkerMaxWidth(unsigned int Width){
	m_TalkerMaxWidth = Width;
}
//Җ̍őc擾
unsigned int BaseDrawManager::GetTalkerMaxHeight() const{
	return(m_TalkerMaxHeight);
}
//Җ̍őcݒ
void BaseDrawManager::SetTalkerMaxHeight(unsigned int Height){
	m_TalkerMaxHeight = Height;
}
//Җ̃J[擾
COLORREF BaseDrawManager::GetTalkerColor() const{
	return(m_TalkerColor);
}
//Җ̃J[ݒ
void BaseDrawManager::SetTalkerColor(COLORREF Color){
	m_TalkerColor = Color;
}
//Җ̃tHg擾
const char* BaseDrawManager::GetTalkerFont() const{
	return(m_TalkerFont.c_str());
}
//Җ̃tHgݒ
void BaseDrawManager::SetTalkerFont(const char* Font){
	m_TalkerFont = Font;
}
//Җ̃TCY擾iptj
unsigned int BaseDrawManager::GetTalkerSize() const{
	return(m_TalkerSize);
}
//Җ̃TCYݒiptj
void BaseDrawManager::SetTalkerSize(unsigned int Size){
	m_TalkerSize = Size;
}
//eLXg擾
const TextTokenSection& BaseDrawManager::GetText() const{
	return(m_Text);
}
//eLXgݒ
void BaseDrawManager::SetText(const TextTokenSection& Text){
	m_Text = Text;
}
//Җ擾
const TextTokenSection& BaseDrawManager::GetTalker() const{
	return(m_Talker);
}
//Җݒ
void BaseDrawManager::SetTalker(const TextTokenSection& Talker){
	m_Talker = Talker;
}

//eLXgJ[\̏Ԃݒ
void BaseDrawManager::SetTextCursorMode(unsigned int Mode){
	m_TextCursorMode = Mode;
}
//eLXgJ[\̊e\Ԃݒ
void BaseDrawManager::SetTextCursorShow(bool None, bool Click, bool GoNext, bool BackLog){
	m_TextCursorIsShowN = None;
	m_TextCursorIsShowC = Click;
	m_TextCursorIsShowG = GoNext;
	m_TextCursorIsShowB = BackLog;
}
//eLXgJ[\iʏjݒ
void BaseDrawManager::SetTextCursorNone(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS){
	if(IsValidNNRect(Image)){
		m_TextCursorImageNameN = FileName;
		m_TextCursorXN = x;
		m_TextCursorYN = y;
		m_TextCursorAN = a;
		m_TextCursorImageSrcRectN = Image;
		m_TextCursorIsABSN = IsABS;
		LoadImage(FileName);
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetTextCursorNone.SrcRect = {%d, %d, %d, %d}j",
			Image.left, Image.top, Image.right, Image.bottom
		);
	}
}
//eLXgJ[\iNbN҂jݒ
void BaseDrawManager::SetTextCursorClick(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS){
	if(IsValidNNRect(Image)){
		m_TextCursorImageNameC = FileName;
		m_TextCursorXC = x;
		m_TextCursorYC = y;
		m_TextCursorAC = a;
		m_TextCursorImageSrcRectC = Image;
		m_TextCursorIsABSC = IsABS;
		LoadImage(FileName);
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetTextCursorClick.SrcRect = {%d, %d, %d, %d}j",
			Image.left, Image.top, Image.right, Image.bottom
		);
	}
}
//eLXgJ[\iy[W҂jݒ
void BaseDrawManager::SetTextCursorGoNext(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS){
	if(IsValidNNRect(Image)){
		m_TextCursorImageNameG = FileName;
		m_TextCursorXG = x;
		m_TextCursorYG = y;
		m_TextCursorAG = a;
		m_TextCursorImageSrcRectG = Image;
		m_TextCursorIsABSG = IsABS;
		LoadImage(FileName);
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetTextCursorGoNext.SrcRect = {%d, %d, %d, %d}j",
			Image.left, Image.top, Image.right, Image.bottom
		);
	}
}
//eLXgJ[\iǗjݒ
void BaseDrawManager::SetTextCursorBackLog(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS){
	if(IsValidNNRect(Image)){
		m_TextCursorImageNameB = FileName;
		m_TextCursorXB = x;
		m_TextCursorYB = y;
		m_TextCursorAB = a;
		m_TextCursorImageSrcRectB = Image;
		m_TextCursorIsABSB = IsABS;
		LoadImage(FileName);
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetTextCursorBackLog.SrcRect = {%d, %d, %d, %d}j",
			Image.left, Image.top, Image.right, Image.bottom
		);
	}
}

//ĨeLXg̃TCY擾
unsigned int BaseDrawManager::GetSelectTextSize() const{
	return(m_SelectTextSize);
}
//ĨeLXg̃TCYݒ
void BaseDrawManager::SetSelectTextSize(unsigned int Size){
	m_SelectTextSize = Size;
}
//ĨeLXg̃tHg擾
const char* BaseDrawManager::GetSelectTextFont() const{
	return(m_SelectTextFont.c_str());
}
//ĨeLXg̃tHgݒ
void BaseDrawManager::SetSelectTextFont(const char* Font){
	m_SelectTextFont = Font;
}
//ĨeLXg̍ő剡擾
unsigned int BaseDrawManager::GetSelectTextMaxWidth() const{
	return(m_SelectTextMaxWidth);
}
//ĨeLXg̍ő剡ݒ
void BaseDrawManager::SetSelectTextMaxWidth(unsigned int Width){
	m_SelectTextMaxWidth = Width;
}
//ĨeLXg̍őc擾
unsigned int BaseDrawManager::GetSelectTextMaxHeight() const{
	return(m_SelectTextMaxHeight);
}
//ĨeLXg̍őcݒ
void BaseDrawManager::SetSelectTextMaxHeight(unsigned int Height){
	m_SelectTextMaxHeight = Height;
}
//ĨeLXg̃J[iʏ펞jݒ
void BaseDrawManager::SetSelectTextNColor(COLORREF Color){
	m_SelectTextNColor = Color;
}
//ĨeLXg̃J[iJ[\jݒ
void BaseDrawManager::SetSelectTextCColor(COLORREF Color){
	m_SelectTextCColor = Color;
}
//ĨeLXg̃J[iz[hjݒ
void BaseDrawManager::SetSelectTextHColor(COLORREF Color){
	m_SelectTextHColor = Color;
}
//ĨEChEƉʉ[̊Ԋuݒ
void BaseDrawManager::SetSelectWindowUnderSpace(unsigned int Space){
	m_SelectWindowUnderSpace = Space;
}
//ISEiNbNjݒ
void BaseDrawManager::SetSelectClickSE(const char* FileName){
	m_SelectClickSE = FileName;
}
//ISEiJ[\jݒ
void BaseDrawManager::SetSelectCursorSE(const char* FileName){
	m_SelectCursorSE = FileName;
}
//Iݒi摜j
void BaseDrawManager::SetSelectWindow(const char* FileName, BYTE a, RECT Normal, RECT OnCursor, RECT OnHold){
	if(!IsValidNNRect(Normal)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetSelectWindow[Normal].SrcRect = {%d, %d, %d, %d}j",
			Normal.left, Normal.top, Normal.right, Normal.bottom
		);
	}
	if(!IsValidNNRect(OnCursor)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetSelectWindow[OnCursor].SrcRect = {%d, %d, %d, %d}j",
			OnCursor.left, OnCursor.top, OnCursor.right, OnCursor.bottom
		);
	}
	if(!IsValidNNRect(OnHold)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\niSetSelectWindow[OnHold].SrcRect = {%d, %d, %d, %d}j",
			OnHold.left, OnHold.top, OnHold.right, OnHold.bottom
		);
	}
	m_SelectWindowIsUsedImage = true;
	m_SelectWindowImageName = FileName;
	m_SelectWindowA = a;
	m_SelectWindowImageSrcRectN = Normal;
	m_SelectWindowImageSrcRectC = OnCursor;
	m_SelectWindowImageSrcRectH = OnHold;
	LoadImage(FileName);
}
//Iݒi`j
void BaseDrawManager::SetSelectWindow(unsigned int AroundSpace, COLORREF NColor, COLORREF CColor, COLORREF HColor, BYTE a, unsigned int Border, COLORREF BorderNColor, COLORREF BorderCColor, COLORREF BorderHColor){
	m_SelectWindowIsUsedImage = false;
	m_SelectWindowAroundSpace = AroundSpace;
	m_SelectWindowNColor = NColor;
	m_SelectWindowCColor = CColor;
	m_SelectWindowHColor = HColor;
	m_SelectWindowA = a;
	m_SelectWindowBorder = Border;
	m_SelectWindowBorderNColor = BorderNColor;
	m_SelectWindowBorderCColor = BorderCColor;
	m_SelectWindowBorderHColor = BorderHColor;
}
//ỈԂ𒲂ׂ
bool BaseDrawManager::CheckSelect(){
	if(m_SelectState>-1){
		int X, Y;
		Outer->GetInput()->GetXY(X, Y);
		unsigned int SelectWindowWidth = m_SelectWindowIsUsedImage ? (m_SelectWindowImageSrcRectN.right - m_SelectWindowImageSrcRectN.left) : (GetSelectTextMaxWidth() + m_SelectWindowAroundSpace * 2);
		unsigned int SelectWindowHeight = m_SelectWindowIsUsedImage ? (m_SelectWindowImageSrcRectN.bottom - m_SelectWindowImageSrcRectN.top) : (GetSelectTextMaxHeight() + m_SelectWindowAroundSpace * 2);
		RECT SelectWindow;
		SelectWindow.left = (GetScreenWidth() - SelectWindowWidth) / 2;
		SelectWindow.right = GetScreenWidth() - SelectWindow.left;
		for(unsigned int i=0;i<m_SelectText.size();i++){
			SelectWindow.top = ((GetScreenHeight() - m_SelectWindowUnderSpace - SelectWindowHeight * m_SelectText.size()) / (m_SelectText.size() + 1) * (i + 1)) + (SelectWindowHeight * i);
			SelectWindow.bottom = SelectWindow.top + SelectWindowHeight;
			if(m_SelectIsCursored.at(i)){
				m_SelectIsCursored.at(i) = (X>=SelectWindow.left && X<=SelectWindow.right && Y>=SelectWindow.top && Y<=SelectWindow.bottom);
			}
			else{
				if(X>=SelectWindow.left && X<=SelectWindow.right && Y>=SelectWindow.top && Y<=SelectWindow.bottom){
					Outer->GetSound()->PlaySE(m_SelectCursorSE.c_str());
					m_SelectIsCursored.at(i) = true;
				}
			}
			if(m_SelectIsPushed.at(i)){
				m_SelectIsPushed.at(i) = (m_SelectIsCursored.at(i) && Outer->GetInput()->OnHoldSelect());
				if(m_SelectIsPushed.at(i)){
					//z[hiIԍ+101j
					m_SelectState = i + 101;
					return(false);
				}
				if(m_SelectIsCursored.at(i) && Outer->GetInput()->OnClickSelect()){
					if(Outer->GetLocal()->Find(m_SelectVar.c_str())){
						Outer->GetLocal()->Set(m_SelectVar.c_str(), i+1);
					}
					else if(Outer->GetGlobal()->Find(m_SelectVar.c_str())){
						Outer->GetGlobal()->Set(m_SelectVar.c_str(), i+1);
					}
					else{
						RuntimeError(Outer->GetMyAppHWND(), "%s͌vZs\ȃV{݂܂I", m_SelectVar.c_str());
					}
					//NbNiIԍ+1001j
					m_SelectState = i + 1001;
					return(true);
				}
			}
			else{
				if(m_SelectIsCursored.at(i) && Outer->GetInput()->OnPushSelect()){
					Outer->GetSound()->PlaySE(m_SelectClickSE.c_str());
					m_SelectIsPushed.at(i) = true;
					//z[hiIԍ+101j
					m_SelectState = i + 101;
					return(false);
				}
			}
			if(m_SelectIsCursored.at(i)){
				if(Outer->GetInput()->OnHoldSelect()){
					//z[hiIԍ+101j
					m_SelectState = i + 101;
					return(false);
				}
				//J[\iIԍ+1j
				m_SelectState = i + 1;
				return(false);
			}
		}
		//̑iǂ̑IJ[\炳Ȃꍇj
		m_SelectState = 0;
		return(false);
	}
	return(false);
}
//Iݒ
void BaseDrawManager::SetSelect(const char* Var, unsigned int NumText, const TextTokenSection Text[]){
	m_SelectVar = Var;
	m_SelectState = 0;
	m_SelectText.clear();
	for(unsigned int i=0;i<NumText;i++){
		m_SelectText.push_back(Text[i]);
		m_SelectIsPushed.push_back(false);
		m_SelectIsCursored.push_back(false);
	}
}
//I
void BaseDrawManager::ClearSelect(){
	m_SelectVar = "";
	m_SelectState = -1;
	m_SelectText.clear();
	m_SelectIsPushed.clear();
	m_SelectIsCursored.clear();
}

//ʂ
void BaseDrawManager::Clear(){
	_Clear(m_PresentClearColor);
}
//ʂ̏Fi݁jXV
void BaseDrawManager::UpdateClearColor(){
	m_PresentClearColor = m_ClearColor;
}
//ʂ̏Fiݒj擾
COLORREF BaseDrawManager::GetClearColor() const{
	return(m_ClearColor);
}
//ʂ̏Fiݒjݒ
void BaseDrawManager::SetClearColor(COLORREF Color){
	m_ClearColor = Color;
}
//ʂ̏Fi݁j擾
COLORREF BaseDrawManager::GetPresentClearColor() const{
	return(m_PresentClearColor);
}
//ʂ̏Fi݁jݒ
void BaseDrawManager::SetPresentClearColor(COLORREF Color){
	m_PresentClearColor = Color;
}

//eLXg`(1)
void BaseDrawManager::DrawText(){
	DrawFreeText(m_Text, m_TextX, m_TextY, 255);
}
//eLXg`(2)
void BaseDrawManager::DrawText(COLORREF Color){
	DrawFreeText(m_Text, m_TextX, m_TextY, 255, Color);
}
//Җ`(1)
void BaseDrawManager::DrawTalker(){
	DrawFreeText(m_Talker, m_TalkerX, m_TalkerY, 255);
}
//Җ`(2)
void BaseDrawManager::DrawTalker(COLORREF Color){
	DrawFreeText(m_Talker, m_TalkerX, m_TalkerY, 255, Color);
}
//^XNXg`
void BaseDrawManager::DrawTaskList(){
	for(vector<DrawTask>::iterator it=GETTASK()->GetTaskList().begin();it!=GETTASK()->GetTaskList().end();it++){
		switch(it->Type){
			case(TYPE_NONE):
				break;
			case(TYPE_RECT):
				DrawRect(it->RectPos, it->Color, it->a, it->Degree);
				break;
			case(TYPE_TEXT):
				DrawFreeText(it->Text, it->x, it->y, it->a);
				break;
			case(TYPE_GRAPHIC):
				switch(it->BltType){
					case(BLTTYPE_NML):
						Blt(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					case(BLTTYPE_ADD):
						AddBlt(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					case(BLTTYPE_SUB):
						SubBlt(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					case(BLTTYPE_FAST):
						BltFast(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					case(BLTTYPE_FAST+BLTTYPE_ADD):
						AddBltFast(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					case(BLTTYPE_FAST+BLTTYPE_SUB):
						SubBltFast(it->FileName.c_str(), it->x, it->y, it->a, it->SrcRect, it->ScalingX, it->ScalingY, it->Degree);
						break;
					default:
						if(PBltFunc.find(it->BltType)!=PBltFunc.end()){
							PBltFunc.find(it->Type)->second(Outer, *it);
						}
						else{
							RuntimeError(Outer->GetMyAppHWND(), "݂Ȃ]@łIiBltType = %dj", it->BltType);
						}
				}
				break;
			default:
				if(PDrawTaskFunc.find(it->Type)!=PDrawTaskFunc.end()){
					PDrawTaskFunc.find(it->Type)->second(Outer, *it);
				}
				else{
					RuntimeError(Outer->GetMyAppHWND(), "݂ȂނłIiType = %dj", it->Type);
				}
		}
	}
}
//eLXgEChE`
void BaseDrawManager::DrawTextWindow(){
	if(m_TextWindowIsUsedImage){
		Blt(m_TextWindowImageName, m_TextWindowX, m_TextWindowY, m_TextWindowA, m_TextWindowImageSrcRect);
	}
	else{
		DrawBorderRect(m_TextWindowPosition, m_TextWindowColor, m_TextWindowA, m_TextWindowBorder, m_TextWindowBorderColor);
	}
}
//eLXgJ[\`
void BaseDrawManager::DrawTextCursor(){
	//֐pNX
	class InnerFunction{
	public:
		//eLXgeLXgJ[\̈ʒu擾
		static void GetCursorPos(const TextTokenSection& Text, int& x, int& y){
			x = Text.empty() ? 0 : Text.back().GetWidth();
			y = Text.GetHeight();
		}
	};
	switch(m_TextCursorMode){
		case(TEXTCURSOR_NONE):
			if(m_TextCursorIsShowN){
				if(m_TextCursorIsABSN){
					Blt(m_TextCursorImageNameN, m_TextCursorXN, m_TextCursorYN, m_TextCursorAN, m_TextCursorImageSrcRectN);
				}
				else{
					int x, y;
					InnerFunction::GetCursorPos(m_Text, x, y);
					x += m_TextX + m_TextCursorXN;
					y += m_TextY + m_TextCursorYN;
					Blt(m_TextCursorImageNameN, x, y, m_TextCursorAN, m_TextCursorImageSrcRectN);
				}
			}
			break;
		case(TEXTCURSOR_CLICK):
			if(m_TextCursorIsShowC){
				if(m_TextCursorIsABSC){
					Blt(m_TextCursorImageNameC, m_TextCursorXC, m_TextCursorYC, m_TextCursorAC, m_TextCursorImageSrcRectC);
				}
				else{
					int x, y;
					InnerFunction::GetCursorPos(m_Text, x, y);
					x += m_TextX + m_TextCursorXC;
					y += m_TextY + m_TextCursorYC;
					Blt(m_TextCursorImageNameC, x, y, m_TextCursorAC, m_TextCursorImageSrcRectC);
				}
			}
			break;
		case(TEXTCURSOR_GONEXT):
			if(m_TextCursorIsShowG){
				if(m_TextCursorIsABSG){
					Blt(m_TextCursorImageNameG, m_TextCursorXG, m_TextCursorYG, m_TextCursorAG, m_TextCursorImageSrcRectG);
				}
				else{
					int x, y;
					InnerFunction::GetCursorPos(m_Text, x, y);
					x += m_TextX + m_TextCursorXG;
					y += m_TextY + m_TextCursorYG;
					Blt(m_TextCursorImageNameG, x, y, m_TextCursorAG, m_TextCursorImageSrcRectG);
				}
			}
			break;
		case(TEXTCURSOR_BACKLOG):
			if(m_TextCursorIsShowB){
				if(m_TextCursorIsABSB){
					Blt(m_TextCursorImageNameB, m_TextCursorXB, m_TextCursorYB, m_TextCursorAB, m_TextCursorImageSrcRectB);
				}
				else{
					int x, y;
					InnerFunction::GetCursorPos(m_Text, x, y);
					x += m_TextX + m_TextCursorXB;
					y += m_TextY + m_TextCursorYB;
					Blt(m_TextCursorImageNameB, x, y, m_TextCursorAB, m_TextCursorImageSrcRectB);
				}
			}
			break;
	}
}
//I`
void BaseDrawManager::DrawSelect(){
	if(m_SelectState>-1){
		unsigned int SelectWindowWidth = m_SelectWindowIsUsedImage ? (m_SelectWindowImageSrcRectN.right - m_SelectWindowImageSrcRectN.left) : (GetSelectTextMaxWidth() + m_SelectWindowAroundSpace * 2);
		unsigned int SelectWindowHeight = m_SelectWindowIsUsedImage ? (m_SelectWindowImageSrcRectN.bottom - m_SelectWindowImageSrcRectN.top) : (GetSelectTextMaxHeight() + m_SelectWindowAroundSpace * 2);
		RECT SelectWindow;
		SelectWindow.left = (GetScreenWidth() - SelectWindowWidth) / 2;
		SelectWindow.right = GetScreenWidth() - SelectWindow.left;
		for(unsigned int i=0;i<m_SelectText.size();i++){
			SelectWindow.top = ((GetScreenHeight() - m_SelectWindowUnderSpace - SelectWindowHeight * m_SelectText.size()) / (m_SelectText.size() + 1) * (i + 1)) + (SelectWindowHeight * i);
			SelectWindow.bottom = SelectWindow.top + SelectWindowHeight;
			if(i+1==static_cast<unsigned int>(m_SelectState%100)){
				if(m_SelectState>100 && m_SelectState<1000){
					//z[h
					if(m_SelectWindowIsUsedImage){
						Blt(m_SelectWindowImageName, SelectWindow.left, SelectWindow.top, m_SelectWindowA, m_SelectWindowImageSrcRectH);
					}
					else{
						DrawBorderRect(SelectWindow, m_SelectWindowHColor, m_SelectWindowA, m_SelectWindowBorder, m_SelectWindowBorderHColor);
					}
					DrawFreeText(m_SelectText.at(i), static_cast<int>(SelectWindow.left+(SelectWindow.right-SelectWindow.left-m_SelectText.at(i).GetWidth())/2),
								static_cast<int>(SelectWindow.top+(SelectWindow.bottom-SelectWindow.top-m_SelectText.at(i).GetHeight())/2), 255, m_SelectTextHColor);
				}
				else{
					//J[\
					if(m_SelectWindowIsUsedImage){
						Blt(m_SelectWindowImageName, SelectWindow.left, SelectWindow.top, m_SelectWindowA, m_SelectWindowImageSrcRectC);
					}
					else{
						DrawBorderRect(SelectWindow, m_SelectWindowCColor, m_SelectWindowA, m_SelectWindowBorder, m_SelectWindowBorderCColor);
					}
					DrawFreeText(m_SelectText.at(i), static_cast<int>(SelectWindow.left+(SelectWindow.right-SelectWindow.left-m_SelectText.at(i).GetWidth())/2),
								static_cast<int>(SelectWindow.top+(SelectWindow.bottom-SelectWindow.top-m_SelectText.at(i).GetHeight())/2), 255, m_SelectTextCColor);
				}
			}
			else{
				//ʏ펞
				if(m_SelectWindowIsUsedImage){
					Blt(m_SelectWindowImageName, SelectWindow.left, SelectWindow.top, m_SelectWindowA, m_SelectWindowImageSrcRectN);
				}
				else{
					DrawBorderRect(SelectWindow, m_SelectWindowNColor, m_SelectWindowA, m_SelectWindowBorder, m_SelectWindowBorderNColor);
				}
				DrawFreeText(m_SelectText.at(i), static_cast<int>(SelectWindow.left+(SelectWindow.right-SelectWindow.left-m_SelectText.at(i).GetWidth())/2),
							static_cast<int>(SelectWindow.top+(SelectWindow.bottom-SelectWindow.top-m_SelectText.at(i).GetHeight())/2), 255, m_SelectTextNColor);
			}
		}
	}
}

//ʏ]iFj
void BaseDrawManager::Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_Blt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}
//F]iFj
void BaseDrawManager::AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_AddBlt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}
//F]iFj
void BaseDrawManager::SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_SubBlt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}
//ʏ]iFȂj
void BaseDrawManager::BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_BltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}
//F]iFȂj
void BaseDrawManager::AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_AddBltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}
//F]iFȂj
void BaseDrawManager::SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(FileName!="" && a!=0 && IsValidNNRect(SrcRect)){
		_SubBltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
	}
}

//`(1)
void BaseDrawManager::DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a){
	if(!Text.empty() && a!=0){
		int dx = 0, dy = 0, drx = 0, dry = 0;
		for(unsigned int i=0;i<Text.size();i++){
			dx = 0;
			dy += Text.at(i).GetHeight();
			for(unsigned int j=0;j<Text.at(i).size();j++){
				const TextToken& Ref = Text.at(i).at(j);
				unsigned int TextWidth = Ref.Width;
				unsigned int RubyWidth = Ref.Ruby.GetWidth();
				DrawFreeText(Ref.Text.c_str(), x+dx+(TextWidth>=RubyWidth ? 0 : (RubyWidth-TextWidth)/2), y+dy-Ref.Height, 
							 static_cast<BYTE>(static_cast<int>(Ref.a)*static_cast<int>(a)/255), Ref.Font.c_str(), Ref.Size, Ref.Color, Ref.IsBold, Ref.IsItalic, Ref.Degree);
				drx = dx + (RubyWidth>=TextWidth ? 0 : (TextWidth-RubyWidth)/2);
				dry = dy - Ref.Height;
				for(unsigned int k=0;k<Ref.Ruby.size();k++){
					const RubyTextToken& RefR = Ref.Ruby.at(k);
					DrawFreeText(RefR.Text.c_str(), x+drx, y+dry-RefR.Height, 
								 static_cast<BYTE>(static_cast<int>(RefR.a)*static_cast<int>(a)/255), RefR.Font.c_str(), RefR.Size, RefR.Color, RefR.IsBold, RefR.IsItalic, RefR.Degree);
					drx += RefR.Width;
				}
				dx += (TextWidth>=RubyWidth ? TextWidth : RubyWidth);
			}
		}
	}
}
//`(2)
void BaseDrawManager::DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a, COLORREF Color){
	if(!Text.empty() && a!=0){
		int dx = 0, dy = 0, drx = 0, dry = 0;
		for(unsigned int i=0;i<Text.size();i++){
			dx = 0;
			dy += Text.at(i).GetHeight();
			for(unsigned int j=0;j<Text.at(i).size();j++){
				const TextToken& Ref = Text.at(i).at(j);
				unsigned int TextWidth = Ref.Width;
				unsigned int RubyWidth = Ref.Ruby.GetWidth();
				DrawFreeText(Ref.Text.c_str(), x+dx+(TextWidth>=RubyWidth ? 0 : (RubyWidth-TextWidth)/2), y+dy-Ref.Height, 
							 static_cast<BYTE>(static_cast<int>(Ref.a)*static_cast<int>(a)/255), Ref.Font.c_str(), Ref.Size, Color, Ref.IsBold, Ref.IsItalic, Ref.Degree);
				drx = dx + (RubyWidth>=TextWidth ? 0 : (TextWidth-RubyWidth)/2);
				dry = dy - Ref.Height;
				for(unsigned int k=0;k<Ref.Ruby.size();k++){
					const RubyTextToken& RefR = Ref.Ruby.at(k);
					DrawFreeText(RefR.Text.c_str(), x+drx, y+dry-RefR.Height, 
								 static_cast<BYTE>(static_cast<int>(RefR.a)*static_cast<int>(a)/255), RefR.Font.c_str(), RefR.Size, Color, RefR.IsBold, RefR.IsItalic, RefR.Degree);
					drx += RefR.Width;
				}
				dx += (TextWidth>=RubyWidth ? TextWidth : RubyWidth);
			}
		}
	}
}
//`(3)
void BaseDrawManager::DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree){
	if(Text!="" && a!=0){
		_DrawFreeText(Text, x, y, a, Font, Size, Color, IsBold, IsItalic, Degree);
	}
}

//``
void BaseDrawManager::DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree){
	if(a!=0 && IsValidRect(Rect)){
		_DrawRect(Rect, Color, a, Degree);
	}
}
//t``
void BaseDrawManager::DrawBorderRect(RECT Rect, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor){
	DrawRect(Rect, Color, a);
	if(Border>0){
		DrawRect(CreateRect(Rect.left, Rect.top-Border, Rect.right-Rect.left+Border, Border), BorderColor, a);
		DrawRect(CreateRect(Rect.right, Rect.top, Border, Rect.bottom-Rect.top+Border), BorderColor, a);
		DrawRect(CreateRect(Rect.left-Border, Rect.bottom, Rect.right-Rect.left+Border, Border), BorderColor, a);
		DrawRect(CreateRect(Rect.left-Border, Rect.top-Border, Border, Rect.bottom-Rect.top+Border), BorderColor, a);
	}
}

//ۑiݒj
void BaseDrawManager::SaveE(IIOStream* IOStream){
	SaveTemplate(IOStream, GetFullScreen());
	SaveTemplate(IOStream, m_DefaultTextSpeed);
}
//ǂݍ݁iݒj
void BaseDrawManager::LoadE(IIOStream* IOStream, bool AllowChangeDisplayMode){
	bool bData;
	LoadTemplate(IOStream, &bData);
	if(AllowChangeDisplayMode){
		SetFullScreen(bData);
	}
	LoadTemplate(IOStream, &m_DefaultTextSpeed);
}
//ۑi[Jj
void BaseDrawManager::SaveL(IIOStream* IOStream){
	SaveTemplate(IOStream, m_TextSpeed);
	SaveTemplate(IOStream, m_TextWindowIsShow);
	SaveTemplate(IOStream, m_TextWindowIsUsedImage);
	SaveTemplate(IOStream, m_TextWindowA);
	SaveStringS(IOStream, m_TextWindowImageName);
	SaveTemplate(IOStream, m_TextWindowX);
	SaveTemplate(IOStream, m_TextWindowY);
	SaveTemplate(IOStream, m_TextWindowImageSrcRect.left);
	SaveTemplate(IOStream, m_TextWindowImageSrcRect.top);
	SaveTemplate(IOStream, m_TextWindowImageSrcRect.right);
	SaveTemplate(IOStream, m_TextWindowImageSrcRect.bottom);
	SaveTemplate(IOStream, m_TextWindowPosition.left);
	SaveTemplate(IOStream, m_TextWindowPosition.top);
	SaveTemplate(IOStream, m_TextWindowPosition.right);
	SaveTemplate(IOStream, m_TextWindowPosition.bottom);
	SaveTemplate(IOStream, m_TextWindowColor);
	SaveTemplate(IOStream, m_TextWindowBorderColor);
	SaveTemplate(IOStream, m_TextWindowBorder);
	SaveStringS(IOStream, m_RubyFont);
	SaveTemplate(IOStream, m_RubySize);
	SaveTemplate(IOStream, m_TextX);
	SaveTemplate(IOStream, m_TextY);
	SaveTemplate(IOStream, m_TalkerX);
	SaveTemplate(IOStream, m_TalkerY);
	SaveTemplate(IOStream, m_TextMaxWidth);
	SaveTemplate(IOStream, m_TextMaxHeight);
	SaveTemplate(IOStream, m_TalkerMaxWidth);
	SaveTemplate(IOStream, m_TalkerMaxHeight);
	SaveTemplate(IOStream, m_TextColor);
	SaveTemplate(IOStream, m_TalkerColor);
	SaveStringS(IOStream, m_TextFont);
	SaveStringS(IOStream, m_TalkerFont);
	SaveTemplate(IOStream, m_TextSize);
	SaveTemplate(IOStream, m_TalkerSize);
	IOStream->SaveTextTokenSection(m_Text);
	IOStream->SaveTextTokenSection(m_Talker);
	SaveTemplate(IOStream, m_TextCursorMode);
	SaveTemplate(IOStream, m_TextCursorIsShowN);
	SaveTemplate(IOStream, m_TextCursorIsShowC);
	SaveTemplate(IOStream, m_TextCursorIsShowG);
	SaveTemplate(IOStream, m_TextCursorIsShowB);
	SaveStringS(IOStream, m_TextCursorImageNameN);
	SaveStringS(IOStream, m_TextCursorImageNameC);
	SaveStringS(IOStream, m_TextCursorImageNameG);
	SaveStringS(IOStream, m_TextCursorImageNameB);
	SaveTemplate(IOStream, m_TextCursorXN);
	SaveTemplate(IOStream, m_TextCursorXC);
	SaveTemplate(IOStream, m_TextCursorXG);
	SaveTemplate(IOStream, m_TextCursorXB);
	SaveTemplate(IOStream, m_TextCursorYN);
	SaveTemplate(IOStream, m_TextCursorYC);
	SaveTemplate(IOStream, m_TextCursorYG);
	SaveTemplate(IOStream, m_TextCursorYB);
	SaveTemplate(IOStream, m_TextCursorAN);
	SaveTemplate(IOStream, m_TextCursorAC);
	SaveTemplate(IOStream, m_TextCursorAG);
	SaveTemplate(IOStream, m_TextCursorAB);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectN.left);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectN.top);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectN.right);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectN.bottom);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectC.left);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectC.top);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectC.right);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectC.bottom);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectG.left);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectG.top);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectG.right);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectG.bottom);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectB.left);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectB.top);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectB.right);
	SaveTemplate(IOStream, m_TextCursorImageSrcRectB.bottom);
	SaveTemplate(IOStream, m_TextCursorIsABSN);
	SaveTemplate(IOStream, m_TextCursorIsABSC);
	SaveTemplate(IOStream, m_TextCursorIsABSG);
	SaveTemplate(IOStream, m_TextCursorIsABSB);
	SaveTemplate(IOStream, m_SelectState);
	SaveStringS(IOStream, m_SelectVar);
	SaveTemplate(IOStream, static_cast<int>(m_SelectText.size()));
	for(vector<TextTokenSection>::iterator it=m_SelectText.begin();it!=m_SelectText.end();it++){
		IOStream->SaveTextTokenSection(*it);
	}
	SaveTemplate(IOStream, m_SelectTextSize);
	SaveStringS(IOStream, m_SelectTextFont);
	SaveTemplate(IOStream, m_SelectTextMaxWidth);
	SaveTemplate(IOStream, m_SelectTextMaxHeight);
	SaveTemplate(IOStream, m_SelectTextNColor);
	SaveTemplate(IOStream, m_SelectTextCColor);
	SaveTemplate(IOStream, m_SelectTextHColor);
	SaveTemplate(IOStream, m_SelectWindowUnderSpace);
	SaveStringS(IOStream, m_SelectClickSE);
	SaveStringS(IOStream, m_SelectCursorSE);
	SaveTemplate(IOStream, m_SelectWindowIsUsedImage);
	SaveTemplate(IOStream, m_SelectWindowA);
	SaveStringS(IOStream, m_SelectWindowImageName);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectN.left);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectN.top);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectN.right);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectN.bottom);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectC.left);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectC.top);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectC.right);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectC.bottom);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectH.left);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectH.top);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectH.right);
	SaveTemplate(IOStream, m_SelectWindowImageSrcRectH.bottom);
	SaveTemplate(IOStream, m_SelectWindowAroundSpace);
	SaveTemplate(IOStream, m_SelectWindowNColor);
	SaveTemplate(IOStream, m_SelectWindowCColor);
	SaveTemplate(IOStream, m_SelectWindowHColor);
	SaveTemplate(IOStream, m_SelectWindowBorder);
	SaveTemplate(IOStream, m_SelectWindowBorderNColor);
	SaveTemplate(IOStream, m_SelectWindowBorderCColor);
	SaveTemplate(IOStream, m_SelectWindowBorderHColor);
	SaveTemplate(IOStream, m_ClearColor);
	SaveTemplate(IOStream, m_PresentClearColor);
}
//ǂݍ݁i[Jj
void BaseDrawManager::LoadL(IIOStream* IOStream){
	int Loop;
	LoadTemplate(IOStream, &m_TextSpeed);
	LoadTemplate(IOStream, &m_TextWindowIsShow);
	LoadTemplate(IOStream, &m_TextWindowIsUsedImage);
	LoadTemplate(IOStream, &m_TextWindowA);
	LoadStringS(IOStream, &m_TextWindowImageName);
	LoadImage(m_TextWindowImageName.c_str());
	LoadTemplate(IOStream, &m_TextWindowX);
	LoadTemplate(IOStream, &m_TextWindowY);
	LoadTemplate(IOStream, &m_TextWindowImageSrcRect.left);
	LoadTemplate(IOStream, &m_TextWindowImageSrcRect.top);
	LoadTemplate(IOStream, &m_TextWindowImageSrcRect.right);
	LoadTemplate(IOStream, &m_TextWindowImageSrcRect.bottom);
	LoadTemplate(IOStream, &m_TextWindowPosition.left);
	LoadTemplate(IOStream, &m_TextWindowPosition.top);
	LoadTemplate(IOStream, &m_TextWindowPosition.right);
	LoadTemplate(IOStream, &m_TextWindowPosition.bottom);
	LoadTemplate(IOStream, &m_TextWindowColor);
	LoadTemplate(IOStream, &m_TextWindowBorderColor);
	LoadTemplate(IOStream, &m_TextWindowBorder);
	LoadStringS(IOStream, &m_RubyFont);
	LoadTemplate(IOStream, &m_RubySize);
	LoadTemplate(IOStream, &m_TextX);
	LoadTemplate(IOStream, &m_TextY);
	LoadTemplate(IOStream, &m_TalkerX);
	LoadTemplate(IOStream, &m_TalkerY);
	LoadTemplate(IOStream, &m_TextMaxWidth);
	LoadTemplate(IOStream, &m_TextMaxHeight);
	LoadTemplate(IOStream, &m_TalkerMaxWidth);
	LoadTemplate(IOStream, &m_TalkerMaxHeight);
	LoadTemplate(IOStream, &m_TextColor);
	LoadTemplate(IOStream, &m_TalkerColor);
	LoadStringS(IOStream, &m_TextFont);
	LoadStringS(IOStream, &m_TalkerFont);
	LoadTemplate(IOStream, &m_TextSize);
	LoadTemplate(IOStream, &m_TalkerSize);
	IOStream->LoadTextTokenSection(&m_Text);
	IOStream->LoadTextTokenSection(&m_Talker);
	LoadTemplate(IOStream, &m_TextCursorMode);
	LoadTemplate(IOStream, &m_TextCursorIsShowN);
	LoadTemplate(IOStream, &m_TextCursorIsShowC);
	LoadTemplate(IOStream, &m_TextCursorIsShowG);
	LoadTemplate(IOStream, &m_TextCursorIsShowB);
	LoadStringS(IOStream, &m_TextCursorImageNameN);
	LoadImage(m_TextCursorImageNameN.c_str());
	LoadStringS(IOStream, &m_TextCursorImageNameC);
	LoadImage(m_TextCursorImageNameC.c_str());
	LoadStringS(IOStream, &m_TextCursorImageNameG);
	LoadImage(m_TextCursorImageNameG.c_str());
	LoadStringS(IOStream, &m_TextCursorImageNameB);
	LoadImage(m_TextCursorImageNameB.c_str());
	LoadTemplate(IOStream, &m_TextCursorXN);
	LoadTemplate(IOStream, &m_TextCursorXC);
	LoadTemplate(IOStream, &m_TextCursorXG);
	LoadTemplate(IOStream, &m_TextCursorXB);
	LoadTemplate(IOStream, &m_TextCursorYN);
	LoadTemplate(IOStream, &m_TextCursorYC);
	LoadTemplate(IOStream, &m_TextCursorYG);
	LoadTemplate(IOStream, &m_TextCursorYB);
	LoadTemplate(IOStream, &m_TextCursorAN);
	LoadTemplate(IOStream, &m_TextCursorAC);
	LoadTemplate(IOStream, &m_TextCursorAG);
	LoadTemplate(IOStream, &m_TextCursorAB);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectN.left);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectN.top);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectN.right);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectN.bottom);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectC.left);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectC.top);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectC.right);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectC.bottom);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectG.left);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectG.top);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectG.right);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectG.bottom);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectB.left);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectB.top);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectB.right);
	LoadTemplate(IOStream, &m_TextCursorImageSrcRectB.bottom);
	LoadTemplate(IOStream, &m_TextCursorIsABSN);
	LoadTemplate(IOStream, &m_TextCursorIsABSC);
	LoadTemplate(IOStream, &m_TextCursorIsABSG);
	LoadTemplate(IOStream, &m_TextCursorIsABSB);
	LoadTemplate(IOStream, &m_SelectState);
	LoadStringS(IOStream, &m_SelectVar);
	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		m_SelectText.push_back(TextTokenSection());
		IOStream->LoadTextTokenSection(&m_SelectText.back());
		m_SelectIsPushed.push_back(false);
		m_SelectIsCursored.push_back(false);
	}
	LoadTemplate(IOStream, &m_SelectTextSize);
	LoadStringS(IOStream, &m_SelectTextFont);
	LoadTemplate(IOStream, &m_SelectTextMaxWidth);
	LoadTemplate(IOStream, &m_SelectTextMaxHeight);
	LoadTemplate(IOStream, &m_SelectTextNColor);
	LoadTemplate(IOStream, &m_SelectTextCColor);
	LoadTemplate(IOStream, &m_SelectTextHColor);
	LoadTemplate(IOStream, &m_SelectWindowUnderSpace);
	LoadStringS(IOStream, &m_SelectClickSE);
	LoadStringS(IOStream, &m_SelectCursorSE);
	LoadTemplate(IOStream, &m_SelectWindowIsUsedImage);
	LoadTemplate(IOStream, &m_SelectWindowA);
	LoadStringS(IOStream, &m_SelectWindowImageName);
	LoadImage(m_SelectWindowImageName.c_str());
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectN.left);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectN.top);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectN.right);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectN.bottom);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectC.left);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectC.top);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectC.right);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectC.bottom);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectH.left);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectH.top);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectH.right);
	LoadTemplate(IOStream, &m_SelectWindowImageSrcRectH.bottom);
	LoadTemplate(IOStream, &m_SelectWindowAroundSpace);
	LoadTemplate(IOStream, &m_SelectWindowNColor);
	LoadTemplate(IOStream, &m_SelectWindowCColor);
	LoadTemplate(IOStream, &m_SelectWindowHColor);
	LoadTemplate(IOStream, &m_SelectWindowBorder);
	LoadTemplate(IOStream, &m_SelectWindowBorderNColor);
	LoadTemplate(IOStream, &m_SelectWindowBorderCColor);
	LoadTemplate(IOStream, &m_SelectWindowBorderHColor);
	LoadTemplate(IOStream, &m_ClearColor);
	LoadTemplate(IOStream, &m_PresentClearColor);
}
//SEgpĂ邩H
bool BaseDrawManager::IsUsedSE(const char* FileName) const{
	return(m_SelectCursorSE==FileName || m_SelectClickSE==FileName);
}
//摜gpĂ邩H
bool BaseDrawManager::IsUsedImage(const char* FileName) const{
	return( m_TextWindowImageName==FileName || 
			m_TextCursorImageNameN==FileName || m_TextCursorImageNameC==FileName || 
			m_TextCursorImageNameG==FileName || m_TextCursorImageNameB==FileName || 
			m_SelectWindowImageName==FileName );
}



//eGWݒ
void DMAccessor::SetParent(INovelEngine* Parent){
	Outer = Parent;
}

//ʂ
void DMAccessor::Clear(){
	GETDRAW()->Clear();
}
//ʂ̏Fi݁jXV
void DMAccessor::UpdateClearColor(){
	GETDRAW()->UpdateClearColor();
}
//ʂ̏Fi݁j擾
COLORREF DMAccessor::GetPresentClearColor(){
	return(GETDRAW()->GetPresentClearColor());
}
//ʂ̏Fi݁jݒ
void DMAccessor::SetPresentClearColor(COLORREF Color){
	GETDRAW()->SetPresentClearColor(Color);
}
//ʏ]iFj
void DMAccessor::Blt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->Blt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//F]iFj
void DMAccessor::AddBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->AddBlt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//F]iFj
void DMAccessor::SubBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->SubBlt(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//ʏ]iFȂj
void DMAccessor::BltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->BltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//F]iFȂj
void DMAccessor::AddBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->AddBltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//F]iFȂj
void DMAccessor::SubBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	GETDRAW()->SubBltFast(FileName, x, y, a, SrcRect, ScalingX, ScalingY, Degree);
}
//`(1)
void DMAccessor::DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a){
	GETDRAW()->DrawFreeText(Text, x, y, a);
}
//`(2)
void DMAccessor::DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a, COLORREF Color){
	GETDRAW()->DrawFreeText(Text, x, y, a, Color);
}
//`(3)
void DMAccessor::DrawFreeText(const char* Text, int x, int y, BYTE a, const char* Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree){
	GETDRAW()->DrawFreeText(Text, x, y, a, Font, Size, Color, IsBold, IsItalic, Degree);
}
//``
void DMAccessor::DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree){
	GETDRAW()->DrawRect(Rect, Color, a, Degree);
}
//t``
void DMAccessor::DrawBorderRect(RECT Rect, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor){
	GETDRAW()->DrawBorderRect(Rect, Color, a, Border, BorderColor);
}



#ifdef __cplusplus
extern "C"{
#endif

//ANZbT
static DMAccessor AbyssLibSingletonDMAccessor;
//ANZbT擾
__declspec(dllexport) IDMAccessor* GetDMAccessor(){
	return(&AbyssLibSingletonDMAccessor);
}
//ANZbTݒ
__declspec(dllexport) void SetDMAccessor(INovelEngine* Parent){
	AbyssLibSingletonDMAccessor.SetParent(Parent);
}

#ifdef __cplusplus
}
#endif

}
}