#include "stdafx.h"
#include "index.h"
#include "FMisc.h"

namespace nsAbyssLib{
namespace nsFMisc{

#ifdef __cplusplus
extern "C"{
#endif

//bZ[W
__declspec(dllexport) void Message(HWND MyApp, LPCSTR fmt, ...){
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	MessageBox(MyApp, buf, "bZ[W", MB_OK);
}
//bZ[WifobOpj
__declspec(dllexport) void DebugMessage(HWND MyApp, LPCSTR fmt, ...){
#ifdef _DEBUG
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	MessageBox(MyApp, buf, "bZ[WifobOpj", MB_OK);
#endif
}

//xI
__declspec(dllexport) void RuntimeWarning(HWND MyApp, LPCSTR fmt, ...){
#ifdef _DEBUG
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	MessageBox(MyApp, buf, "xI", MB_OK | MB_ICONWARNING);
#endif
}
//G[I
__declspec(dllexport) void RuntimeError(HWND MyApp, LPCSTR fmt, ...){
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	MessageBox(MyApp, buf, "G[I", MB_OK | MB_ICONWARNING);
	WARNING
}

//vZ
__declspec(dllexport) int CalcExpression(const Expression& Exp, INovelEngine* Outer){
	Expression Out;
	for(unsigned int i=0;i<Exp.size();i++){
		//萔
		if(Exp.at(i).Type==TK_CONST){
			Out.push_back(Exp.at(i));
		}
		//Zq
		else if(Exp.at(i).Type==TK_OPERATOR){
			Token Temp;
			Temp.Type = TK_CONST;
			switch(Exp.at(i).SubType){
				case(OP_PLUS1):					//	+iPj
					break;
				case(OP_PLUS2):					//	+i񍀁j
					Temp.Value = Out.at(Out.size()-2).Value + Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_MINUS1):				//	-iPj
					Temp.Value = -Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_MINUS2):				//	-i񍀁j
					Temp.Value = Out.at(Out.size()-2).Value - Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_DIVIDE):				//	/
					if(Out.at(Out.size()-1).Value==0){
						RuntimeError(Outer->GetMyAppHWND(), "0ZłI");
					}
					Temp.Value = Out.at(Out.size()-2).Value / Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_MULTIPLY):				//	*
					Temp.Value = Out.at(Out.size()-2).Value * Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_REMAINDER):				//	%
					Temp.Value = Out.at(Out.size()-2).Value % Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_LOGIC_OR):				//	|
					Temp.Value = Out.at(Out.size()-2).Value | Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_LOGIC_AND):				//	&
					Temp.Value = Out.at(Out.size()-2).Value & Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_LOGIC_XOR):				//	^
					Temp.Value = Out.at(Out.size()-2).Value ^ Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_LOGIC_NOT1):			//	~
					Temp.Value = ~Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_LOGIC_NOT2):			//	!
					Temp.Value = !Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_OR):				//	||
					Temp.Value = Out.at(Out.size()-2).Value || Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_AND):				//	&&
					Temp.Value = Out.at(Out.size()-2).Value && Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_EQUAL):			//	==
					Temp.Value = Out.at(Out.size()-2).Value == Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_BIGGER):			//	>
					Temp.Value = Out.at(Out.size()-2).Value > Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_SMALLER):			//	<
					Temp.Value = Out.at(Out.size()-2).Value < Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_EQUAL_NOT):		//	!=
					Temp.Value = Out.at(Out.size()-2).Value != Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_EQUAL_BIGGER):		//	>=
					Temp.Value = Out.at(Out.size()-2).Value >= Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				case(OP_COMP_EQUAL_SMALLER):	//	<=
					Temp.Value = Out.at(Out.size()-2).Value <= Out.at(Out.size()-1).Value;
					Out.pop_back();
					Out.pop_back();
					Out.push_back(Temp);
					break;
				default:
					RuntimeError(Outer->GetMyAppHWND(), "݂ȂZqłIiSubType = %dj", Exp.at(i).SubType);
					break;
			}
		}
		//ʎq
		else if(Exp.at(i).Type==TK_IDENTIFER){
			Token Temp;
			Temp.Type = TK_CONST;
			//ϐ
			if(Outer->GetLocal()->Find(Exp.at(i).Text.c_str())){
				Temp.Value = Outer->GetLocal()->Get(Exp.at(i).Text.c_str());
			}
			//Oϐ
			else if(Outer->GetGlobal()->Find(Exp.at(i).Text.c_str())){
				Temp.Value = Outer->GetGlobal()->Get(Exp.at(i).Text.c_str());
			}
			//̑
			else{
				RuntimeError(Outer->GetMyAppHWND(), "%s͌vZs\ȃV{݂܂I", Exp.at(i).Text.c_str());
			}
			Out.push_back(Temp);
		}
		//̑
		else{
			RuntimeError(Outer->GetMyAppHWND(), "sȃg[NłIiType = %dj", Exp.at(i).Type);
		}
	}
	//X^bNЂƂij
	if(Out.size()==1){
		return(Out.at(0).Value);
	}
	//X^bNЂƂȊOiG[j
	else{
		RuntimeError(Outer->GetMyAppHWND(), "sȎłI");
		return(0);
	}
}

#ifdef __cplusplus
}
#endif

RECT CreateRect(int X, int Y, int Width, int Height){
	RECT Temp;
	Temp.left = X;
	Temp.top = Y;
	Temp.right = X + Width;
	Temp.bottom = Y + Height;
	return(Temp);
}

}
}