#include "stdafx.h"
#include "index.h"
#include "IOStream.h"

namespace nsAbyssLib{
namespace nsIOStream{

static void SaveRubyTextToken(IIOStream* IOStream, const RubyTextToken& Data){
	if(IOStream->IsOpened()){
		IOStream->SaveStringM(Data.Text);
		SaveTemplate(IOStream, Data.Size);
		SaveTemplate(IOStream, Data.Color);
		IOStream->SaveStringM(Data.Font);
		SaveTemplate(IOStream, Data.a);
		SaveTemplate(IOStream, Data.IsBold);
		SaveTemplate(IOStream, Data.IsItalic);
		SaveTemplate(IOStream, Data.Width);
		SaveTemplate(IOStream, Data.Height);
		SaveTemplate(IOStream, Data.Degree);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void SaveRubyTextTokenLine(IIOStream* IOStream, const RubyTextTokenLine& Data){
	if(IOStream->IsOpened()){
		SaveTemplate(IOStream, static_cast<int>(Data.size()));
		for(unsigned int i=0;i<Data.size();i++){
			SaveRubyTextToken(IOStream, Data.at(i));
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void SaveTextToken(IIOStream* IOStream, const TextToken& Data){
	if(IOStream->IsOpened()){
		IOStream->SaveStringM(Data.Text);
		SaveTemplate(IOStream, Data.Size);
		SaveTemplate(IOStream, Data.Color);
		IOStream->SaveStringM(Data.Font);
		SaveTemplate(IOStream, Data.a);
		SaveTemplate(IOStream, Data.IsBold);
		SaveTemplate(IOStream, Data.IsItalic);
		SaveTemplate(IOStream, Data.Width);
		SaveTemplate(IOStream, Data.Height);
		SaveRubyTextTokenLine(IOStream, Data.Ruby);
		SaveTemplate(IOStream, Data.Degree);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void SaveTextTokenLine(IIOStream* IOStream, const TextTokenLine& Data){
	if(IOStream->IsOpened()){
		SaveTemplate(IOStream, static_cast<int>(Data.size()));
		for(unsigned int i=0;i<Data.size();i++){
			SaveTextToken(IOStream, Data.at(i));
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

static void LoadRubyTextToken(IIOStream* IOStream, RubyTextToken* Data){
	if(IOStream->IsOpened()){
		IOStream->LoadStringM(&Data->Text);
		LoadTemplate(IOStream, &Data->Size);
		LoadTemplate(IOStream, &Data->Color);
		IOStream->LoadStringM(&Data->Font);
		LoadTemplate(IOStream, &Data->a);
		LoadTemplate(IOStream, &Data->IsBold);
		LoadTemplate(IOStream, &Data->IsItalic);
		LoadTemplate(IOStream, &Data->Width);
		LoadTemplate(IOStream, &Data->Height);
		LoadTemplate(IOStream, &Data->Degree);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void LoadRubyTextTokenLine(IIOStream* IOStream, RubyTextTokenLine* Data){
	if(IOStream->IsOpened()){
		int Loop;
		Data->clear();
		LoadTemplate(IOStream, &Loop);
		for(int i=0;i<Loop;i++){
			Data->push_back(RubyTextToken());
			LoadRubyTextToken(IOStream, &Data->back());
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void LoadTextToken(IIOStream* IOStream, TextToken* Data){
	if(IOStream->IsOpened()){
		IOStream->LoadStringM(&Data->Text);
		LoadTemplate(IOStream, &Data->Size);
		LoadTemplate(IOStream, &Data->Color);
		IOStream->LoadStringM(&Data->Font);
		LoadTemplate(IOStream, &Data->a);
		LoadTemplate(IOStream, &Data->IsBold);
		LoadTemplate(IOStream, &Data->IsItalic);
		LoadTemplate(IOStream, &Data->Width);
		LoadTemplate(IOStream, &Data->Height);
		LoadRubyTextTokenLine(IOStream, &Data->Ruby);
		LoadTemplate(IOStream, &Data->Degree);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
static void LoadTextTokenLine(IIOStream* IOStream, TextTokenLine* Data){
	if(IOStream->IsOpened()){
		int Loop;
		Data->clear();
		LoadTemplate(IOStream, &Loop);
		for(int i=0;i<Loop;i++){
			Data->push_back(TextToken(), UINT_MAX);
			LoadTextToken(IOStream, &Data->back());
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}



//ftHgRXgN^
BaseIOStream::BaseIOStream(){
	stream = NULL;
}
//fXgN^
BaseIOStream::~BaseIOStream(){
	Close();
}
//I[vEN[YEI[vmF
bool BaseIOStream::Open(const char* FileName, const char* Mode){
	if(IsOpened()){
		RuntimeError(NULL, "t@C͊ɃI[vĂ܂I");
	}
	else{
		stream = fopen(FileName, Mode);
	}
	return(stream!=NULL);
}
bool BaseIOStream::Close(){
	if(IsOpened()){
		if(fclose(stream)==0){
			stream = NULL;
			return(true);
		}
		else{
			RuntimeError(NULL, "t@C̃N[YɎs܂I");
			return(false);
		}
	}
	return(true);
}
bool BaseIOStream::IsOpened(){
	return(stream!=NULL);
}

//f[^o
void BaseIOStream::SaveNum(int Data){
	if(IsOpened()){
		fwrite(&Data, sizeof(int), 1, stream);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveChar(const char* Data){
	if(IsOpened()){
		char strData[65535] = {0};
		strcpy(strData, Data);
		for(unsigned int i=0;strData[i]!='\0';i++){
			strData[i] = 255 - strData[i];
		}
		fwrite(strData, strlen(strData)+1, 1, stream);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SavePrimitive(const void* Data, unsigned int Size){
	if(IsOpened()){
		fwrite(Data, Size, 1, stream);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::LoadNum(int* Data){
	if(IsOpened()){
		fread(Data, sizeof(int), 1, stream);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadChar(char* Data){
	if(IsOpened()){
		unsigned int i = 0;
		char strData[65535] = {0};
		while(true){
			fread(strData+i, sizeof(char), 1, stream);
			if(strData[i]=='\0'){
				break;
			}
			else{
				strData[i] = 255 - strData[i];
				i += 1;
			}
		}
		strcpy(Data, strData);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadPrimitive(void* Data, unsigned int Size){
	if(IsOpened()){
		fread(Data, Size, 1, stream);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::SaveStringM(const mystr& Data){
	if(IsOpened()){
		SaveChar(Data.c_str());
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveStringVM(const vector_mystr& Data){
	if(IsOpened()){
		SaveTemplate(this, static_cast<int>(Data.size()));
		for(unsigned int i=0;i<Data.size();i++){
			SaveStringM(Data.at(i));
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveExpression(const Expression& Data){
	if(IsOpened()){
		SaveTemplate(this, static_cast<int>(Data.size()));
		for(unsigned int i=0;i<Data.size();i++){
			SaveTemplate(this, Data.at(i).Type);
			SaveTemplate(this, Data.at(i).SubType);
			SaveTemplate(this, Data.at(i).Value);
			SaveStringM(Data.at(i).Text);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveTextTokenSection(const TextTokenSection& Data){
	if(IsOpened()){
		SaveTemplate(this, static_cast<int>(Data.size()));
		for(unsigned int i=0;i<Data.size();i++){
			SaveTextTokenLine(this, Data.at(i));
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::LoadStringM(mystr* Data){
	if(IsOpened()){
		char strData[65535] = {0};
		LoadChar(strData);
		Data->assign(strData);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadStringVM(vector_mystr* Data){
	if(IsOpened()){
		int Loop;
		Data->clear();
		LoadTemplate(this, &Loop);
		for(int i=0;i<Loop;i++){
			Data->push_back("");
			LoadStringM(&Data->back());
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadExpression(Expression* Data){
	if(IsOpened()){
		int Loop;
		Data->clear();
		LoadTemplate(this, &Loop);
		for(int i=0;i<Loop;i++){
			Data->push_back(Token());
			LoadTemplate(this, &Data->back().Type);
			LoadTemplate(this, &Data->back().SubType);
			LoadTemplate(this, &Data->back().Value);
			LoadStringM(&Data->back().Text);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadTextTokenSection(TextTokenSection* Data){
	if(IsOpened()){
		int Loop;
		Data->clear();
		LoadTemplate(this, &Loop);
		for(int i=0;i<Loop;i++){
			Data->push_back(TextTokenLine(), UINT_MAX, UINT_MAX);
			LoadTextTokenLine(this, &Data->back());
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::SaveDrawTask(const DrawTask& Data){
	if(IsOpened()){
		SaveTemplate(this, Data.a);
		SaveTemplate(this, Data.x);
		SaveTemplate(this, Data.y);
		SaveTemplate(this, Data.z);
		SaveTemplate(this, Data.IsShow);
		SaveTemplate(this, Data.BltType);
		SaveTemplate(this, Data.Degree);
		SaveTemplate(this, Data.RectPos.left);
		SaveTemplate(this, Data.RectPos.top);
		SaveTemplate(this, Data.RectPos.right);
		SaveTemplate(this, Data.RectPos.bottom);
		SaveTemplate(this, Data.Color);
		SaveTextTokenSection(Data.Text);
		SaveTemplate(this, Data.SrcRect.left);
		SaveTemplate(this, Data.SrcRect.top);
		SaveTemplate(this, Data.SrcRect.right);
		SaveTemplate(this, Data.SrcRect.bottom);
		SaveStringM(Data.FileName);
		SaveTemplate(this, Data.ScalingX);
		SaveTemplate(this, Data.ScalingY);
		SaveTemplate(this, Data.zz);
		SaveTemplate(this, Data.Type);
		for(unsigned int i=0;i<10;i++){
			SaveTemplate(this, Data.nArg[i]);
			SaveStringM(Data.strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveSprite(const Sprite& Data){
	if(IsOpened()){
		SaveDrawTask(Data.SpriteTask[0]);
		SaveDrawTask(Data.SpriteTask[1]);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveButton(const Button& Data){
	if(IsOpened()){
		SaveTemplate(this, Data.IsPushed);
		SaveTemplate(this, Data.IsCursored);
		SaveTemplate(this, Data.IsEnable);
		SaveTemplate(this, Data.ClickRect.left);
		SaveTemplate(this, Data.ClickRect.top);
		SaveTemplate(this, Data.ClickRect.right);
		SaveTemplate(this, Data.ClickRect.bottom);
		for(unsigned int i=0;i<2;i++){
			for(unsigned int j=0;j<4;j++){
				SaveTemplate(this, Data.SrcRect[i][j].left);
				SaveTemplate(this, Data.SrcRect[i][j].top);
				SaveTemplate(this, Data.SrcRect[i][j].right);
				SaveTemplate(this, Data.SrcRect[i][j].bottom);
			}
		}
		SaveStringM(Data.DestLabel);
		SaveStringM(Data.OnClickSE);
		SaveStringM(Data.OnCursorSE);
		SaveSprite(Data.ButtonTask);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveEffectParam(const EffectParam& Data){
	if(IsOpened()){
		SaveTemplate(this, Data.Type);
		SaveTemplate(this, Data.Time);
		SaveTemplate(this, Data.Color);
		for(unsigned int i=0;i<10;i++){
			SaveTemplate(this, Data.nArg[i]);
			SaveStringM(Data.strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::SaveUpdateParam(const UpdateParam& Data){
	if(IsOpened()){
		SaveTemplate(this, Data.Type);
		SaveTemplate(this, Data.Time);
		SaveTemplate(this, Data.Color);
		for(unsigned int i=0;i<10;i++){
			SaveTemplate(this, Data.nArg[i]);
			SaveStringM(Data.strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::LoadDrawTask(DrawTask* Data){
	if(IsOpened()){
		LoadTemplate(this, &Data->a);
		LoadTemplate(this, &Data->x);
		LoadTemplate(this, &Data->y);
		LoadTemplate(this, &Data->z);
		LoadTemplate(this, &Data->IsShow);
		LoadTemplate(this, &Data->BltType);
		LoadTemplate(this, &Data->Degree);
		LoadTemplate(this, &Data->RectPos.left);
		LoadTemplate(this, &Data->RectPos.top);
		LoadTemplate(this, &Data->RectPos.right);
		LoadTemplate(this, &Data->RectPos.bottom);
		LoadTemplate(this, &Data->Color);
		LoadTextTokenSection(&Data->Text);
		LoadTemplate(this, &Data->SrcRect.left);
		LoadTemplate(this, &Data->SrcRect.top);
		LoadTemplate(this, &Data->SrcRect.right);
		LoadTemplate(this, &Data->SrcRect.bottom);
		LoadStringM(&Data->FileName);
		LoadTemplate(this, &Data->ScalingX);
		LoadTemplate(this, &Data->ScalingY);
		LoadTemplate(this, &Data->zz);
		LoadTemplate(this, &Data->Type);
		for(unsigned int i=0;i<10;i++){
			LoadTemplate(this, &Data->nArg[i]);
			LoadStringM(&Data->strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadSprite(Sprite* Data){
	if(IsOpened()){
		LoadDrawTask(&Data->SpriteTask[0]);
		LoadDrawTask(&Data->SpriteTask[1]);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadButton(Button* Data){
	if(IsOpened()){
		LoadTemplate(this, &Data->IsPushed);
		LoadTemplate(this, &Data->IsCursored);
		LoadTemplate(this, &Data->IsEnable);
		LoadTemplate(this, &Data->ClickRect.left);
		LoadTemplate(this, &Data->ClickRect.top);
		LoadTemplate(this, &Data->ClickRect.right);
		LoadTemplate(this, &Data->ClickRect.bottom);
		for(unsigned int i=0;i<2;i++){
			for(unsigned int j=0;j<4;j++){
				LoadTemplate(this, &Data->SrcRect[i][j].left);
				LoadTemplate(this, &Data->SrcRect[i][j].top);
				LoadTemplate(this, &Data->SrcRect[i][j].right);
				LoadTemplate(this, &Data->SrcRect[i][j].bottom);
			}
		}
		LoadStringM(&Data->DestLabel);
		LoadStringM(&Data->OnClickSE);
		LoadStringM(&Data->OnCursorSE);
		LoadSprite(&Data->ButtonTask);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadEffectParam(EffectParam* Data){
	if(IsOpened()){
		LoadTemplate(this, &Data->Type);
		LoadTemplate(this, &Data->Time);
		LoadTemplate(this, &Data->Color);
		for(unsigned int i=0;i<10;i++){
			LoadTemplate(this, &Data->nArg[i]);
			LoadStringM(&Data->strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void BaseIOStream::LoadUpdateParam(UpdateParam* Data){
	if(IsOpened()){
		LoadTemplate(this, &Data->Type);
		LoadTemplate(this, &Data->Time);
		LoadTemplate(this, &Data->Color);
		for(unsigned int i=0;i<10;i++){
			LoadTemplate(this, &Data->nArg[i]);
			LoadStringM(&Data->strArg[i]);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::SaveRecord(const Record& Data){
	if(IsOpened()){
		SaveTextTokenSection(Data.Text);
		SaveTextTokenSection(Data.Talker);
		SaveStringVM(Data.VoiceFileName);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void BaseIOStream::LoadRecord(Record* Data){
	if(IsOpened()){
		LoadTextTokenSection(&Data->Text);
		LoadTextTokenSection(&Data->Talker);
		LoadStringVM(&Data->VoiceFileName);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}



//wp[֐
void SaveStringS(IIOStream* IOStream, const string& Data){
	if(IOStream->IsOpened()){
		IOStream->SaveChar(Data.c_str());
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void SaveMapList(IIOStream* IOStream, const map<string, int>& Data){
	if(IOStream->IsOpened()){
		SaveTemplate(IOStream, static_cast<int>(Data.size()));
		for(map<string, int>::const_iterator it=Data.begin();it!=Data.end();it++){
			SaveStringS(IOStream, it->first);
			SaveTemplate(IOStream, it->second);
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

void LoadStringS(IIOStream* IOStream, string* Data){
	if(IOStream->IsOpened()){
		char strData[65535] = {0};
		IOStream->LoadChar(strData);
		Data->assign(strData);
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}
void LoadMapList(IIOStream* IOStream, map<string, int>* Data){
	if(IOStream->IsOpened()){
		int Loop;
		int nData;
		string strData;
		Data->clear();
		LoadTemplate(IOStream, &Loop);
		for(int i=0;i<Loop;i++){
			LoadStringS(IOStream, &strData);
			LoadTemplate(IOStream, &nData);
			Data->insert(pair<string, int>(strData, nData));
		}
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

bool FindScriptFile(IIOStream* IOStream, const string& FileName){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='s' && Header[2]=='c' && Header[3]=='r'){
		return(IOStream->Close());
	}
	else{
		IOStream->Close();
		return(false);
	}
}
bool LoadEIsFullScreen(IIOStream* IOStream, const string& FileName){
	if(!IOStream->Open(FileName.c_str(), "rb")){
		return(false);
	}
	char Header[4] = {0};
	bool IsFullScreen = DEFAULT_SCREENMODE;
	IOStream->LoadPrimitive(Header, sizeof(Header));
	if(Header[0]=='.' && Header[1]=='e' && Header[2]=='n' && Header[3]=='v'){
		IOStream->LoadPrimitive(&IsFullScreen, sizeof(IsFullScreen));
	}
	IOStream->Close();
	return(IsFullScreen);
}

}
}