/*************************************************
t@CFIOStream.h
쐬ҁ@@Fт
@@@Ff[^o
*************************************************/
/**
*	@file	IOStream.h
*	@brief	f[^o̓NX֌WłB
*/
#ifndef ABYSSLIB_IOSTREAM_H
#define ABYSSLIB_IOSTREAM_H

namespace nsAbyssLib{

namespace nsTaskManager{
//ˑ\́iQƐFTaskManager.hj
struct DrawTask;
struct Sprite;
struct Button;
struct EffectParam;
struct UpdateParam;
}
namespace nsTextManager{
//ˑ\́iQƐFTextManager.hj
struct Record;
}
namespace nsCore{
//ˑNXiQƐFAbyssLib.hj
class INovelEngine;
}

namespace nsIOStream{

//f[^o̓NXiC^[tF[Xj
/**
*	@brief	f[^o̓NX̃C^[tF[XłB
*
*			{NX͑SẴf[^o͏s܂B<br>
*			SẴf[^o͏s悤ɎĂB<br>
*			<br>
*			e\bhׂ̐ɂ͋L܂B<br>
*			Save`\bhȂтLoad`\bh́A舵^قȂ邾Ŏׂ͓łB<br>
*			Save`\bhȂтLoad`\bh́At@CI[vĂȂꍇ\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*/
class IIOStream{
public:
	//zfXgN^
/**
*	@brief	fXgN^łB
*/
	~IIOStream(){}

	//I[vEN[YEI[vmF
/**
*	@brief	t@CI[v܂B
*
*			I[v悤ɎĂB<br>
*			dI[v݂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B<br>
*			<a href="http://msdn.microsoft.com/ja-jp/library/yeby3zcb(VS.80).aspx" target="_blank">fopen֐</a>̌݊\bhłB
*	@param	FileName	[in]I[vt@Cw肵܂B
*	@param	Mode		[in]t@C[hw肵܂B
*	@return	t@C̃I[vꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool Open(const char* FileName, const char* Mode) = 0;
/**
*	@brief	t@CN[Y܂B
*
*			N[Y悤ɎĂB<br>
*			N[YɎsꍇA\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B<br>
*			<a href="http://msdn.microsoft.com/ja-jp/library/fxfsw25t(VS.80).aspx" target="_blank">fclose֐</a>̌݊\bhłB
*	@return	t@C̃N[YꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool Close() = 0;
/**
*	@brief	t@CI[vĂ邩擾܂B
*	@return	t@CI[vĂꍇtrueAĂȂꍇfalseԂ܂B
*/
	virtual bool IsOpened() = 0;

	//f[^o
	virtual void SaveNum(int Data) = 0;
	virtual void SaveChar(const char* Data) = 0;
	virtual void SavePrimitive(const void* Data, unsigned int Size) = 0;

	virtual void LoadNum(int* Data) = 0;
	virtual void LoadChar(char* Data) = 0;
	virtual void LoadPrimitive(void* Data, unsigned int Size) = 0;

	virtual void SaveStringM(const mystr& Data) = 0;
	virtual void SaveStringVM(const vector_mystr& Data) = 0;
	virtual void SaveExpression(const Expression& Data) = 0;
	virtual void SaveTextTokenSection(const TextTokenSection& Data) = 0;

	virtual void LoadStringM(mystr* Data) = 0;
	virtual void LoadStringVM(vector_mystr* Data) = 0;
	virtual void LoadExpression(Expression* Data) = 0;
	virtual void LoadTextTokenSection(TextTokenSection* Data) = 0;

	virtual void SaveDrawTask(const DrawTask& Data) = 0;
	virtual void SaveSprite(const Sprite& Data) = 0;
	virtual void SaveButton(const Button& Data) = 0;
	virtual void SaveEffectParam(const EffectParam& Data) = 0;
	virtual void SaveUpdateParam(const UpdateParam& Data) = 0;

	virtual void LoadDrawTask(DrawTask* Data) = 0;
	virtual void LoadSprite(Sprite* Data) = 0;
	virtual void LoadButton(Button* Data) = 0;
	virtual void LoadEffectParam(EffectParam* Data) = 0;
	virtual void LoadUpdateParam(UpdateParam* Data) = 0;

	virtual void SaveRecord(const Record& Data) = 0;

	virtual void LoadRecord(Record* Data) = 0;
};

//f[^o̓NX
/**
*	@brief	f[^o̓NXłB
*
*			{NX͑SẴf[^o͏s܂B<br>
*			<br>
*			e\bhׂ̐ɂ͋L܂B<br>
*			Save`\bhȂтLoad`\bh́A舵^قȂ邾ŏ͓łB
*/
class BaseIOStream : public IIOStream{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	BaseIOStream();											//ftHgRXgN^
/**
*	@brief	fXgN^łB
*/
	~BaseIOStream();										//fXgN^

	//I[vEN[YEI[vmF
	bool Open(const char* FileName, const char* Mode);
	bool Close();
	bool IsOpened();

	//f[^o
	void SaveNum(int Data);
	void SaveChar(const char* Data);
	void SavePrimitive(const void* Data, unsigned int Size);

	void LoadNum(int* Data);
	void LoadChar(char* Data);
	void LoadPrimitive(void* Data, unsigned int Size);

	void SaveStringM(const mystr& Data);
	void SaveStringVM(const vector_mystr& Data);
	void SaveExpression(const Expression& Data);
	void SaveTextTokenSection(const TextTokenSection& Data);

	void LoadStringM(mystr* Data);
	void LoadStringVM(vector_mystr* Data);
	void LoadExpression(Expression* Data);
	void LoadTextTokenSection(TextTokenSection* Data);

	void SaveDrawTask(const DrawTask& Data);
	void SaveSprite(const Sprite& Data);
	void SaveButton(const Button& Data);
	void SaveEffectParam(const EffectParam& Data);
	void SaveUpdateParam(const UpdateParam& Data);

	void LoadDrawTask(DrawTask* Data);
	void LoadSprite(Sprite* Data);
	void LoadButton(Button* Data);
	void LoadEffectParam(EffectParam* Data);
	void LoadUpdateParam(UpdateParam* Data);

	void SaveRecord(const Record& Data);

	void LoadRecord(Record* Data);
private:
	FILE* stream;
	BaseIOStream(const BaseIOStream&);						//Rs[RXgN^i֎~j
	BaseIOStream& operator =(const BaseIOStream&);			//Zqi֎~j
};

//wp[֐
/**
*	@brief	string^̃f[^o͂s܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[in]o͂sf[^w肵܂B
*/
void SaveStringS(IIOStream* IOStream, const string& Data);
/**
*	@brief	map<string, int>^̃f[^o͂s܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[in]o͂sf[^w肵܂B
*/
void SaveMapList(IIOStream* IOStream, const map<string, int>& Data);
/**
*	@brief	f[^o͂̃ev[g֐łB
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[in]o͂sf[^w肵܂B
*/
template <typename T> void SaveTemplate(IIOStream* IOStream, const T& Data){
	if(IOStream->IsOpened()){
		IOStream->SavePrimitive(&Data, sizeof(T));
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

/**
*	@brief	string^̃f[^͂s܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[out]ǂݍ񂾃f[^i[܂B
*/
void LoadStringS(IIOStream* IOStream, string* Data);
/**
*	@brief	map<string, int>^̃f[^͂s܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[out]ǂݍ񂾃f[^i[܂B
*/
void LoadMapList(IIOStream* IOStream, map<string, int>* Data);
/**
*	@brief	f[^͂̃ev[g֐łB
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	Data		[out]ǂݍ񂾃f[^i[܂B
*/
template <typename T> void LoadTemplate(IIOStream* IOStream, T* Data){
	if(IOStream->IsOpened()){
		IOStream->LoadPrimitive(Data, sizeof(T));
	}
	else{
		RuntimeError(NULL, "t@CI[vĂ܂I");
	}
}

/**
*	@brief	XNvgt@CAʂ擾܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@return	XNvgt@C݂ꍇtrueA݂ȂꍇfalseԂ܂B
*/
bool FindScriptFile(IIOStream* IOStream, const string& FileName);
/**
*	@brief	ݒt@CAʃ[h̐ݒ肾擾܂B
*	@param	IOStream	[in]gpf[^o̓NXw肵܂B
*	@param	FileName	[in]ݒt@Cw肵܂B
*	@return	ʃ[h̐ݒ肪tXN[[h̏ꍇtrueA<br>
*			ʃ[h̐ݒ肪EChE[h܂͊ݒt@Cǂݍ߂ȂꍇfalseԂ܂B
*/
bool LoadEIsFullScreen(IIOStream* IOStream, const string& FileName);

}
}

#endif