#include "stdafx.h"
#include "index.h"
#include "Plugins.h"

namespace nsAbyssLib{
namespace nsPlugins{

//vOCpo^}bvi񋓌^Factory֐j
map<unsigned int, FactoryFunc> PFactory;
//vOCpo^}bvi񋓌^Update֐j
map<unsigned int, UpdateFunc> PUpdate;
//vOCpo^}bvi񋓌^Effect֐j
map<unsigned int, EffectFunc> PEffect1;
map<unsigned int, EffectFunc> PEffect2;
map<unsigned int, EffectFunc> PEffect3;
//vOCpo^}bvi񋓌^Analysis֐AʎqƗ񋓌^j
map<unsigned int, AnalysisFunc> PAnalysis;
map<string, unsigned int> PCommandName;
//vOCpo^Xgi񋓌^j
vector<unsigned int> PEnableSystemCommand;
//vOCpo^}bvivOCƃ[Jf[^̕ۑ֐j
map<string, SaveLocalDataFunc> PSaveLocalDataFunc;
//vOCpo^}bvivOCƃ[Jf[^̓ǂݍ݊֐j
map<string, LoadLocalDataFunc> PLoadLocalDataFunc;
//vOCpo^}bvivOCƊݒ̕ۑ֐j
map<string, SaveEnvironmentDataFunc> PSaveEnvironmentDataFunc;
//vOCpo^}bvivOCƊݒ̓ǂݍ݊֐j
map<string, LoadEnvironmentDataFunc> PLoadEnvironmentDataFunc;
//vOCpo^}bvi񋓌^ƕ`^XNǉ֐j
map<unsigned int, AddDrawTaskFunc> PAddDrawTaskFunc;
//vOCpo^}bvi񋓌^ƕ`^XN֐j
map<unsigned int, DrawTaskFunc> PDrawTaskFunc;
//vOCpo^}bvi񋓌^ƕ`֐j
map<unsigned int, BltFunc> PBltFunc;

//vOCLoad/Free
static vector<HMODULE> hLibs;
void LoadPlugin(){
	//֐pNX
	class InnerFunction{
	public:
		//ftHgRXgN^
		InnerFunction(){
			char Dir[1024];
			char Drive[1024];
			char FullPath[1024];
			char NewCurrentDir[1024];
			GetCurrentDirectory(1024, m_CurrentDir);
			GetModuleFileName(NULL, FullPath, 1024);
			_splitpath(FullPath, Drive, Dir, NULL, NULL);
			sprintf(NewCurrentDir, "%s%s", Drive, Dir);
			SetCurrentDirectory(NewCurrentDir);
		}
		//fXgN^
		~InnerFunction(){
			SetCurrentDirectory(m_CurrentDir);
		}
	protected:
		char m_CurrentDir[1024];
	};

	HANDLE hFind;
	WIN32_FIND_DATA fd;
	InnerFunction LocalFunction;

	hFind = FindFirstFile("*.dll", &fd);
	if(hFind!=INVALID_HANDLE_VALUE){
		do{
			hLibs.push_back(LoadLibrary(fd.cFileName));
			if(hLibs.back()){
				DebugMessage(NULL, "%sLoadLibraryɐ܂I", fd.cFileName);
				int (*GetAbyssLibDllVersion)() = reinterpret_cast<int (*)()>(GetProcAddress(hLibs.back(), "GetAbyssLibDllVersion"));
				if(GetAbyssLibDllVersion){
					DebugMessage(NULL, "%s͗p\ȃvOCłI", fd.cFileName);
				}
				else{
					RuntimeWarning(NULL, "%s̓vOCł͂܂I", fd.cFileName);
					FreeLibrary(hLibs.back());
					hLibs.pop_back();
				}
			}
			else{
				RuntimeWarning(NULL, "%sLoadLibraryɎs܂I", fd.cFileName);
				hLibs.pop_back();
			}
		}while(FindNextFile(hFind, &fd));
		FindClose(hFind);
	}
}
void FreePlugin(){
	for(vector<HMODULE>::iterator it=hLibs.begin();it!=hLibs.end();it++){
		FreeLibrary(*it);
	}
	hLibs.clear();
	PFactory.clear();
	PUpdate.clear();
	PEffect1.clear();
	PEffect2.clear();
	PEffect3.clear();
	PAnalysis.clear();
	PCommandName.clear();
	PEnableSystemCommand.clear();
	PSaveLocalDataFunc.clear();
	PLoadLocalDataFunc.clear();
	PSaveEnvironmentDataFunc.clear();
	PLoadEnvironmentDataFunc.clear();
	PAddDrawTaskFunc.clear();
	PDrawTaskFunc.clear();
	PBltFunc.clear();
}
void FreeCommand(INovelEngine* Outer){
	GETCOMMAND()->Clear();
}

#ifdef __cplusplus
extern "C"{
#endif

//o[W擾
__declspec(dllexport) int GetAbyssLibVersion(){
	return(ABYSSLIB_VERSION);
}

//vOCpo^֐
__declspec(dllexport) void RegisterPFactory(unsigned int PID, FactoryFunc PFunc){
	PFactory.insert(pair<unsigned int, FactoryFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPUpdate(unsigned int PID, UpdateFunc PFunc){
	PUpdate.insert(pair<unsigned int, UpdateFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPEffect1(unsigned int PID, EffectFunc PFunc){
	PEffect1.insert(pair<unsigned int, EffectFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPEffect2(unsigned int PID, EffectFunc PFunc){
	PEffect2.insert(pair<unsigned int, EffectFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPEffect3(unsigned int PID, EffectFunc PFunc){
	PEffect3.insert(pair<unsigned int, EffectFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPAnalysis(unsigned int PID, AnalysisFunc PFunc){
	PAnalysis.insert(pair<unsigned int, AnalysisFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPCommandName(const char* PName, unsigned int PID){
	PCommandName.insert(pair<string, unsigned int>(PName, PID));
}
__declspec(dllexport) void RegisterPEnableSystemCommand(unsigned int PID){
	PEnableSystemCommand.push_back(PID);
}
__declspec(dllexport) void RegisterPSaveLocalDataFunc(const char* PName, SaveLocalDataFunc PFunc){
	PSaveLocalDataFunc.insert(pair<string, SaveLocalDataFunc>(PName, PFunc));
}
__declspec(dllexport) void RegisterPLoadLocalDataFunc(const char* PName, LoadLocalDataFunc PFunc){
	PLoadLocalDataFunc.insert(pair<string, LoadLocalDataFunc>(PName, PFunc));
}
__declspec(dllexport) void RegisterPSaveEnvironmentDataFunc(const char* PName, SaveEnvironmentDataFunc PFunc){
	PSaveEnvironmentDataFunc.insert(pair<string, SaveEnvironmentDataFunc>(PName, PFunc));
}
__declspec(dllexport) void RegisterPLoadEnvironmentDataFunc(const char* PName, LoadEnvironmentDataFunc PFunc){
	PLoadEnvironmentDataFunc.insert(pair<string, LoadEnvironmentDataFunc>(PName, PFunc));
}
__declspec(dllexport) void RegisterPAddDrawTaskFunc(unsigned int PID, AddDrawTaskFunc PFunc){
	PAddDrawTaskFunc.insert(pair<unsigned int, AddDrawTaskFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPDrawTaskFunc(unsigned int PID, DrawTaskFunc PFunc){
	PDrawTaskFunc.insert(pair<unsigned int, DrawTaskFunc>(PID, PFunc));
}
__declspec(dllexport) void RegisterPBltFunc(unsigned int PID, BltFunc PFunc){
	PBltFunc.insert(pair<unsigned int, BltFunc>(PID, PFunc));
}

#ifdef __cplusplus
}
#endif

}
}