#include "stdafx.h"
#include "index.h"
#include "Scene.h"

namespace nsAbyssLib{
namespace nsScene{

//ftHgRXgN^
DefaultNormalScene::DefaultNormalScene(){
	m_IsRun = true;
}

//
void DefaultNormalScene::Initialize(){
	if(!m_IsRun){
		m_IsRun = true;
		GETTASK()->LeaveBVCS();
	}
}

//O
void DefaultNormalScene::OnBegin(){
	//͎tJ
	if( m_IsRun && !Outer->GetSystemState() && 
		find(PEnableSystemCommand.begin(), PEnableSystemCommand.end(), GETCOMMAND()->GetObj()->at(Outer->GetCommand()->GetIterator())->GetID())!=PEnableSystemCommand.end() ){
		Outer->EnableSystem();
	}
}
//{
void DefaultNormalScene::OnMove(){
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	if(m_IsRun){
		//XNvgs
		if(Outer->GetSystemState()){
			if(Outer->GetInput()->OnEraseTextWindow() && Outer->GetDraw()->GetTextWindowShow() && !Outer->GetDraw()->GetTextWindowForceShow()){
				m_IsRun = false;
				GETTASK()->EnterBVCS();
			}
			else{
				if(Outer->GetInput()->OnCallBackLog() && !Outer->GetText()->IsEmptyRecordData()){
					Outer->PushState(ST_BACKLOG);
				}
				else if(Outer->GetMenu()){
					if(Outer->GetInput()->OnCallMenu()){
						Outer->PushState(ST_MENU);
					}
					else if(Outer->GetInput()->OnCallSave()){
						Outer->PushState(ST_SAVE);
					}
					else if(Outer->GetInput()->OnCallLoad()){
						Outer->PushState(ST_LOAD);
					}
					else if(Outer->GetInput()->OnCallConfig()){
						Outer->PushState(ST_CONFIG);
					}
					else if(Outer->GetInput()->OnCallSuspend()){
						Outer->GetSound()->StopBGM();
						Outer->GetSound()->StopAllSE();
						Outer->GetSound()->StopAllVoice();
						Outer->PushState(ST_SUSPEND);
					}
					else if(Outer->GetInput()->OnCallEndApp()){
						Outer->GetSound()->StopBGM();
						Outer->GetSound()->StopAllSE();
						Outer->GetSound()->StopAllVoice();
						Outer->PushState(ST_ENDAPP);
					}
					else{
						if(Outer->GetInput()->OnSkipOn()){
							Outer->GetText()->SetSkip(true);
						}
						if(Outer->GetInput()->OnSkipOff()){
							Outer->GetText()->SetSkip(false);
						}
						if(Outer->GetInput()->OnAutoOn()){
							Outer->GetText()->SetAutoMode(true);
						}
						if(Outer->GetInput()->OnAutoOff()){
							Outer->GetText()->SetAutoMode(false);
						}
					}
				}
				else{
					if(Outer->GetInput()->OnSkipOn()){
						Outer->GetText()->SetSkip(true);
					}
					if(Outer->GetInput()->OnSkipOff()){
						Outer->GetText()->SetSkip(false);
					}
					if(Outer->GetInput()->OnAutoOn()){
						Outer->GetText()->SetAutoMode(true);
					}
					if(Outer->GetInput()->OnAutoOff()){
						Outer->GetText()->SetAutoMode(false);
					}
				}
				GETTASK()->CheckButton();
				GETCOMMAND()->Run();
			}
		}
		else{
			GETTASK()->CheckButton();
			GETCOMMAND()->Run();
		}
	}
	else{
		//XNvg~
		if(Outer->GetInput()->OnEraseTextWindow()){
			m_IsRun = true;
			GETTASK()->LeaveBVCS();
		}
	}
}
//`
void DefaultNormalScene::OnDraw(){
	if(Outer->GetState()==ST_NORMAL){
		GETDRAW()->Clear();
		GETTASK()->Update();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		if(m_IsRun){
			if(Outer->GetDraw()->GetTextWindowShow() || Outer->GetDraw()->GetTextWindowForceShow()){
				GETDRAW()->DrawTextWindow();
				GETDRAW()->DrawTalker();
				GETDRAW()->DrawText();
				GETDRAW()->DrawTextCursor();
			}
			GETDRAW()->DrawSelect();
		}
		GETTASK()->ExecuteEffect3();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultNormalScene::OnEnd(){
	//͎t
	if(Outer->GetSystemState()){
		Outer->DisableSystem();
	}
}



//ftHgRXgN^
DefaultBackLogScene::DefaultBackLogScene(){
	m_IsFirst = true;
}

//
void DefaultBackLogScene::Initialize(){
	m_IsFirst = true;
}

//O
void DefaultBackLogScene::OnBegin(){
	if(m_IsFirst){
		m_IsFirst = false;
		Outer->GetText()->SetReadIterator(1);
		m_Temp.Text = Outer->GetDraw()->GetText();
		m_Temp.Talker = Outer->GetDraw()->GetTalker();
		Outer->GetDraw()->SetTextCursorMode(TEXTCURSOR_BACKLOG);
	}
}
//{
void DefaultBackLogScene::OnMove(){
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	if(Outer->GetInput()->OnRollUpLog()){
		Outer->GetText()->AddReadIterator(1);
	}
	if(Outer->GetInput()->OnRollDownLog()){
		Outer->GetText()->AddReadIterator(-1);
	}
	//eLXgƔҖݒ
	Outer->GetDraw()->SetText(Outer->GetText()->GetRecordData().Text);
	Outer->GetDraw()->SetTalker(Outer->GetText()->GetRecordData().Talker);
}
//`
void DefaultBackLogScene::OnDraw(){
	if(Outer->GetState()==ST_BACKLOG){
		GETDRAW()->Clear();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		GETDRAW()->DrawTextWindow();
		GETDRAW()->DrawText(RGB(192, 192, 192));
		GETDRAW()->DrawTalker(RGB(192, 192, 192));
		GETDRAW()->DrawTextCursor();
		GETDRAW()->DrawSelect();
		GETTASK()->ExecuteEffect3();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultBackLogScene::OnEnd(){
	if(Outer->GetInput()->OnReturnBackLog()){
		m_IsFirst = true;
		Outer->PopState();
		Outer->GetText()->SetReadIterator(1);
		Outer->GetDraw()->SetText(m_Temp.Text);
		Outer->GetDraw()->SetTalker(m_Temp.Talker);
		Outer->GetDraw()->SetTextCursorMode(TEXTCURSOR_NONE);
	}
}



//ftHgRXgN^
DefaultSaveScene::DefaultSaveScene(){
	m_nSelect = 0;
	char SAVE_ISELECT_TEXT[2];
	for(unsigned int i=0;i<10;i++){
		sprintf(SAVE_ISELECT_TEXT, "%d", i);
		m_Data[i].SetBorder(1);
		m_Data[i].SetPosition(CreateRect(360, i*40+80, 220, 40), 255);
		m_Data[i].SetSound("", "");
		m_Data[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Data[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Data[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorder(1);
		m_Select[i].SetPosition(CreateRect(i/5*50+220, i%5*50+240, 40, 40), 255);
		m_Select[i].SetSound("", "");
		m_Select[i].SetText(SAVE_ISELECT_TEXT, "lr SVbN", 20);
		m_Select[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Select[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	}
	m_EndSave.SetBorder(1);
	m_EndSave.SetPosition(CreateRect(460, 490, 120, 30), 255);
	m_EndSave.SetSound("", "");
	m_EndSave.SetText("߂", "lr SVbN", 20);
	m_EndSave.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndSave.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndSave.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IOStream = new BaseIOStream;
}
//RXgN^if[^o̓NXwj
DefaultSaveScene::DefaultSaveScene(IIOStream* IOStream){
	m_nSelect = 0;
	char SAVE_ISELECT_TEXT[2];
	for(unsigned int i=0;i<10;i++){
		sprintf(SAVE_ISELECT_TEXT, "%d", i);
		m_Data[i].SetBorder(1);
		m_Data[i].SetPosition(CreateRect(360, i*40+80, 220, 40), 255);
		m_Data[i].SetSound("", "");
		m_Data[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Data[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Data[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorder(1);
		m_Select[i].SetPosition(CreateRect(i/5*50+220, i%5*50+240, 40, 40), 255);
		m_Select[i].SetSound("", "");
		m_Select[i].SetText(SAVE_ISELECT_TEXT, "lr SVbN", 20);
		m_Select[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Select[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	}
	m_EndSave.SetBorder(1);
	m_EndSave.SetPosition(CreateRect(460, 490, 120, 30), 255);
	m_EndSave.SetSound("", "");
	m_EndSave.SetText("߂", "lr SVbN", 20);
	m_EndSave.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndSave.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndSave.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IOStream = IOStream;
}
//fXgN^
DefaultSaveScene::~DefaultSaveScene(){
	delete(m_IOStream);
}

//
void DefaultSaveScene::Initialize(){
	m_nSelect = 0;
}

//O
void DefaultSaveScene::OnBegin(){}
//{
void DefaultSaveScene::OnMove(){
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	for(unsigned int i=0;i<10;i++){
		if(m_Data[i].OnMove()){
			if(Confirm()){
				Outer->SaveLocalData(GetSaveFileName(m_nSelect*10+i), m_IOStream);
			}
		}
		if(m_Select[i].OnMove()){
			m_nSelect = i;
		}
	}
	if(m_EndSave.OnMove()){
		Outer->PopState();
	}
	if(Outer->GetInput()->OnReturnSave()){
		Outer->PopState();
	}
	//{^i`j̐ݒ
	for(unsigned int i=0;i<10;i++){
		SetData(i);
		m_Select[i].SetDisable(false);
	}
	m_Select[m_nSelect].SetDisable(true);
}
//`
void DefaultSaveScene::OnDraw(){
	if(Outer->GetState()==ST_SAVE){
		GETDRAW()->Clear();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		if(Outer->GetDraw()->GetTextWindowShow() || Outer->GetDraw()->GetTextWindowForceShow()){
			GETDRAW()->DrawTextWindow();
			GETDRAW()->DrawTalker();
			GETDRAW()->DrawText();
			GETDRAW()->DrawTextCursor();
		}
		GETDRAW()->DrawSelect();
		GETTASK()->ExecuteEffect3();
		GETDRAW()->DrawRect(CreateRect(0, 0, Outer->GetDraw()->GetScreenWidth(), Outer->GetDraw()->GetScreenHeight()), RGB(0, 0, 0), 128);
		GETDRAW()->DrawFreeText("Save", 240, 80, 255, "Times New Roman", 30, RGB(255, 255, 255), false, false);
		for(unsigned int i=0;i<10;i++){
			m_Data[i].OnDraw();
			m_Select[i].OnDraw();
		}
		m_EndSave.OnDraw();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultSaveScene::OnEnd(){}

//eGWݒ
void DefaultSaveScene::SetParent(NovelPlayer* Parent){
	Outer = Parent;
	for(unsigned int i=0;i<10;i++){
		m_Data[i].SetParent(Parent);
		m_Select[i].SetParent(Parent);
	}
	m_EndSave.SetParent(Parent);
}

//mF
bool DefaultSaveScene::Confirm(){
	return(MessageBox(Outer->GetMyAppHWND(), "Z[u܂A낵łH", "mF", MB_YESNO)==IDYES);
}
//Z[ut@C擾
const char* DefaultSaveScene::GetSaveFileName(unsigned int Num){
	static char FileName[11];
	sprintf(FileName, "Save%02d.dat", Num);
	return(FileName);
}
//{^if[^jݒ
void DefaultSaveScene::SetData(unsigned int Num){
	FILETIME ft;
	HANDLE hFind;
	SYSTEMTIME st;
	WIN32_FIND_DATA fd;
	char SAVE_IDATA_TEXT[21];
	hFind = FindFirstFile(GetSaveFileName(m_nSelect*10+Num), &fd);
	if(hFind!=INVALID_HANDLE_VALUE){
		FileTimeToLocalFileTime(&fd.ftLastWriteTime, &ft);
		FileTimeToSystemTime(&ft, &st);
		sprintf(SAVE_IDATA_TEXT, "%02dF%04d/%02d/%02d %02d:%02d", m_nSelect*10+Num, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute);
		m_Data[Num].SetText(SAVE_IDATA_TEXT, "lr SVbN", 20);
	}
	else{
		sprintf(SAVE_IDATA_TEXT, "%02dF----/--/-- --:--", m_nSelect*10+Num);
		m_Data[Num].SetText(SAVE_IDATA_TEXT, "lr SVbN", 20);
	}
}



//ftHgRXgN^
DefaultLoadScene::DefaultLoadScene(){
	m_nSelect = 0;
	char LOAD_ISELECT_TEXT[2];
	for(unsigned int i=0;i<10;i++){
		sprintf(LOAD_ISELECT_TEXT, "%d", i);
		m_Data[i].SetBorder(1);
		m_Data[i].SetPosition(CreateRect(360, i*40+80, 220, 40), 255);
		m_Data[i].SetSound("", "");
		m_Data[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Data[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Data[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorder(1);
		m_Select[i].SetPosition(CreateRect(i/5*50+220, i%5*50+240, 40, 40), 255);
		m_Select[i].SetSound("", "");
		m_Select[i].SetText(LOAD_ISELECT_TEXT, "lr SVbN", 20);
		m_Select[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Select[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	}
	m_EndLoad.SetBorder(1);
	m_EndLoad.SetPosition(CreateRect(460, 490, 120, 30), 255);
	m_EndLoad.SetSound("", "");
	m_EndLoad.SetText("߂", "lr SVbN", 20);
	m_EndLoad.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndLoad.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndLoad.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IOStream = new BaseIOStream;
}
//RXgN^if[^o̓NXwj
DefaultLoadScene::DefaultLoadScene(IIOStream* IOStream){
	m_nSelect = 0;
	char LOAD_ISELECT_TEXT[2];
	for(unsigned int i=0;i<10;i++){
		sprintf(LOAD_ISELECT_TEXT, "%d", i);
		m_Data[i].SetBorder(1);
		m_Data[i].SetPosition(CreateRect(360, i*40+80, 220, 40), 255);
		m_Data[i].SetSound("", "");
		m_Data[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Data[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Data[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorder(1);
		m_Select[i].SetPosition(CreateRect(i/5*50+220, i%5*50+240, 40, 40), 255);
		m_Select[i].SetSound("", "");
		m_Select[i].SetText(LOAD_ISELECT_TEXT, "lr SVbN", 20);
		m_Select[i].SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
		m_Select[i].SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
		m_Select[i].SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	}
	m_EndLoad.SetBorder(1);
	m_EndLoad.SetPosition(CreateRect(460, 490, 120, 30), 255);
	m_EndLoad.SetSound("", "");
	m_EndLoad.SetText("߂", "lr SVbN", 20);
	m_EndLoad.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndLoad.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndLoad.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_IOStream = IOStream;
}
//fXgN^
DefaultLoadScene::~DefaultLoadScene(){
	delete(m_IOStream);
}

//
void DefaultLoadScene::Initialize(){
	m_nSelect = 0;
}

//O
void DefaultLoadScene::OnBegin(){}
//{
void DefaultLoadScene::OnMove(){
	//{^i`j̐ݒ
	for(unsigned int i=0;i<10;i++){
		SetData(i);
		m_Select[i].SetDisable(false);
	}
	m_Select[m_nSelect].SetDisable(true);
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	for(unsigned int i=0;i<10;i++){
		if(m_Data[i].OnMove()){
			if(Confirm()){
				Outer->LoadLocalData(GetSaveFileName(m_nSelect*10+i), m_IOStream);
				Outer->InitState();
			}
		}
		if(m_Select[i].OnMove()){
			m_nSelect = i;
		}
	}
	if(m_EndLoad.OnMove()){
		Outer->PopState();
	}
	if(Outer->GetInput()->OnReturnLoad()){
		Outer->PopState();
	}
}
//`
void DefaultLoadScene::OnDraw(){
	if(Outer->GetState()==ST_LOAD){
		GETDRAW()->Clear();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		if(Outer->GetDraw()->GetTextWindowShow() || Outer->GetDraw()->GetTextWindowForceShow()){
			GETDRAW()->DrawTextWindow();
			GETDRAW()->DrawTalker();
			GETDRAW()->DrawText();
			GETDRAW()->DrawTextCursor();
		}
		GETDRAW()->DrawSelect();
		GETTASK()->ExecuteEffect3();
		GETDRAW()->DrawRect(CreateRect(0, 0, Outer->GetDraw()->GetScreenWidth(), Outer->GetDraw()->GetScreenHeight()), RGB(0, 0, 0), 128);
		GETDRAW()->DrawFreeText("Load", 240, 80, 255, "Times New Roman", 30, RGB(255, 255, 255), false, false);
		for(unsigned int i=0;i<10;i++){
			m_Data[i].OnDraw();
			m_Select[i].OnDraw();
		}
		m_EndLoad.OnDraw();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultLoadScene::OnEnd(){}

//eGWݒ
void DefaultLoadScene::SetParent(NovelPlayer* Parent){
	Outer = Parent;
	for(unsigned int i=0;i<10;i++){
		m_Data[i].SetParent(Parent);
		m_Select[i].SetParent(Parent);
	}
	m_EndLoad.SetParent(Parent);
}

//mF
bool DefaultLoadScene::Confirm(){
	return(MessageBox(Outer->GetMyAppHWND(), "[h܂A낵łH", "mF", MB_YESNO)==IDYES);
}
//Z[ut@C擾
const char* DefaultLoadScene::GetSaveFileName(unsigned int Num){
	static char FileName[11];
	sprintf(FileName, "Save%02d.dat", Num);
	return(FileName);
}
//{^if[^jݒ
void DefaultLoadScene::SetData(unsigned int Num){
	FILETIME ft;
	HANDLE hFind;
	SYSTEMTIME st;
	WIN32_FIND_DATA fd;
	char LOAD_IDATA_TEXT[21];
	hFind = FindFirstFile(GetSaveFileName(m_nSelect*10+Num), &fd);
	if(hFind!=INVALID_HANDLE_VALUE){
		FileTimeToLocalFileTime(&fd.ftLastWriteTime, &ft);
		FileTimeToSystemTime(&ft, &st);
		sprintf(LOAD_IDATA_TEXT, "%02dF%04d/%02d/%02d %02d:%02d", m_nSelect*10+Num, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute);
		m_Data[Num].SetText(LOAD_IDATA_TEXT, "lr SVbN", 20);
		m_Data[Num].SetDisable(false);
	}
	else{
		sprintf(LOAD_IDATA_TEXT, "%02dF----/--/-- --:--", m_nSelect*10+Num);
		m_Data[Num].SetText(LOAD_IDATA_TEXT, "lr SVbN", 20);
		m_Data[Num].SetDisable(true);
	}
}



//ftHgRXgN^
DefaultConfigScene::DefaultConfigScene(){
	m_AutoModeTime.SetBorder(1);
	m_AutoModeTime.SetPosition(CreateRect(240, 75, 500, 10), CreateRect(-5, -15, 10, 30), 255);
	m_AutoModeTime.SetSound("", "");
	m_AutoModeTime.SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_AutoModeTime.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_DefaultTextSpeed.SetBorder(1);
	m_DefaultTextSpeed.SetPosition(CreateRect(240, 135, 500, 10), CreateRect(-5, -15, 10, 30), 255);
	m_DefaultTextSpeed.SetSound("", "");
	m_DefaultTextSpeed.SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_DefaultTextSpeed.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_DefaultBGMVolume.SetBorder(1);
	m_DefaultBGMVolume.SetPosition(CreateRect(240, 195, 500, 10), CreateRect(-5, -15, 10, 30), 255);
	m_DefaultBGMVolume.SetSound("", "");
	m_DefaultBGMVolume.SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_DefaultBGMVolume.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_DefaultSEVolume.SetBorder(1);
	m_DefaultSEVolume.SetPosition(CreateRect(240, 255, 500, 10), CreateRect(-5, -15, 10, 30), 255);
	m_DefaultSEVolume.SetSound("", "");
	m_DefaultSEVolume.SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_DefaultSEVolume.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_DefaultVoiceVolume.SetBorder(1);
	m_DefaultVoiceVolume.SetPosition(CreateRect(240, 315, 500, 10), CreateRect(-5, -15, 10, 30), 255);
	m_DefaultVoiceVolume.SetSound("", "");
	m_DefaultVoiceVolume.SetBarColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_DefaultVoiceVolume.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_WindowMode.SetBorder(1);
	m_WindowMode.SetPosition(CreateRect(70, 440, 150, 30), 255);
	m_WindowMode.SetSound("", "");
	m_WindowMode.SetText("EChE", "lr SVbN", 20);
	m_WindowMode.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_WindowMode.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_WindowMode.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_FullScreen.SetBorder(1);
	m_FullScreen.SetPosition(CreateRect(240, 440, 150, 30), 255);
	m_FullScreen.SetSound("", "");
	m_FullScreen.SetText("tXN[", "lr SVbN", 20);
	m_FullScreen.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_FullScreen.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_FullScreen.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_ForceSkipOn.SetBorder(1);
	m_ForceSkipOn.SetPosition(CreateRect(410, 440, 150, 30), 255);
	m_ForceSkipOn.SetSound("", "");
	m_ForceSkipOn.SetText("", "lr SVbN", 20);
	m_ForceSkipOn.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_ForceSkipOn.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_ForceSkipOn.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_ForceSkipOff.SetBorder(1);
	m_ForceSkipOff.SetPosition(CreateRect(580, 440, 150, 30), 255);
	m_ForceSkipOff.SetSound("", "");
	m_ForceSkipOff.SetText("Ȃ", "lr SVbN", 20);
	m_ForceSkipOff.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_ForceSkipOff.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_ForceSkipOff.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndConfig.SetBorder(1);
	m_EndConfig.SetPosition(CreateRect(620, 495, 120, 30), 255);
	m_EndConfig.SetSound("", "");
	m_EndConfig.SetText("߂", "lr SVbN", 20);
	m_EndConfig.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndConfig.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndConfig.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
}

//
void DefaultConfigScene::Initialize(){}

//O
void DefaultConfigScene::OnBegin(){}
//{
void DefaultConfigScene::OnMove(){
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	if(m_AutoModeTime.OnMove()){										//I[g[h̑ҋ@ԁF0-3000
		SetAutoModeTime();
	}
	if(m_DefaultTextSpeed.OnMove()){									//eLXg̕\xiftHgjF0-500
		SetDefaultTextSpeed();
	}
	if(m_DefaultBGMVolume.OnMove()){									//BGM̉ʁiftHgjF0-10000
		SetDefaultBGMVolume();
		if(Outer->GetSound()->IsBasedOnDefaultBGMVolume()){
			Outer->GetSound()->SetBGMVolumeIM(-1);
		}
	}
	if(m_DefaultSEVolume.OnMove()){										//SẺʁiftHgjF0-10000
		SetDefaultSEVolume();
		if(Outer->GetSound()->IsBasedOnDefaultSEVolume()){
			Outer->GetSound()->SetSEVolumeIM(-1);
		}
	}
	if(m_DefaultVoiceVolume.OnMove()){									//̉ʁiftHgjF0-10000
		SetDefaultVoiceVolume();
		if(Outer->GetSound()->IsBasedOnDefaultVoiceVolume()){
			Outer->GetSound()->SetVoiceVolumeIM(-1);
		}
	}
	if(m_WindowMode.OnMove() && Outer->GetDraw()->GetFullScreen()){		//EChE
		Outer->GetDraw()->SetFullScreen(false);
	}
	if(m_FullScreen.OnMove() && !Outer->GetDraw()->GetFullScreen()){	//tXN[
		Outer->GetDraw()->SetFullScreen(true);
	}
	if(m_ForceSkipOn.OnMove() && !Outer->GetText()->GetForceSkip()){	//XLbv
		Outer->GetText()->SetForceSkip(true);
	}
	if(m_ForceSkipOff.OnMove() && Outer->GetText()->GetForceSkip()){	//XLbvȂ
		Outer->GetText()->SetForceSkip(false);
	}
	if(m_EndConfig.OnMove()){											//ݒI
		Outer->PopState();
	}
	if(Outer->GetInput()->OnReturnConfig()){
		Outer->PopState();
	}
	//o[i`j̐ݒ
	UpdateAllBarRate();
	//{^i`j̐ݒ
	if(Outer->GetDraw()->GetFullScreen()){
		m_FullScreen.SetDisable(true);
		m_WindowMode.SetDisable(false);
	}
	else{
		m_FullScreen.SetDisable(false);
		m_WindowMode.SetDisable(true);
	}
	if(Outer->GetText()->GetForceSkip()){
		m_ForceSkipOn.SetDisable(true);
		m_ForceSkipOff.SetDisable(false);
	}
	else{
		m_ForceSkipOn.SetDisable(false);
		m_ForceSkipOff.SetDisable(true);
	}
}
//`
void DefaultConfigScene::OnDraw(){
	if(Outer->GetState()==ST_CONFIG){
		GETDRAW()->Clear();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		if(Outer->GetDraw()->GetTextWindowShow() || Outer->GetDraw()->GetTextWindowForceShow()){
			GETDRAW()->DrawTextWindow();
			GETDRAW()->DrawTalker();
			GETDRAW()->DrawText();
			GETDRAW()->DrawTextCursor();
		}
		GETDRAW()->DrawSelect();
		GETTASK()->ExecuteEffect3();
		GETDRAW()->DrawRect(CreateRect(0, 0, Outer->GetDraw()->GetScreenWidth(), Outer->GetDraw()->GetScreenHeight()), RGB(0, 0, 0), 128);
		GETDRAW()->DrawFreeText("I[gx", 60, 70, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("eLXg\x", 60, 130, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("BGM", 60, 190, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("SE", 60, 250, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("", 60, 310, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("ʐݒ", 190, 410, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		GETDRAW()->DrawFreeText("XLbv", 435, 410, 255, "lr SVbN", 20, RGB(255, 255, 255), false, false);
		m_AutoModeTime.OnDraw();
		m_DefaultTextSpeed.OnDraw();
		m_DefaultBGMVolume.OnDraw();
		m_DefaultSEVolume.OnDraw();
		m_DefaultVoiceVolume.OnDraw();
		m_WindowMode.OnDraw();
		m_FullScreen.OnDraw();
		m_ForceSkipOn.OnDraw();
		m_ForceSkipOff.OnDraw();
		m_EndConfig.OnDraw();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultConfigScene::OnEnd(){}

//eGWݒ
void DefaultConfigScene::SetParent(NovelPlayer* Parent){
	Outer = Parent;
	m_AutoModeTime.SetParent(Parent);
	m_DefaultTextSpeed.SetParent(Parent);
	m_DefaultBGMVolume.SetParent(Parent);
	m_DefaultSEVolume.SetParent(Parent);
	m_DefaultVoiceVolume.SetParent(Parent);
	m_WindowMode.SetParent(Parent);
	m_FullScreen.SetParent(Parent);
	m_ForceSkipOn.SetParent(Parent);
	m_ForceSkipOff.SetParent(Parent);
	m_EndConfig.SetParent(Parent);
}

//I[g[h̑ҋ@Ԃݒ
void DefaultConfigScene::SetAutoModeTime(){
	Outer->GetText()->SetAutoModeTime(m_AutoModeTime.GetRate()*3/10);
}
//eLXg̕\xiftHgjݒ
void DefaultConfigScene::SetDefaultTextSpeed(){
	Outer->GetDraw()->SetDefaultTextSpeed(m_DefaultTextSpeed.GetRate()/20);
}
//BGM̉ʁiftHgjݒ
void DefaultConfigScene::SetDefaultBGMVolume(){
	Outer->GetSound()->SetDefaultBGMVolume(m_DefaultBGMVolume.GetRate());
}
//SẺʁiftHgjݒ
void DefaultConfigScene::SetDefaultSEVolume(){
	Outer->GetSound()->SetDefaultSEVolume(m_DefaultSEVolume.GetRate());
}
//̉ʁiftHgjݒ
void DefaultConfigScene::SetDefaultVoiceVolume(){
	Outer->GetSound()->SetDefaultVoiceVolume(m_DefaultVoiceVolume.GetRate());
}
//SẴo[̊ꊇݒ
void DefaultConfigScene::UpdateAllBarRate(){
	m_AutoModeTime.SetRate(Outer->GetText()->GetAutoModeTime()*10/3);
	m_DefaultTextSpeed.SetRate(Outer->GetDraw()->GetDefaultTextSpeed()*20);
	m_DefaultBGMVolume.SetRate(Outer->GetSound()->GetDefaultBGMVolume());
	m_DefaultSEVolume.SetRate(Outer->GetSound()->GetDefaultSEVolume());
	m_DefaultVoiceVolume.SetRate(Outer->GetSound()->GetDefaultVoiceVolume());
}



//ftHgRXgN^
DefaultMenuScene::DefaultMenuScene(){
	m_Auto.SetBorder(1);
	m_Auto.SetPosition(CreateRect(640, 10, 150, 30), 255);
	m_Auto.SetSound("", "");
	m_Auto.SetText("I[g", "lr SVbN", 20);
	m_Auto.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_Auto.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Auto.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Skip.SetBorder(1);
	m_Skip.SetPosition(CreateRect(640, 45, 150, 30), 255);
	m_Skip.SetSound("", "");
	m_Skip.SetText("XLbv", "lr SVbN", 20);
	m_Skip.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_Skip.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Skip.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Save.SetBorder(1);
	m_Save.SetPosition(CreateRect(640, 80, 150, 30), 255);
	m_Save.SetSound("", "");
	m_Save.SetText("Z[u", "lr SVbN", 20);
	m_Save.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_Save.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Save.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Load.SetBorder(1);
	m_Load.SetPosition(CreateRect(640, 115, 150, 30), 255);
	m_Load.SetSound("", "");
	m_Load.SetText("[h", "lr SVbN", 20);
	m_Load.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_Load.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Load.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Config.SetBorder(1);
	m_Config.SetPosition(CreateRect(640, 150, 150, 30), 255);
	m_Config.SetSound("", "");
	m_Config.SetText("ݒ", "lr SVbN", 20);
	m_Config.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_Config.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_Config.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndGame.SetBorder(1);
	m_EndGame.SetPosition(CreateRect(640, 185, 150, 30), 255);
	m_EndGame.SetSound("", "");
	m_EndGame.SetText("Q[I", "lr SVbN", 20);
	m_EndGame.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndGame.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndGame.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndMenu.SetBorder(1);
	m_EndMenu.SetPosition(CreateRect(640, 220, 150, 30), 255);
	m_EndMenu.SetSound("", "");
	m_EndMenu.SetText("Q[ɖ߂", "lr SVbN", 20);
	m_EndMenu.SetButtonColor(RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0), RGB(0, 0, 0));
	m_EndMenu.SetTextColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
	m_EndMenu.SetBorderColor(RGB(255, 255, 255), RGB(192, 192, 192), RGB(128, 128, 128), RGB(128, 128, 128));
}

//
void DefaultMenuScene::Initialize(){}

//O
void DefaultMenuScene::OnBegin(){}
//{
void DefaultMenuScene::OnMove(){
	//͎t
	GETINPUT()->Flush();
	GETINPUT()->DecGuardTime();
	if(m_Auto.OnMove()){											//I[g[h
		Outer->GetText()->SetAutoMode(!Outer->GetText()->GetAutoMode());
		Outer->PopState();
	}
	if(m_Skip.OnMove()){											//XLbv
		Outer->GetText()->SetSkip(!Outer->GetText()->GetSkip());
		Outer->PopState();
	}
	if(m_Save.OnMove()){											//Z[u
		Outer->PushState(ST_SAVE);
	}
	if(m_Load.OnMove()){											//[h
		Outer->PushState(ST_LOAD);
	}
	if(m_Config.OnMove()){											//ݒ
		Outer->PushState(ST_CONFIG);
	}
	if(m_EndGame.OnMove()){											//Q[I
		if(Confirm()){
			Outer->GetSound()->StopBGM();
			Outer->GetSound()->StopAllSE();
			Outer->GetSound()->StopAllVoice();
			Outer->PushState(ST_ENDAPP);
		}
	}
	if(m_EndMenu.OnMove()){											//j[I
		Outer->PopState();
	}
	if(Outer->GetInput()->OnReturnMenu()){
		Outer->PopState();
	}
}
//`
void DefaultMenuScene::OnDraw(){
	if(Outer->GetState()==ST_MENU){
		GETDRAW()->Clear();
		GETDRAW()->OnDrawEX();
		GETTASK()->ExecuteEffect1();
		GETDRAW()->DrawTaskList();
		GETTASK()->ExecuteEffect2();
		if(Outer->GetDraw()->GetTextWindowShow() || Outer->GetDraw()->GetTextWindowForceShow()){
			GETDRAW()->DrawTextWindow();
			GETDRAW()->DrawTalker();
			GETDRAW()->DrawText();
			GETDRAW()->DrawTextCursor();
		}
		GETDRAW()->DrawSelect();
		GETTASK()->ExecuteEffect3();
		GETDRAW()->DrawRect(CreateRect(0, 0, Outer->GetDraw()->GetScreenWidth(), Outer->GetDraw()->GetScreenHeight()), RGB(0, 0, 0), 128);
		m_Auto.OnDraw();
		m_Skip.OnDraw();
		m_Save.OnDraw();
		m_Load.OnDraw();
		m_Config.OnDraw();
		m_EndGame.OnDraw();
		m_EndMenu.OnDraw();
		GETDRAW()->Flip();
	}
}
//㏈
void DefaultMenuScene::OnEnd(){}

//eGWݒ
void DefaultMenuScene::SetParent(NovelPlayer* Parent){
	Outer = Parent;
	m_Auto.SetParent(Parent);
	m_Skip.SetParent(Parent);
	m_Save.SetParent(Parent);
	m_Load.SetParent(Parent);
	m_Config.SetParent(Parent);
	m_EndGame.SetParent(Parent);
	m_EndMenu.SetParent(Parent);
}

//mF
bool DefaultMenuScene::Confirm(){
	return(MessageBox(Outer->GetMyAppHWND(), "I܂H", "mF", MB_YESNO)==IDYES);
}

}
}