#include "stdafx.h"
#include "index.h"
#include "SimulatedHeap.h"

namespace nsAbyssLib{
namespace nsSimulatedHeap{

//
void SingleHeap::Clear(){
	m_Heap.clear();
}
//擾
int SingleHeap::Get(const char* Text) const{
	if(m_Heap.find(Text)!=m_Heap.end()){
		return(m_Heap.find(Text)->second);
	}
	else{
		RuntimeError(NULL, "%s݂͑ȂV{łI", Text);
	}
}
//
bool SingleHeap::Find(const char* Text) const{
	return(m_Heap.find(Text)!=m_Heap.end());
}
//ǉ/ݒ
void SingleHeap::Set(const char* Text, int Value){
	//ݒ
	if(m_Heap.find(Text)!=m_Heap.end()){
		m_Heap.find(Text)->second = Value;
	}
	//ǉ
	else{
		m_Heap.insert(pair<string, int>(Text, Value));
	}
}
//e\
void SingleHeap::Print(const ITextStream* Output) const{
	if(Output){
		for(map<string, int>::const_iterator it=m_Heap.begin();it!=m_Heap.end();it++){
			Output->Out("%sF%d\n", it->first.c_str(), it->second);
		}
	}
}

//̂擾(1)
map<string, int>* SingleHeap::GetObj(){
	return(&m_Heap);
}
//̂擾(2)
const map<string, int>* SingleHeap::GetObj() const{
	return(&m_Heap);
}

//ۑ
void SingleHeap::Save(IIOStream* IOStream){
	SaveMapList(IOStream, m_Heap);
}
//ǂݍ
void SingleHeap::Load(IIOStream* IOStream){
	LoadMapList(IOStream, &m_Heap);
}



//ftHgRXgN^
CommandHeap::CommandHeap(){
	ClearIterator();
	PushIterator(-1);
}
//fXgN^
CommandHeap::~CommandHeap(){
	Clear();
}

//
void CommandHeap::Initialize(){
	for(vector<ICmd_Base*>::iterator it=m_Heap.begin();it!=m_Heap.end();it++){
		(*it)->Initialize();
		(*it)->SetParent(Outer);
	}
	ClearIterator();
	PushIterator(-1);
}

//eGWݒ
void CommandHeap::SetParent(INovelEngine* Parent){
	Outer = Parent;
}

//߂s
void CommandHeap::Run(){
	//G[`FbN
	if(m_Heap.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "߃Xg݂܂I");
	}
	if(m_Iterator.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "Ce[^݂܂I");
	}
	if(GetIterator()<0){
		RuntimeError(Outer->GetMyAppHWND(), "XNvgso܂IiCe[^0j");
	}
	if(GetIterator()>=static_cast<int>(GetObj()->size())){
		RuntimeError(Outer->GetMyAppHWND(), "XNvgso܂IiCe[^I[ȏj");
	}
	//߂s
	m_Heap.at(GetIterator())->Run();
}
//߃Xg
void CommandHeap::Clear(){
	for(vector<ICmd_Base*>::iterator it=m_Heap.begin();it!=m_Heap.end();it++){
		(*it)->Suicide();
	}
	m_Heap.clear();
}
//߂̓e\
void CommandHeap::Print(const ITextStream* Output) const{
	if(Output){
		for(unsigned int i=0;i<m_Heap.size();i++){
			Output->Out("%4dF", i);
			m_Heap.at(i)->Print(Output);
		}
	}
}
//߂VKɒǉ
void CommandHeap::Add(ICmd_Base* NewCommand, const CmdParam& Parameter){
	m_Heap.push_back(NewCommand);
	m_Heap.back()->SetParent(Outer);
	m_Heap.back()->SetParam(Parameter);
}

//̂擾(1)
vector<ICmd_Base*>* CommandHeap::GetObj(){
	return(&m_Heap);
}
//̂擾(2)
const vector<ICmd_Base*>* CommandHeap::GetObj() const{
	return(&m_Heap);
}

//ۑ
void CommandHeap::Save(IIOStream* IOStream){
	SaveTemplate(IOStream, static_cast<int>(m_Heap.size()));
	for(unsigned int i=0;i<m_Heap.size();i++){
		SaveTemplate(IOStream, m_Heap.at(i)->GetID());
		m_Heap.at(i)->Save(IOStream);
	}
}
//ǂݍ
void CommandHeap::Load(IIOStream* IOStream){
	Clear();
	int Loop;
	int CommandType;
	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		LoadTemplate(IOStream, &CommandType);
		m_Heap.push_back(CommandFactory(CommandType));
		m_Heap.back()->SetParent(Outer);
		m_Heap.back()->Load(IOStream);
	}
}

//Ce[^擾
int CommandHeap::GetIterator() const{
	if(m_Iterator.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "Ce[^݂͑܂I");
	}
	else{
		return(m_Iterator.back());
	}
}
//Ce[^Z
void CommandHeap::AddIterator(int it){
	if(m_Iterator.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "Ce[^݂͑܂I");
	}
	else{
		m_Iterator.back() += it;
	}
}
//Ce[^ݒ
void CommandHeap::SetIterator(int it){
	if(m_Iterator.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "Ce[^݂͑܂I");
	}
	else{
		m_Iterator.back() = it;
	}
}
//Ce[^|bv
void CommandHeap::PopIterator(){
	if(m_Iterator.empty()){
		RuntimeError(Outer->GetMyAppHWND(), "Ce[^͊ɑ݂܂I");
	}
	else{
		m_Iterator.pop_back();
	}
}
//Ce[^S
void CommandHeap::ClearIterator(){
	m_Iterator.clear();
}
//Ce[^vbV
void CommandHeap::PushIterator(int it){
	m_Iterator.push_back(it);
}
//Ce[^̓e\
void CommandHeap::PrintIterator(const ITextStream* Output) const{
	if(Output){
		for(unsigned int i=0;i<m_Iterator.size();i++){
			Output->Out("%dF%d\n", i, m_Iterator.at(i));
		}
	}
}

//Ce[^ۑ
void CommandHeap::SaveIterator(IIOStream* IOStream){
	SaveTemplate(IOStream, static_cast<int>(m_Iterator.size()));
	for(unsigned int i=0;i<m_Iterator.size();i++){
		SaveTemplate(IOStream, m_Iterator.at(i));
	}
}
//Ce[^ǂݍ
void CommandHeap::LoadIterator(IIOStream* IOStream){
	int Loop;
	ClearIterator();
	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		m_Iterator.push_back(0);
		LoadTemplate(IOStream, &m_Iterator.back());
	}
}

}
}