#include "stdafx.h"
#include "index.h"
#include "SoundManager.h"

namespace nsAbyssLib{
namespace nsSoundManager{

//ftHgRXgN^
BaseSoundManager::BaseSoundManager(){
	m_BGMName = "";
	m_IsPlayOnceBGM = false;
	SetDefaultSEVolume(DEFAULT_SE_VOLUME);
	SetDefaultBGMVolume(DEFAULT_BGM_VOLUME);
	SetDefaultVoiceVolume(DEFAULT_VOICE_VOLUME);
	SetSEVolume(-1);
	SetBGMVolume(-1);
	SetVoiceVolume(-1);
}

//
void BaseSoundManager::Initialize(){
	StopBGM();
	StopAllSE();
	UnloadAllSE();
	StopAllVoice();
	UnloadAllVoice();
	SetSEVolume(-1);
	SetBGMVolume(-1);
	SetVoiceVolume(-1);
}

//SẺʂ擾
long BaseSoundManager::GetSEVolume() const{
	if(IsBasedOnDefaultSEVolume()){
		return(m_DefaultSEVolume);
	}
	else{
		return(m_SEVolume);
	}
}
//BGM̉ʂ擾
long BaseSoundManager::GetBGMVolume() const{
	if(IsBasedOnDefaultBGMVolume()){
		return(m_DefaultBGMVolume);
	}
	else{
		return(m_BGMVolume);
	}
}
//̉ʂ擾
long BaseSoundManager::GetVoiceVolume() const{
	if(IsBasedOnDefaultVoiceVolume()){
		return(m_DefaultVoiceVolume);
	}
	else{
		return(m_VoiceVolume);
	}
}
//SẺʂݒ
void BaseSoundManager::SetSEVolume(long Volume){
	m_SEVolume = Volume;
}
//BGM̉ʂݒ
void BaseSoundManager::SetBGMVolume(long Volume){
	m_BGMVolume = Volume;
}
//̉ʂݒ
void BaseSoundManager::SetVoiceVolume(long Volume){
	m_VoiceVolume = Volume;
}
//SẺʂݒij
void BaseSoundManager::SetSEVolumeIM(long Volume){
	SetSEVolume(Volume);
	_SetSEVolume(GetSEVolume());
}
//BGM̉ʂݒij
void BaseSoundManager::SetBGMVolumeIM(long Volume){
	SetBGMVolume(Volume);
	_SetBGMVolume(GetBGMVolume());
}
//̉ʂݒij
void BaseSoundManager::SetVoiceVolumeIM(long Volume){
	SetVoiceVolume(Volume);
	_SetVoiceVolume(GetVoiceVolume());
}
//SẺʂ擾iftHgj
long BaseSoundManager::GetDefaultSEVolume() const{
	return(m_DefaultSEVolume);
}
//BGM̉ʂ擾iftHgj
long BaseSoundManager::GetDefaultBGMVolume() const{
	return(m_DefaultBGMVolume);
}
//̉ʂ擾iftHgj
long BaseSoundManager::GetDefaultVoiceVolume() const{
	return(m_DefaultVoiceVolume);
}
//SẺʂݒiftHgj
void BaseSoundManager::SetDefaultSEVolume(long Volume){
	if(Volume>=0 && Volume<=10000){
		m_DefaultSEVolume = Volume;
	}
	else{
		RuntimeError(NULL, "SẺʐݒiftHgjsłIi%dj", Volume);
	}
}
//BGM̉ʂݒiftHgj
void BaseSoundManager::SetDefaultBGMVolume(long Volume){
	if(Volume>=0 && Volume<=10000){
		m_DefaultBGMVolume = Volume;
	}
	else{
		RuntimeError(NULL, "BGM̉ʐݒiftHgjsłIi%dj", Volume);
	}
}
//̉ʂݒiftHgj
void BaseSoundManager::SetDefaultVoiceVolume(long Volume){
	if(Volume>=0 && Volume<=10000){
		m_DefaultVoiceVolume = Volume;
	}
	else{
		RuntimeError(NULL, "̉ʐݒiftHgjsłIi%dj", Volume);
	}
}
//SẼftHgʂɌ݂̉ʂĂ邩H
bool BaseSoundManager::IsBasedOnDefaultSEVolume() const{
	return(m_SEVolume>10000 || m_SEVolume<0);
}
//BGM̃ftHgʂɌ݂̉ʂĂ邩H
bool BaseSoundManager::IsBasedOnDefaultBGMVolume() const{
	return(m_BGMVolume>10000 || m_BGMVolume<0);
}
//̃ftHgʂɌ݂̉ʂĂ邩H
bool BaseSoundManager::IsBasedOnDefaultVoiceVolume() const{
	return(m_VoiceVolume>10000 || m_VoiceVolume<0);
}

//ۑiݒj
void BaseSoundManager::SaveE(IIOStream* IOStream){
	SaveTemplate(IOStream, m_DefaultSEVolume);
	SaveTemplate(IOStream, m_DefaultBGMVolume);
	SaveTemplate(IOStream, m_DefaultVoiceVolume);
}
//ǂݍ݁iݒj
void BaseSoundManager::LoadE(IIOStream* IOStream){
	LoadTemplate(IOStream, &m_DefaultSEVolume);
	LoadTemplate(IOStream, &m_DefaultBGMVolume);
	LoadTemplate(IOStream, &m_DefaultVoiceVolume);
}
//ۑi[Jj
void BaseSoundManager::SaveL(IIOStream* IOStream){
	SaveTemplate(IOStream, m_SEVolume);
	SaveTemplate(IOStream, m_BGMVolume);
	SaveTemplate(IOStream, m_VoiceVolume);
	SaveStringS(IOStream, m_BGMName);
	SaveTemplate(IOStream, m_IsPlayOnceBGM);
}
//ǂݍ݁i[Jj
void BaseSoundManager::LoadL(IIOStream* IOStream){
	StopBGM();
	StopAllSE();
	StopAllVoice();
	LoadTemplate(IOStream, &m_SEVolume);
	LoadTemplate(IOStream, &m_BGMVolume);
	LoadTemplate(IOStream, &m_VoiceVolume);
	bool bData;
	string sData;
	LoadStringS(IOStream, &sData);
	LoadTemplate(IOStream, &bData);
	if(bData){
		if(!PlayOnceBGM(sData.c_str())){
			RuntimeWarning(NULL, "BGMi%sjĐo܂Iiplayoncej", sData.c_str());
		}
	}
	else{
		if(!PlayBGM(sData.c_str())){
			RuntimeWarning(NULL, "BGMi%sjĐo܂Iiplayj", sData.c_str());
		}
	}
}

//SSE~
bool BaseSoundManager::StopAllSE(){
	bool Result = true;
	for(vector<string>::iterator it=m_SEName.begin();it!=m_SEName.end();it++){
		Result &= StopSE(it->c_str());
	}
	return(Result);
}
//SSE
bool BaseSoundManager::UnloadAllSE(){
	bool Result = true, Result2;
	vector<string>::iterator it = m_SEName.begin();
	while(it!=m_SEName.end()){
		if((Result2=UnloadSE(it->c_str()))!=0){
			it = m_SEName.begin();
		}
		else{
			it++;
		}
		Result &= Result2;
	}
	return(Result);
}
//SEĐ
bool BaseSoundManager::PlaySE(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(find(m_SEName.begin(), m_SEName.end(), FileName)==m_SEName.end()){
		if(!LoadSE(FileName)){
			return(false);
		}
	}
	_SetSEVolume(GetSEVolume());
	return(_PlaySE(FileName));
}
//SE~
bool BaseSoundManager::StopSE(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(find(m_SEName.begin(), m_SEName.end(), FileName)==m_SEName.end()){
		return(true);
	}
	if(!_IsPlayingSE(FileName)){
		return(true);
	}
	return(_StopSE(FileName));
}
//SEɓǂݍ
bool BaseSoundManager::LoadSE(const char* FileName){
	if(!strcmp(FileName, "") || find(m_SEName.begin(), m_SEName.end(), FileName)!=m_SEName.end()){
		return(true);
	}
	if(find(m_SEName.begin(), m_SEName.end(), FileName)==m_SEName.end()){
		m_SEName.push_back(FileName);
		if(_LoadSE(FileName)){
			return(true);
		}
		m_SEName.pop_back();
	}
	return(false);
}
//SE
bool BaseSoundManager::UnloadSE(const char* FileName){
	if(!strcmp(FileName, "") || find(m_SEName.begin(), m_SEName.end(), FileName)==m_SEName.end()){
		return(true);
	}
	if(find(m_SEName.begin(), m_SEName.end(), FileName)!=m_SEName.end()){
		if(_IsPlayingSE(FileName)){
			if(!StopSE(FileName)){
				return(false);
			}
		}
		if(!_UnloadSE(FileName)){
			return(false);
		}
		m_SEName.erase(find(m_SEName.begin(), m_SEName.end(), FileName));
		return(true);
	}
	return(false);
}

//BGM~
bool BaseSoundManager::StopBGM(){
	if(m_BGMName=="" || !_IsPlayingBGM()){
		return(true);
	}
	if(_StopBGM()){
		m_BGMName = "";
		m_IsPlayOnceBGM = false;
		return(true);
	}
	else{
		return(false);
	}
}
//BGMĐ
bool BaseSoundManager::PlayBGM(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(m_BGMName==FileName && !m_IsPlayOnceBGM){
		return(true);
	}
	else{
		if(_IsPlayingBGM()){
			if(!StopBGM()){
				return(false);
			}
		}
		if(m_BGMName!=FileName && !_LoadBGM(FileName)){
			return(false);
		}
	}
	_SetBGMVolume(GetBGMVolume());
	if(_PlayBGM(false)){
		m_BGMName = FileName;
		m_IsPlayOnceBGM = false;
		return(true);
	}
	else{
		m_BGMName = "";
		m_IsPlayOnceBGM = false;
		return(false);
	}
}
//BGMxĐ
bool BaseSoundManager::PlayOnceBGM(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(m_BGMName==FileName && m_IsPlayOnceBGM){
		return(true);
	}
	else{
		if(_IsPlayingBGM()){
			if(!StopBGM()){
				return(false);
			}
		}
		if(m_BGMName!=FileName && !_LoadBGM(FileName)){
			return(false);
		}
	}
	_SetBGMVolume(GetBGMVolume());
	if(_PlayBGM(true)){
		m_BGMName = FileName;
		m_IsPlayOnceBGM = true;
		return(true);
	}
	else{
		m_BGMName = "";
		m_IsPlayOnceBGM = true;
		return(false);
	}
}
//BGM
bool BaseSoundManager::UnloadBGM(){
	if(_IsPlayingBGM()){
		if(!StopBGM()){
			return(false);
		}
	}
	if(!_UnloadBGM()){
		return(false);
	}
	m_BGMName = "";
	return(true);
}

//S~
bool BaseSoundManager::StopAllVoice(){
	bool Result = true;
	for(vector<string>::iterator it=m_VoiceName.begin();it!=m_VoiceName.end();it++){
		Result &= StopVoice(it->c_str());
	}
	return(Result);
}
//S
bool BaseSoundManager::UnloadAllVoice(){
	bool Result = true, Result2;
	vector<string>::iterator it = m_VoiceName.begin();
	while(it!=m_VoiceName.end()){
		if((Result2=UnloadVoice(it->c_str()))!=0){
			it = m_VoiceName.begin();
		}
		else{
			it++;
		}
		Result &= Result2;
	}
	return(Result);
}
//Đ
bool BaseSoundManager::PlayVoice(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(find(m_VoiceName.begin(), m_VoiceName.end(), FileName)==m_VoiceName.end()){
		if(!LoadVoice(FileName)){
			return(false);
		}
	}
	_SetVoiceVolume(GetVoiceVolume());
	return(_PlayVoice(FileName));
}
//~
bool BaseSoundManager::StopVoice(const char* FileName){
	if(!strcmp(FileName, "")){
		return(true);
	}
	if(find(m_VoiceName.begin(), m_VoiceName.end(), FileName)==m_VoiceName.end()){
		return(true);
	}
	if(!_IsPlayingVoice(FileName)){
		return(true);
	}
	return(_StopVoice(FileName));
}
//ɓǂݍ
bool BaseSoundManager::LoadVoice(const char* FileName){
	if(!strcmp(FileName, "") || find(m_VoiceName.begin(), m_VoiceName.end(), FileName)!=m_VoiceName.end()){
		return(true);
	}
	if(find(m_VoiceName.begin(), m_VoiceName.end(), FileName)==m_VoiceName.end()){
		m_VoiceName.push_back(FileName);
		if(_LoadVoice(FileName)){
			return(true);
		}
		m_VoiceName.pop_back();
	}
	return(false);
}
//
bool BaseSoundManager::UnloadVoice(const char* FileName){
	if(!strcmp(FileName, "") || find(m_VoiceName.begin(), m_VoiceName.end(), FileName)==m_VoiceName.end()){
		return(true);
	}
	if(find(m_VoiceName.begin(), m_VoiceName.end(), FileName)!=m_VoiceName.end()){
		if(_IsPlayingVoice(FileName)){
			if(!StopVoice(FileName)){
				return(false);
			}
		}
		if(!_UnloadVoice(FileName)){
			return(false);
		}
		m_VoiceName.erase(find(m_VoiceName.begin(), m_VoiceName.end(), FileName));
		return(true);
	}
	return(false);
}

//SEgpĂ邩H
bool BaseSoundManager::IsUsedSE(const char* FileName) const{
	return(find(m_SEName.begin(), m_SEName.end(), FileName)!=m_SEName.end() && _IsPlayingSE(FileName));
}
//BGMgpĂ邩H
bool BaseSoundManager::IsUsedBGM(const char* FileName) const{
	return(m_BGMName==FileName && _IsPlayingBGM());
}
//gpĂ邩H
bool BaseSoundManager::IsUsedVoice(const char* FileName) const{
	return(find(m_VoiceName.begin(), m_VoiceName.end(), FileName)!=m_VoiceName.end() && _IsPlayingVoice(FileName));
}

}
}