#include "stdafx.h"
#include "index.h"
#include "TaskManager.h"

namespace nsAbyssLib{
namespace nsTaskManager{

//``FbN
static bool IsValidRect(RECT Rect){
	return(Rect.top<=Rect.bottom && Rect.left<=Rect.right);
}
//``FbNiRŁj
static bool IsValidNNRect(RECT Rect){
	return(Rect.top<=Rect.bottom && Rect.left<=Rect.right && Rect.top>=0 && Rect.left>=0);
}



//ftHgRXgN^
TaskManager::TaskManager(){
	Initialize();
}

//
void TaskManager::Initialize(){
	SetMaxZ(DEFAULT_MAX_Z);
	SetMinZ(DEFAULT_MIN_Z);
	SetReservedZBG(DEFAULT_RESERVED_Z_BG);
	SetReservedZCh1(DEFAULT_RESERVED_Z_CH1);
	SetReservedZCh2(DEFAULT_RESERVED_Z_CH2);
	SetReservedZCh3(DEFAULT_RESERVED_Z_CH3);
	m_TaskList.clear();
	m_BG.Clear();
	m_LCh.Clear();
	m_CCh.Clear();
	m_RCh.Clear();
	m_Sprite.clear();
	m_Button.clear();
	SetCharaSpace(DEFAULT_CHARA_SPACE);
	m_ChPriority[0] = DEFAULT_CHPRIORITY;
	m_ChPriority[1] = DEFAULT_CHPRIORITY;
	m_DrawTaskIterator = 0;
	m_UpdateData.Clear();
	m_EffectData.Clear();
	BRCS.clear(); IsBRCS = true;
	BVCS[0].clear(); BVCS[1].clear(); IsBVCS = false;
	ZeroMemory(UpdateI, sizeof(UpdateI));
	ZeroMemory(UpdateBy, sizeof(UpdateBy));
	ZeroMemory(UpdateDw, sizeof(UpdateDw));
	ZeroMemory(UpdateD, sizeof(UpdateD));
	UpdateS[0] = "";	UpdateS[1] = "";	UpdateS[2] = "";	UpdateS[3] = "";
	ZeroMemory(UpdateC, sizeof(UpdateC));
	ZeroMemory(EffectI, sizeof(EffectI));
	ZeroMemory(EffectBy, sizeof(EffectBy));
	ZeroMemory(EffectDw, sizeof(EffectDw));
	ZeroMemory(EffectD, sizeof(EffectD));
	EffectS[0] = "";	EffectS[1] = "";	EffectS[2] = "";	EffectS[3] = "";
	ZeroMemory(EffectC, sizeof(EffectC));
}

//eGWݒ
void TaskManager::SetParent(INovelEngine* Parent){
	Outer = Parent;
}

//őZݒ
void TaskManager::SetMaxZ(int z){
	m_MaxZ = z;
}
//ŏZݒ
void TaskManager::SetMinZ(int z){
	m_MinZ = z;
}
//\ςZWiwijݒ
void TaskManager::SetReservedZBG(int z){
	m_RZBG = z;
}
//\ςZWiG1jݒ
void TaskManager::SetReservedZCh1(int z){
	m_RZCh1 = z;
}
//\ςZWiG2jݒ
void TaskManager::SetReservedZCh2(int z){
	m_RZCh2 = z;
}
//\ςZWiG3jݒ
void TaskManager::SetReservedZCh3(int z){
	m_RZCh3 = z;
}

//wiݒ
void TaskManager::SetBG(const DrawTask& Task){
	if(!IsValidNNRect(Task.SrcRect)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\nim_BG.SrcRect = {%d, %d, %d, %d}j",
			Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
	m_BG.SpriteTask[1-m_DrawTaskIterator] = Task;
	Outer->GetDraw()->LoadImage(Task.FileName.c_str());
}
//Gݒ
void TaskManager::SetLCh(const DrawTask& Task){
	if(!IsValidNNRect(Task.SrcRect)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\nim_LCh.SrcRect = {%d, %d, %d, %d}j",
			Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
	m_LCh.SpriteTask[1-m_DrawTaskIterator] = Task;
	Outer->GetDraw()->LoadImage(Task.FileName.c_str());
}
//Gݒ
void TaskManager::SetCCh(const DrawTask& Task){
	if(!IsValidNNRect(Task.SrcRect)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\nim_CCh.SrcRect = {%d, %d, %d, %d}j",
			Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
	m_CCh.SpriteTask[1-m_DrawTaskIterator] = Task;
	Outer->GetDraw()->LoadImage(Task.FileName.c_str());
}
//EGݒ
void TaskManager::SetRCh(const DrawTask& Task){
	if(!IsValidNNRect(Task.SrcRect)){
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\nim_RCh.SrcRect = {%d, %d, %d, %d}j",
			Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
	m_RCh.SpriteTask[1-m_DrawTaskIterator] = Task;
	Outer->GetDraw()->LoadImage(Task.FileName.c_str());
}
//G̗D揇ʂݒ
void TaskManager::SetChPriority(unsigned int ChPriority){
	if(ChPriority>=CHPRIORITY_LCR && ChPriority<=CHPRIORITY_RLC){
		m_ChPriority[1-m_DrawTaskIterator] = ChPriority;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "D揇ʂ̎w肪ԈĂ܂IiChPriority = %dj", ChPriority);
	}
}
//GƉʍE[̊Ԋuݒ
void TaskManager::SetCharaSpace(unsigned int Space){
	m_CharaSpace = Space;
}

//VKǉ
void TaskManager::AddSprite(const char* SpriteName){
	if(!FindSprite(SpriteName)){
		m_Sprite.insert(pair<string, Sprite>(SpriteName, Sprite()));
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s͊ɑ݂XvCgłI", SpriteName);
	}
}
//݂邩H
bool TaskManager::FindSprite(const char* SpriteName) const{
	return(m_Sprite.find(SpriteName)!=m_Sprite.end());
}
//S\/\
void TaskManager::SetAllSpriteShow(bool IsShow){
	for(map<string, Sprite>::iterator it=m_Sprite.begin();it!=m_Sprite.end();it++){
		it->second.SpriteTask[1-m_DrawTaskIterator].IsShow = IsShow;
	}
}
//\/\
void TaskManager::SetSpriteShow(const char* SpriteName, bool IsShow){
	if(FindSprite(SpriteName)){
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].IsShow = IsShow;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂXvCgłI", SpriteName);
	}
}
//ړi΍Wj
void TaskManager::SetSprite(const char* SpriteName, int x, int y, int z, BYTE a){
	if(FindSprite(SpriteName)){
		if(z>m_MaxZ || z<m_MinZ){
			RuntimeError(Outer->GetMyAppHWND(), "͈͊Ow肳Ă܂IiZ = %dj", z);
		}
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].x = x;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].y = y;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].z = z;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a = a;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂXvCgłI", SpriteName);
	}
}
//ړi΍Wj
void TaskManager::MoveSprite(const char* SpriteName, int x, int y, int z, int a){
	if(FindSprite(SpriteName)){
		if(m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].z+z>m_MaxZ ||
		   m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].z+z<m_MinZ){
			RuntimeError(
				Outer->GetMyAppHWND(),
				"͈͊Ow肳Ă܂IiZ = %d + %dj",
				m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].z, z
			);
		}
		if(m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a+a>255 ||
		   m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a+a<0){
			RuntimeError(
				Outer->GetMyAppHWND(),
				"ߓx255𒴂Ă܂IiA = %d + %dj",
				m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a, a
			);
		}
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].x += x;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].y += y;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].z += z;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a = static_cast<BYTE>(m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].a + a);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂXvCgłI", SpriteName);
	}
}
//摜ݒ
void TaskManager::SetSpriteImage(const char* SpriteName, const char* FileName, unsigned int BltType, RECT Image, float ScalingX, float ScalingY, float Degree){
	if(FindSprite(SpriteName)){
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].FileName = FileName;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].Type = TYPE_GRAPHIC;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].BltType = BltType;
		if(IsValidNNRect(Image)){
			m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].SrcRect = Image;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"]`̎w肪ԈĂ܂I\ni%s.SrcRect = {%d, %d, %d, %d}j",
				SpriteName, Image.left, Image.top, Image.right, Image.bottom
			);
		}
		if(ScalingX>0.0f){
			m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].ScalingX = ScalingX;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"g{iXj0܂͕łI\ni%s.ScalingX = %fj",
				SpriteName, ScalingX
			);
		}
		if(ScalingY>0.0f){
			m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].ScalingY = ScalingY;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"g{iYj0܂͕łI\ni%s.ScalingY = %fj",
				SpriteName, ScalingY
			);
		}
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].Degree = Degree;
		Outer->GetDraw()->LoadImage(FileName);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂXvCgłI", SpriteName);
	}
}
//eLXgݒ
void TaskManager::SetSpriteText(const char* SpriteName, const TextTokenSection& Text){
	if(FindSprite(SpriteName)){
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].Type = TYPE_TEXT;
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator].Text = Text;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂXvCgłI", SpriteName);
	}
}
//XvCgݒ
void TaskManager::SetSprite(const char* SpriteName, const DrawTask& Task){
	if(IsValidNNRect(Task.SrcRect)){
		m_Sprite.find(SpriteName)->second.SpriteTask[1-m_DrawTaskIterator] = Task;
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\ni%s.SrcRect = {%d, %d, %d, %d}j",
			SpriteName, Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
}

//VKǉ
void TaskManager::AddButton(const char* ButtonName){
	if(IsBRCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBRCSj");
	}
	if(IsBVCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBVCSj");
	}
	if(!FindButton(ButtonName)){
		m_Button.insert(pair<string, Button>(ButtonName, Button()));
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s͊ɑ݂{^łI", ButtonName);
	}
}
//݂邩H
bool TaskManager::FindButton(const char* ButtonName) const{
	return(m_Button.find(ButtonName)!=m_Button.end());
}
//S\/\
void TaskManager::SetAllButtonShow(bool IsShow){
	if(IsBVCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBVCSj");
	}
	for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
		it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].IsShow = IsShow;
	}
}
//\/\
void TaskManager::SetButtonShow(const char* ButtonName, bool IsShow){
	if(IsBVCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBVCSj");
	}
	if(FindButton(ButtonName)){
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].IsShow = IsShow;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//SL/
void TaskManager::SetAllButtonEnable(bool IsEnable){
	if(IsBRCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBRCSj");
	}
	for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
		it->second.IsEnable = IsEnable;
	}
}
//L/
void TaskManager::SetButtonEnable(const char* ButtonName, bool IsEnable){
	if(IsBRCS){
		RuntimeError(Outer->GetMyAppHWND(), "r䒆łIiBRCSj");
	}
	if(FindButton(ButtonName)){
		m_Button.find(ButtonName)->second.IsEnable = IsEnable;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//ړi΍Wj
void TaskManager::SetButton(const char* ButtonName, int x, int y, int z, BYTE a){
	if(FindButton(ButtonName)){
		if(z>m_MaxZ || z<m_MinZ){
			RuntimeError(Outer->GetMyAppHWND(), "͈͊Ow肳Ă܂IiZ = %dj", z);
		}
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].x = x;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].y = y;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].z = z;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a = a;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//ړi΍Wj
void TaskManager::MoveButton(const char* ButtonName, int x, int y, int z, int a){
	if(FindButton(ButtonName)){
		if(m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].z+z>m_MaxZ ||
		   m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].z+z<m_MinZ){
			RuntimeError(
				Outer->GetMyAppHWND(),
				"͈͊Ow肳Ă܂IiZ = %d + %dj",
				m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].z, z
			);
		}
		if(m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a+a>255 ||
		   m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a+a<0){
			RuntimeError(
				Outer->GetMyAppHWND(),
				"ߓx255𒴂Ă܂IiA = %d + %dj",
				m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a, a
			);
		}
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].x += x;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].y += y;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].z += z;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a = static_cast<BYTE>(m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].a + a);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//摜ݒ
void TaskManager::SetButtonImage(const char* ButtonName, const char* FileName, unsigned int BltType, RECT Normal, RECT OnCursor, RECT OnHold, RECT Disable, float ScalingX, float ScalingY, float Degree){
	if(FindButton(ButtonName)){
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].FileName = FileName;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].Type = TYPE_GRAPHIC;
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].BltType = BltType;
		if(IsValidNNRect(Normal)){
			m_Button.find(ButtonName)->second.SrcRect[1-m_DrawTaskIterator][0] = Normal;
			m_Button.find(ButtonName)->second.ClickRect.top = 0;
			m_Button.find(ButtonName)->second.ClickRect.left = 0;
			m_Button.find(ButtonName)->second.ClickRect.right = Normal.right - Normal.left;
			m_Button.find(ButtonName)->second.ClickRect.bottom = Normal.bottom - Normal.top;
			m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = Normal;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"]`̎w肪ԈĂ܂I\ni%s.SrcRect[Normal] = {%d, %d, %d, %d}j",
				ButtonName, Normal.left, Normal.top, Normal.right, Normal.bottom
			);
		}
		if(IsValidNNRect(OnCursor)){
			m_Button.find(ButtonName)->second.SrcRect[1-m_DrawTaskIterator][1] = OnCursor;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"]`̎w肪ԈĂ܂I\ni%s.SrcRect[OnCursor] = {%d, %d, %d, %d}j",
				ButtonName, OnCursor.left, OnCursor.top, OnCursor.right, OnCursor.bottom
			);
		}
		if(IsValidNNRect(OnHold)){
			m_Button.find(ButtonName)->second.SrcRect[1-m_DrawTaskIterator][2] = OnHold;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"]`̎w肪ԈĂ܂I\ni%s.SrcRect[OnHold] = {%d, %d, %d, %d}j",
				ButtonName, OnHold.left, OnHold.top, OnHold.right, OnHold.bottom
			);
		}
		if(IsValidNNRect(Disable)){
			m_Button.find(ButtonName)->second.SrcRect[1-m_DrawTaskIterator][3] = Disable;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"]`̎w肪ԈĂ܂I\ni%s.SrcRect[Disable] = {%d, %d, %d, %d}j",
				ButtonName, Disable.left, Disable.top, Disable.right, Disable.bottom
			);
		}
		if(ScalingX>0.0f){
			m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].ScalingX = ScalingX;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"g{iXj0܂͕łI\ni%s.ScalingX = %fj",
				ButtonName, ScalingX
			);
		}
		if(ScalingY>0.0f){
			m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].ScalingY = ScalingY;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"g{iYj0܂͕łI\ni%s.ScalingY = %fj",
				ButtonName, ScalingY
			);
		}
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].Degree = Degree;
		Outer->GetDraw()->LoadImage(FileName);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//{^ݒ
void TaskManager::SetButton(const char* ButtonName, const DrawTask& Task){
	if(IsValidNNRect(Task.SrcRect)){
		m_Button.find(ButtonName)->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator] = Task;
	}
	else{
		RuntimeError(
			Outer->GetMyAppHWND(), 
			"]`̎w肪ԈĂ܂I\ni%s.SrcRect = {%d, %d, %d, %d}j",
			ButtonName, Task.SrcRect.left, Task.SrcRect.top, Task.SrcRect.right, Task.SrcRect.bottom
		);
	}
}
//`ݒ
void TaskManager::SetButtonClickRect(const char* ButtonName, RECT ClickRect){
	if(FindButton(ButtonName)){
		if(IsValidRect(ClickRect)){
			m_Button.find(ButtonName)->second.ClickRect = ClickRect;
		}
		else{
			RuntimeError(
				Outer->GetMyAppHWND(), 
				"`̎w肪ԈĂ܂I\ni%s.ClickRect = {%d, %d, %d, %d}j",
				ButtonName, ClickRect.left, ClickRect.top, ClickRect.right, ClickRect.bottom
			);
		}
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//ړ惉xݒ
void TaskManager::SetButtonDestLabel(const char* ButtonName, const char* DestLabel){
	if(FindButton(ButtonName)){
		if(Outer->GetLabel()->Find(DestLabel)){
			m_Button.find(ButtonName)->second.DestLabel = DestLabel;
		}
		else{
			RuntimeError(Outer->GetMyAppHWND(), "%s݂͑ȂxłI", DestLabel);
		}
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//J[\/NbNSEݒ
void TaskManager::SetButtonSound(const char* ButtonName, const char* OnCursor, const char* OnClick){
	if(FindButton(ButtonName)){
		m_Button.find(ButtonName)->second.OnClickSE = OnClick;
		m_Button.find(ButtonName)->second.OnCursorSE = OnCursor;
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "%s݂͑Ȃ{^łI", ButtonName);
	}
}
//Ԃ𒲂ׂčXV
void TaskManager::CheckButton(){
	int X, Y;
	Outer->GetInput()->GetXY(X, Y);
	//͂m摜ݒ
	for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
		//͎tL
		if(it->second.IsEnable){
			//͂m
			if(it->second.IsCursored){
				it->second.IsCursored = (X>=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].x+it->second.ClickRect.left &&
										 X<=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].x+it->second.ClickRect.right &&
										 Y>=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].y+it->second.ClickRect.top &&
										 Y<=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].y+it->second.ClickRect.bottom);
			}
			else{
				if(X>=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].x+it->second.ClickRect.left &&
				   X<=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].x+it->second.ClickRect.right &&
				   Y>=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].y+it->second.ClickRect.top &&
				   Y<=it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].y+it->second.ClickRect.bottom){
					Outer->GetSound()->PlaySE(it->second.OnCursorSE.c_str());
					it->second.IsCursored = true;
				}
			}
			if(it->second.IsPushed){
				it->second.IsPushed = (it->second.IsCursored && Outer->GetInput()->OnHoldButton());
				if(it->second.IsPushed){
					Outer->GetInput()->SetGuardTime(1);
				}
				else{
					if(it->second.IsCursored && Outer->GetInput()->OnClickButton()){
						Outer->GetCommand()->PushIterator(Outer->GetLabel()->Get(it->second.DestLabel.c_str()));
					}
				}
			}
			else{
				if(it->second.IsCursored && Outer->GetInput()->OnPushButton()){
					Outer->GetSound()->PlaySE(it->second.OnClickSE.c_str());
					Outer->GetInput()->SetGuardTime(1);
					it->second.IsPushed = true;
				}
			}
			//摜ݒ
			//ʏ펞
			it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].SrcRect = it->second.SrcRect[m_DrawTaskIterator][0];
			it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = it->second.SrcRect[1-m_DrawTaskIterator][0];
			//J[\
			if(it->second.IsCursored){
				it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].SrcRect = it->second.SrcRect[m_DrawTaskIterator][1];
				it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = it->second.SrcRect[1-m_DrawTaskIterator][1];
			}
			//z[h
			if(it->second.IsCursored && Outer->GetInput()->OnHoldButton()){
				it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].SrcRect = it->second.SrcRect[m_DrawTaskIterator][2];
				it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = it->second.SrcRect[1-m_DrawTaskIterator][2];
			}
		}
		//͎t
		else{
			//摜ݒ
			//
			it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].SrcRect = it->second.SrcRect[m_DrawTaskIterator][3];
			it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = it->second.SrcRect[1-m_DrawTaskIterator][3];
			//BRCS
			if(IsBRCS && BRCS.find(it->first)->second){
				it->second.ButtonTask.SpriteTask[m_DrawTaskIterator].SrcRect = it->second.SrcRect[m_DrawTaskIterator][0];
				it->second.ButtonTask.SpriteTask[1-m_DrawTaskIterator].SrcRect = it->second.SrcRect[1-m_DrawTaskIterator][0];
			}
		}
	}
}
//m̔riJnj
void TaskManager::EnterBRCS(){
	if(IsBRCS){
		RuntimeError(Outer->GetMyAppHWND(), "ɔr䒆łIiBRCSj");
	}
	else{
		IsBRCS = true;
		for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
			BRCS.insert(pair<string, bool>(it->first, it->second.IsEnable));
			it->second.IsEnable = false;
		}
	}
}
//m̔riIj
void TaskManager::LeaveBRCS(){
	if(!IsBRCS){
		RuntimeError(Outer->GetMyAppHWND(), "ɔrOłIiBRCSj");
	}
	else{
		IsBRCS = false;
		if(!BRCS.empty()){
			for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
				it->second.IsEnable = BRCS.find(it->first)->second;
			}
		}
		BRCS.clear();
	}
}
//\̔riJnj
void TaskManager::EnterBVCS(){
	if(IsBVCS){
		RuntimeError(Outer->GetMyAppHWND(), "ɔr䒆łIiBVCSj");
	}
	else{
		IsBVCS = true;
		for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
			BVCS[0].insert(pair<string, bool>(it->first, it->second.ButtonTask.SpriteTask[0].IsShow));
			BVCS[1].insert(pair<string, bool>(it->first, it->second.ButtonTask.SpriteTask[1].IsShow));
			it->second.ButtonTask.SpriteTask[0].IsShow = false;
			it->second.ButtonTask.SpriteTask[1].IsShow = false;
		}
	}
}
//\̔riIj
void TaskManager::LeaveBVCS(){
	if(!IsBVCS){
		RuntimeError(Outer->GetMyAppHWND(), "ɔrOłIiBVCSj");
	}
	else{
		IsBVCS = false;
		if(!BVCS[0].empty() && !BVCS[1].empty()){
			for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
				it->second.ButtonTask.SpriteTask[0].IsShow = BVCS[0].find(it->first)->second;
				it->second.ButtonTask.SpriteTask[1].IsShow = BVCS[1].find(it->first)->second;
			}
		}
		BVCS[0].clear();
		BVCS[1].clear();
	}
}

//^XNXg\z
void TaskManager::Update(){
	if(PUpdate.find(m_UpdateData.Type)!=PUpdate.end()){
		PUpdate.find(m_UpdateData.Type)->second(Outer);
	}
	else{
		if(m_UpdateData.Type==UPDATETYPE_NONE){
			SetTMAccessor(Outer);
			GetTMAccessor()->ClearTaskList();

			unsigned int SpriteNum = 0;
			unsigned int ButtonNum = 0;
			Sprite* _Sprite[1024] = {0};
			Button* _Button[1024] = {0};
			ITMAccessor* TMA = GetTMAccessor();
			unsigned int DTI = TMA->GetDrawTaskIterator();
			TMA->SetChLocation();
			TMA->PushTaskList(TMA->GetBG().SpriteTask[DTI]);
			TMA->PushTaskList(TMA->GetLCh().SpriteTask[DTI]);
			TMA->PushTaskList(TMA->GetCCh().SpriteTask[DTI]);
			TMA->PushTaskList(TMA->GetRCh().SpriteTask[DTI]);
			TMA->GetSprite(SpriteNum, _Sprite);
			for(unsigned int i=0;i<SpriteNum;i++){
				TMA->PushTaskList(_Sprite[i]->SpriteTask[DTI]);
			}
			TMA->GetButton(ButtonNum, _Button);
			for(unsigned int i=0;i<ButtonNum;i++){
				TMA->PushTaskList(_Button[i]->ButtonTask.SpriteTask[DTI]);
			}
			TMA->ZSortTaskList();
		}
		else{
			RuntimeError(Outer->GetMyAppHWND(), "sȍXVp^[łIim_UpdateData.Type=%dj", m_UpdateData.Type);
		}
	}
}
//XV̎ނ擾
int TaskManager::GetUpdateType() const{
	return(m_UpdateData.Type);
}
//XVp^[ݒ
void TaskManager::SetUpdateParam(const UpdateParam& Parameter){
	m_UpdateData = Parameter;
}

//sie`Oj
void TaskManager::ExecuteEffect1(){
	if(m_EffectData.Type==EFFECTTYPE_NONE){
		return;
	}
	if(PEffect1.find(m_EffectData.Type)!=PEffect1.end()){
		PEffect1.find(m_EffectData.Type)->second(Outer);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "sȌʃp^[łIie`Ojim_EffectData.Type=%dj", m_EffectData.Type);
	}
}
//sie`ieLXgEChE`Ojj
void TaskManager::ExecuteEffect2(){
	if(m_EffectData.Type==EFFECTTYPE_NONE){
		return;
	}
	if(PEffect2.find(m_EffectData.Type)!=PEffect2.end()){
		PEffect2.find(m_EffectData.Type)->second(Outer);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "sȌʃp^[łIie`ieLXgEChE`Ojjim_EffectData.Type=%dj", m_EffectData.Type);
	}
}
//sie`ieLXgEChE`jj
void TaskManager::ExecuteEffect3(){
	if(m_EffectData.Type==EFFECTTYPE_NONE){
		return;
	}
	if(PEffect3.find(m_EffectData.Type)!=PEffect3.end()){
		PEffect3.find(m_EffectData.Type)->second(Outer);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "sȌʃp^[łIie`ieLXgEChE`jjim_EffectData.Type=%dj", m_EffectData.Type);
	}
}
//ʂ̎ނ擾
int TaskManager::GetEffectType() const{
	return(m_EffectData.Type);
}
//ʃp^[ݒ
void TaskManager::SetEffectParam(const EffectParam& Parameter){
	m_EffectData = Parameter;
}

//ۑi[Jj
void TaskManager::SaveL(IIOStream* IOStream){
	SaveTemplate(IOStream, m_MaxZ);
	SaveTemplate(IOStream, m_MinZ);
	SaveTemplate(IOStream, m_RZBG);
	SaveTemplate(IOStream, m_RZCh1);
	SaveTemplate(IOStream, m_RZCh2);
	SaveTemplate(IOStream, m_RZCh3);
	SaveTemplate(IOStream, static_cast<int>(m_TaskList.size()));
	for(vector<DrawTask>::iterator it=m_TaskList.begin();it!=m_TaskList.end();it++){
		IOStream->SaveDrawTask(*it);
	}

	IOStream->SaveSprite(m_BG);
	IOStream->SaveSprite(m_LCh);
	IOStream->SaveSprite(m_CCh);
	IOStream->SaveSprite(m_RCh);

	SaveTemplate(IOStream, static_cast<int>(m_Sprite.size()));
	for(map<string, Sprite>::iterator it=m_Sprite.begin();it!=m_Sprite.end();it++){
		SaveStringS(IOStream, it->first);
		IOStream->SaveSprite(it->second);
	}

	SaveTemplate(IOStream, static_cast<int>(m_Button.size()));
	for(map<string, Button>::iterator it=m_Button.begin();it!=m_Button.end();it++){
		SaveStringS(IOStream, it->first);
		IOStream->SaveButton(it->second);
	}

	SaveTemplate(IOStream, m_CharaSpace);
	SaveTemplate(IOStream, m_ChPriority[0]);
	SaveTemplate(IOStream, m_ChPriority[1]);
	SaveTemplate(IOStream, m_DrawTaskIterator);
	
	IOStream->SaveUpdateParam(m_UpdateData);
	IOStream->SaveEffectParam(m_EffectData);
}
//ǂݍ݁i[Jj
void TaskManager::LoadL(IIOStream* IOStream){
	int Loop;

	Initialize();

	LoadTemplate(IOStream, &m_MaxZ);
	LoadTemplate(IOStream, &m_MinZ);
	LoadTemplate(IOStream, &m_RZBG);
	LoadTemplate(IOStream, &m_RZCh1);
	LoadTemplate(IOStream, &m_RZCh2);
	LoadTemplate(IOStream, &m_RZCh3);
	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		m_TaskList.push_back(DrawTask());
		IOStream->LoadDrawTask(&m_TaskList.back());
		Outer->GetDraw()->LoadImage(m_TaskList.back().FileName.c_str());
	}

	IOStream->LoadSprite(&m_BG);
	IOStream->LoadSprite(&m_LCh);
	IOStream->LoadSprite(&m_CCh);
	IOStream->LoadSprite(&m_RCh);
	Outer->GetDraw()->LoadImage(m_BG.SpriteTask[0].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_BG.SpriteTask[1].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_LCh.SpriteTask[0].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_LCh.SpriteTask[1].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_CCh.SpriteTask[0].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_CCh.SpriteTask[1].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_RCh.SpriteTask[0].FileName.c_str());
	Outer->GetDraw()->LoadImage(m_RCh.SpriteTask[1].FileName.c_str());

	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		string strData;
		Sprite sprData;
		LoadStringS(IOStream, &strData);
		IOStream->LoadSprite(&sprData);
		m_Sprite.insert(pair<string, Sprite>(strData, sprData));
		Outer->GetSymbolName()->Set(strData.c_str(), SY_SPRITE);
		Outer->GetDraw()->LoadImage(sprData.SpriteTask[0].FileName.c_str());
		Outer->GetDraw()->LoadImage(sprData.SpriteTask[1].FileName.c_str());
	}

	LoadTemplate(IOStream, &Loop);
	for(int i=0;i<Loop;i++){
		string strData;
		Button btnData;
		LoadStringS(IOStream, &strData);
		IOStream->LoadButton(&btnData);
		m_Button.insert(pair<string, Button>(strData, btnData));
		Outer->GetSymbolName()->Set(strData.c_str(), SY_BUTTON);
		Outer->GetDraw()->LoadImage(btnData.ButtonTask.SpriteTask[0].FileName.c_str());
		Outer->GetDraw()->LoadImage(btnData.ButtonTask.SpriteTask[1].FileName.c_str());
	}

	LoadTemplate(IOStream, &m_CharaSpace);
	LoadTemplate(IOStream, &m_ChPriority[0]);
	LoadTemplate(IOStream, &m_ChPriority[1]);
	LoadTemplate(IOStream, &m_DrawTaskIterator);

	IOStream->LoadUpdateParam(&m_UpdateData);
	IOStream->LoadEffectParam(&m_EffectData);
}
//`^XNXg擾(1)
vector<DrawTask>& TaskManager::GetTaskList(){
	return(m_TaskList);
}
//`^XNXg擾(2)
const vector<DrawTask>& TaskManager::GetTaskList() const{
	return(m_TaskList);
}
//SEgpĂ邩H
bool TaskManager::IsUsedSE(const char* FileName) const{
	for(map<string, Button>::const_iterator it=m_Button.begin();it!=m_Button.end();it++){
		if(it->second.OnClickSE==FileName || it->second.OnCursorSE==FileName){
			return(true);
		}
	}
	return(false);
}
//摜gpĂ邩H
bool TaskManager::IsUsedImage(const char* FileName) const{
	for(vector<DrawTask>::const_iterator it=m_TaskList.begin();it!=m_TaskList.end();it++){
		if(it->FileName==FileName){
			return(true);
		}
	}
	for(unsigned int i=0;i<2;i++){
		if(	m_BG.SpriteTask[i].FileName==FileName ||
			m_LCh.SpriteTask[i].FileName==FileName ||
			m_CCh.SpriteTask[i].FileName==FileName ||
			m_RCh.SpriteTask[i].FileName==FileName ){
			return(true);
		}
	}
	for(map<string, Sprite>::const_iterator it=m_Sprite.begin();it!=m_Sprite.end();it++){
		for(unsigned int i=0;i<2;i++){
			if(it->second.SpriteTask[i].FileName==FileName){
				return(true);
			}
		}
	}
	for(map<string, Button>::const_iterator it=m_Button.begin();it!=m_Button.end();it++){
		for(unsigned int i=0;i<2;i++){
			if(it->second.ButtonTask.SpriteTask[i].FileName==FileName){
				return(true);
			}
		}
	}
	return(false);
}



//eGWݒ
void TMAccessor::SetParent(INovelEngine* Parent){
	Outer = Parent;
}

//`^XNXg
void TMAccessor::ClearTaskList(){
	GETTASK()->GetTaskList().clear();
}
//`^XNXgZ\[g
void TMAccessor::ZSortTaskList(){
	//֐pNX
	class InnerFunction{
	public:
		//Z\[gpr֐
		static bool Compare(const DrawTask& D1, const DrawTask& D2){
			//zŔrij
			if(D1.z!=D2.z){
				return(D1.z<D2.z);
			}
			//zȂAzzŔrij
			if(D1.zz!=D2.zz){
				return(D1.zz<D2.zz);
			}
			//zzzȂAaŔri~j
			return(D1.a>D2.a);
		}
	};
	sort<vector<DrawTask>::iterator>(GETTASK()->m_TaskList.begin(), GETTASK()->m_TaskList.end(), InnerFunction::Compare);
}
//`^XNXg𕡎
void TMAccessor::DuplicateTaskList(){
	unsigned int DTI = GetDrawTaskIterator();
	GETTASK()->m_BG.SpriteTask[1-DTI] = GETTASK()->m_BG.SpriteTask[DTI];
	GETTASK()->m_LCh.SpriteTask[1-DTI] = GETTASK()->m_LCh.SpriteTask[DTI];
	GETTASK()->m_CCh.SpriteTask[1-DTI] = GETTASK()->m_CCh.SpriteTask[DTI];
	GETTASK()->m_RCh.SpriteTask[1-DTI] = GETTASK()->m_RCh.SpriteTask[DTI];
	for(map<string, Sprite>::iterator it=GETTASK()->m_Sprite.begin();it!=GETTASK()->m_Sprite.end();it++){
		it->second.SpriteTask[1-DTI] = it->second.SpriteTask[DTI];
	}
	for(map<string, Button>::iterator it=GETTASK()->m_Button.begin();it!=GETTASK()->m_Button.end();it++){
		for(unsigned int i=0;i<4;i++){
			it->second.SrcRect[1-DTI][i] = it->second.SrcRect[DTI][i];
		}
		it->second.ButtonTask.SpriteTask[1-DTI] = it->second.ButtonTask.SpriteTask[DTI];
	}
	GETTASK()->m_ChPriority[1-DTI] = GETTASK()->m_ChPriority[DTI];
}
//`^XNǉ
void TMAccessor::PushTaskList(const DrawTask& PushTask){
	switch(PushTask.Type){
		case(TYPE_NONE):
			break;
		case(TYPE_RECT):
			if(PushTask.a>0 && PushTask.IsShow && IsValidRect(PushTask.RectPos)){
				GETTASK()->GetTaskList().push_back(PushTask);
			}
			break;
		case(TYPE_TEXT):
			if(PushTask.a>0 && PushTask.IsShow && !PushTask.Text.empty()){
				GETTASK()->GetTaskList().push_back(PushTask);
			}
			break;
		case(TYPE_GRAPHIC):
			if(PushTask.a>0 && PushTask.IsShow && PushTask.FileName!=""){
				GETTASK()->GetTaskList().push_back(PushTask);
			}
			break;
		default:
			if(PAddDrawTaskFunc.find(PushTask.Type)!=PAddDrawTaskFunc.end()){
				PAddDrawTaskFunc.find(PushTask.Type)->second(Outer, PushTask);
			}
			else{
				RuntimeError(NULL, "TMAccessor::PushTaskList(const DrawTask& PushTask)");
			}
	}
}
//`^XNǉij
void TMAccessor::PushTaskListIM(const DrawTask& PushTask){
	GETTASK()->GetTaskList().push_back(PushTask);
}
//`^XN擾/ݒ
void TMAccessor::GetTaskList(unsigned int& Num, DrawTask* _DrawTask[]){
	unsigned int i=0;
	Num = static_cast<unsigned int>(GETTASK()->GetTaskList().size());
	for(vector<DrawTask>::iterator it=GETTASK()->GetTaskList().begin();it!=GETTASK()->GetTaskList().end();it++){
		_DrawTask[i++] = &(*it);
	}
}

//wi擾
Sprite& TMAccessor::GetBG(){
	return(GETTASK()->m_BG);
}
//G擾
Sprite& TMAccessor::GetLCh(){
	return(GETTASK()->m_LCh);
}
//G擾
Sprite& TMAccessor::GetCCh(){
	return(GETTASK()->m_CCh);
}
//EG擾
Sprite& TMAccessor::GetRCh(){
	return(GETTASK()->m_RCh);
}

//XvCg擾(1)
Sprite& TMAccessor::GetSprite(const char* SpriteName){
	if(GETTASK()->m_Sprite.find(SpriteName)!=GETTASK()->m_Sprite.end()){
		return(GETTASK()->m_Sprite.find(SpriteName)->second);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "TMAccessor::GetSprite(const char* SpriteName)");
	}
}
//XvCg擾(2)
void TMAccessor::GetSprite(unsigned int& Num, Sprite* _Sprite[]){
	unsigned int i=0;
	Num = static_cast<unsigned int>(GETTASK()->m_Sprite.size());
	for(map<string, Sprite>::iterator it=GETTASK()->m_Sprite.begin();it!=GETTASK()->m_Sprite.end();it++){
		_Sprite[i++] = &(it->second);
	}
}

//{^擾(1)
Button& TMAccessor::GetButton(const char* ButtonName){
	if(GETTASK()->m_Button.find(ButtonName)!=GETTASK()->m_Button.end()){
		return(GETTASK()->m_Button.find(ButtonName)->second);
	}
	else{
		RuntimeError(Outer->GetMyAppHWND(), "TMAccessor::GetButton(const char* ButtonName)");
	}
}
//{^擾(2)
void TMAccessor::GetButton(unsigned int& Num, Button* _Button[]){
	unsigned int i=0;
	Num = static_cast<unsigned int>(GETTASK()->m_Button.size());
	for(map<string, Button>::iterator it=GETTASK()->m_Button.begin();it!=GETTASK()->m_Button.end();it++){
		_Button[i++] = &(it->second);
	}
}

//G̕\ʒuݒ
void TMAccessor::SetChLocation(){
	for(unsigned int i=0;i<2;i++){
		GETTASK()->m_LCh.SpriteTask[i].x = GETTASK()->m_CharaSpace;
		GETTASK()->m_LCh.SpriteTask[i].y = static_cast<int>(Outer->GetDraw()->GetScreenHeight() - ((GETTASK()->m_LCh.SpriteTask[i].SrcRect.bottom - GETTASK()->m_LCh.SpriteTask[i].SrcRect.top) * GETTASK()->m_LCh.SpriteTask[i].ScalingY));
		GETTASK()->m_CCh.SpriteTask[i].x = static_cast<int>((Outer->GetDraw()->GetScreenWidth() - ((GETTASK()->m_CCh.SpriteTask[i].SrcRect.right - GETTASK()->m_CCh.SpriteTask[i].SrcRect.left) * GETTASK()->m_CCh.SpriteTask[i].ScalingX)) / 2);
		GETTASK()->m_CCh.SpriteTask[i].y = static_cast<int>(Outer->GetDraw()->GetScreenHeight() - ((GETTASK()->m_CCh.SpriteTask[i].SrcRect.bottom - GETTASK()->m_CCh.SpriteTask[i].SrcRect.top) * GETTASK()->m_CCh.SpriteTask[i].ScalingY));
		GETTASK()->m_RCh.SpriteTask[i].x = static_cast<int>(Outer->GetDraw()->GetScreenWidth() - GETTASK()->m_CharaSpace - ((GETTASK()->m_RCh.SpriteTask[i].SrcRect.right - GETTASK()->m_RCh.SpriteTask[i].SrcRect.left) * GETTASK()->m_RCh.SpriteTask[i].ScalingX));
		GETTASK()->m_RCh.SpriteTask[i].y = static_cast<int>(Outer->GetDraw()->GetScreenHeight() - ((GETTASK()->m_RCh.SpriteTask[i].SrcRect.bottom - GETTASK()->m_RCh.SpriteTask[i].SrcRect.top) * GETTASK()->m_RCh.SpriteTask[i].ScalingY));

		GETTASK()->m_BG.SpriteTask[i].z = GETTASK()->m_RZBG;
		switch(GETTASK()->m_ChPriority[GetDrawTaskIterator()]){
			case(CHPRIORITY_LCR):
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
			case(CHPRIORITY_LRC):
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
			case(CHPRIORITY_CLR):
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
			case(CHPRIORITY_CRL):
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
			case(CHPRIORITY_RCL):
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
			case(CHPRIORITY_RLC):
				GETTASK()->m_RCh.SpriteTask[i].z = GETTASK()->m_RZCh1;
				GETTASK()->m_LCh.SpriteTask[i].z = GETTASK()->m_RZCh2;
				GETTASK()->m_CCh.SpriteTask[i].z = GETTASK()->m_RZCh3;
				break;
		}
	}
}

//`^XÑCe[^ؑ
void TMAccessor::SwitchDrawTaskIterator(){
	GETTASK()->m_DrawTaskIterator = 1 - GETTASK()->m_DrawTaskIterator;
}
//`^XÑCe[^擾
unsigned int TMAccessor::GetDrawTaskIterator(){
	return(GETTASK()->m_DrawTaskIterator);
}

//ʃp^[擾/ݒ
EffectParam& TMAccessor::GetEffectParam(){
	return(GETTASK()->m_EffectData);
}

//XVp^[擾/ݒ
UpdateParam& TMAccessor::GetUpdateParam(){
	return(GETTASK()->m_UpdateData);
}

//Sԕϐ
void TMAccessor::InitStateVar(){
	ZeroMemory(GETTASK()->UpdateI, sizeof(GETTASK()->UpdateI));
	ZeroMemory(GETTASK()->UpdateBy, sizeof(GETTASK()->UpdateBy));
	ZeroMemory(GETTASK()->UpdateDw, sizeof(GETTASK()->UpdateDw));
	ZeroMemory(GETTASK()->UpdateD, sizeof(GETTASK()->UpdateD));
	GETTASK()->UpdateS[0] = "";	GETTASK()->UpdateS[1] = "";	GETTASK()->UpdateS[2] = "";	GETTASK()->UpdateS[3] = "";
	ZeroMemory(GETTASK()->UpdateC, sizeof(GETTASK()->UpdateC));
	ZeroMemory(GETTASK()->EffectI, sizeof(GETTASK()->EffectI));
	ZeroMemory(GETTASK()->EffectBy, sizeof(GETTASK()->EffectBy));
	ZeroMemory(GETTASK()->EffectDw, sizeof(GETTASK()->EffectDw));
	ZeroMemory(GETTASK()->EffectD, sizeof(GETTASK()->EffectD));
	GETTASK()->EffectS[0] = "";	GETTASK()->EffectS[1] = "";	GETTASK()->EffectS[2] = "";	GETTASK()->EffectS[3] = "";
	ZeroMemory(GETTASK()->EffectC, sizeof(GETTASK()->EffectC));
}

//ԕϐiʍXVpj擾/ݒ
int& TMAccessor::GetUpdateI(unsigned int Num){
	return(GETTASK()->UpdateI[Num]);
}
BYTE& TMAccessor::GetUpdateBy(unsigned int Num){
	return(GETTASK()->UpdateBy[Num]);
}
mystr& TMAccessor::GetUpdateS(unsigned int Num){
	return(GETTASK()->UpdateS[Num]);
}
DWORD& TMAccessor::GetUpdateDw(unsigned int Num){
	return(GETTASK()->UpdateDw[Num]);
}
double& TMAccessor::GetUpdateD(unsigned int Num){
	return(GETTASK()->UpdateD[Num]);
}
COLORREF& TMAccessor::GetUpdateC(unsigned int Num){
	return(GETTASK()->UpdateC[Num]);
}

//ԕϐiʌʗpj擾/ݒ
int& TMAccessor::GetEffectI(unsigned int Num){
	return(GETTASK()->EffectI[Num]);
}
BYTE& TMAccessor::GetEffectBy(unsigned int Num){
	return(GETTASK()->EffectBy[Num]);
}
mystr& TMAccessor::GetEffectS(unsigned int Num){
	return(GETTASK()->EffectS[Num]);
}
DWORD& TMAccessor::GetEffectDw(unsigned int Num){
	return(GETTASK()->EffectDw[Num]);
}
double& TMAccessor::GetEffectD(unsigned int Num){
	return(GETTASK()->EffectD[Num]);
}
COLORREF& TMAccessor::GetEffectC(unsigned int Num){
	return(GETTASK()->EffectC[Num]);
}



#ifdef __cplusplus
extern "C"{
#endif

//ANZbT
static TMAccessor AbyssLibSingletonTMAccessor;
//ANZbT擾
__declspec(dllexport) ITMAccessor* GetTMAccessor(){
	return(&AbyssLibSingletonTMAccessor);
}
//ANZbTݒ
__declspec(dllexport) void SetTMAccessor(INovelEngine* Parent){
	AbyssLibSingletonTMAccessor.SetParent(Parent);
}

#ifdef __cplusplus
}
#endif

}
}